(set-info :smt-lib-version 2.6)
(set-logic UFDTLIA)
(set-info :source |
Generated by: Bernhard Gleiss
Generated on: 2019-3-11
Generator: Rapid
Application: Software Verification
Target solver: Vampire
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "crafted")
(set-info :status unknown)

(declare-datatypes ((Nat 0)) (( (zero) (s (p Nat)) )) )
(declare-sort Time 0)
(declare-sort Trace 0)
(declare-const main_end Time)
(declare-const l36 Time)
(declare-const l32_lEnd Time)
(declare-const l32 Time)
(declare-const l25_rEnd Time)
(declare-const l25_lEnd Time)
(declare-fun l18 (Nat) Time)
(declare-fun l17_lEnd (Nat) Time)
(declare-fun nl14 (Trace) Nat)
(declare-fun l21 (Nat) Time)
(declare-fun l17_rEnd (Nat) Time)
(declare-fun hammingWeight (Time Trace) Int)
(declare-fun x (Trace) Int)
(declare-const l26 Time)
(declare-fun alength (Trace) Int)
(declare-const t1 Trace)
(declare-const l32_rEnd Time)
(declare-fun l17 (Nat) Time)
(declare-const t2 Trace)
(declare-const l11 Time)
(declare-fun l16 (Nat) Time)
(declare-fun a (Int Trace) Int)
(declare-const l12 Time)
(declare-fun l14 (Nat) Time)
(declare-fun i (Time Trace) Int)
(declare-fun y (Trace) Int)
(declare-fun Sub (Nat Nat) Bool)
(assert (forall ((it Nat)) (Sub it (s it))) )
(assert (forall ((it1 Nat)(it2 Nat)) (=> (Sub it1 it2) (Sub it1 (s it2))) ))
(declare-const l25 Time)
(declare-const l33 Time)
(declare-const l29 Time)

(assert
   ;Semantics of function main
   (and
      (forall ((tr Trace))
         ;Update variable i at location l11
         (= (i l12 tr) 0)
      )
      (forall ((tr Trace))
         ;Update variable hammingWeight at location l12
         (and
            (= (hammingWeight (l14 zero) tr) 0)
            (= (i (l14 zero) tr) (i l12 tr))
         )
      )
      (forall ((tr Trace))
         ;Loop at location l14
         (and
            ;Jumping into the body doesn't change the variable values
            (forall ((Itl14 Nat))
               (and
                  (= (hammingWeight (l16 Itl14) tr) (hammingWeight (l14 Itl14) tr))
                  (= (i (l16 Itl14) tr) (i (l14 Itl14) tr))
               )
            )
            ;Semantics of the body
            (forall ((Itl14 Nat))
               (and
                  ;Update variable i at location l16
                  (and
                     (= (i (l17 Itl14) tr) (+ (i (l16 Itl14) tr) 1))
                     (= (hammingWeight (l17 Itl14) tr) (hammingWeight (l16 Itl14) tr))
                  )
                  ;Semantics of IfElse at location l17
                  (and
                     ;Jumping into any branch doesn't change the variable values
                     (and
                        (= (hammingWeight (l18 Itl14) tr) (hammingWeight (l17 Itl14) tr))
                        (= (i (l18 Itl14) tr) (i (l17 Itl14) tr))
                        (= (hammingWeight (l21 Itl14) tr) (hammingWeight (l17 Itl14) tr))
                        (= (i (l21 Itl14) tr) (i (l17 Itl14) tr))
                     )
                     ;The branching-condition determines which values to use after the if-statement
                     (and
                        (=>
                           (not
                              (= (a (i (l17 Itl14) tr) tr) 0)
                           )
                           (= (i (l14 (s Itl14)) tr) (i (l17_lEnd Itl14) tr))
                        )
                        (=>
                           (not
                              (= (a (i (l17 Itl14) tr) tr) 0)
                           )
                           (= (hammingWeight (l14 (s Itl14)) tr) (hammingWeight (l17_lEnd Itl14) tr))
                        )
                        (=>
                           (not
                              (not
                                 (= (a (i (l17 Itl14) tr) tr) 0)
                              )
                           )
                           (= (i (l14 (s Itl14)) tr) (i (l17_rEnd Itl14) tr))
                        )
                        (=>
                           (not
                              (not
                                 (= (a (i (l17 Itl14) tr) tr) 0)
                              )
                           )
                           (= (hammingWeight (l14 (s Itl14)) tr) (hammingWeight (l17_rEnd Itl14) tr))
                        )
                     )
                     ;Update variable hammingWeight at location l18
                     (and
                        (= (hammingWeight (l17_lEnd Itl14) tr) (+ (hammingWeight (l18 Itl14) tr) 1))
                        (= (i (l17_lEnd Itl14) tr) (i (l18 Itl14) tr))
                     )
                     ;Ignore any skip statement
                     (= (l21 Itl14) (l17_rEnd Itl14))
                  )
               )
            )
            ;The loop-condition holds always before the last iteration
            (forall ((Itl14 Nat))
               (=>
                  (Sub Itl14 (nl14 tr))
                  (< (i (l14 Itl14) tr) (alength tr))
               )
            )
            ;The loop-condition doesn't hold in the last iteration
            (not
               (< (i (l14 (nl14 tr)) tr) (alength tr))
            )
            ;The values after the while-loop are the values from the last iteration
            (and
               (= (hammingWeight l25 tr) (hammingWeight (l14 (nl14 tr)) tr))
               (= (i l25 tr) (i (l14 (nl14 tr)) tr))
            )
         )
      )
      (forall ((tr Trace))
         ;Semantics of IfElse at location l25
         (and
            ;Jumping into any branch doesn't change the variable values
            (and
               (= (hammingWeight l26 tr) (hammingWeight l25 tr))
               (= (i l26 tr) (i l25 tr))
               (= (hammingWeight l29 tr) (hammingWeight l25 tr))
               (= (i l29 tr) (i l25 tr))
            )
            ;The branching-condition determines which values to use after the if-statement
            (and
               (=>
                  (not
                     (= (x tr) 0)
                  )
                  (= (i l32 tr) (i l25_lEnd tr))
               )
               (=>
                  (not
                     (= (x tr) 0)
                  )
                  (= (hammingWeight l32 tr) (hammingWeight l25_lEnd tr))
               )
               (=>
                  (not
                     (not
                        (= (x tr) 0)
                     )
                  )
                  (= (i l32 tr) (i l25_rEnd tr))
               )
               (=>
                  (not
                     (not
                        (= (x tr) 0)
                     )
                  )
                  (= (hammingWeight l32 tr) (hammingWeight l25_rEnd tr))
               )
            )
            ;Update variable hammingWeight at location l26
            (and
               (= (hammingWeight l25_lEnd tr) (+ (hammingWeight l26 tr) 1))
               (= (i l25_lEnd tr) (i l26 tr))
            )
            ;Ignore any skip statement
            (= l29 l25_rEnd)
         )
      )
      (forall ((tr Trace))
         ;Semantics of IfElse at location l32
         (and
            ;Jumping into any branch doesn't change the variable values
            (and
               (= (hammingWeight l33 tr) (hammingWeight l32 tr))
               (= (i l33 tr) (i l32 tr))
               (= (hammingWeight l36 tr) (hammingWeight l32 tr))
               (= (i l36 tr) (i l32 tr))
            )
            ;The branching-condition determines which values to use after the if-statement
            (and
               (=>
                  (not
                     (= (y tr) 0)
                  )
                  (= (i main_end tr) (i l32_lEnd tr))
               )
               (=>
                  (not
                     (= (y tr) 0)
                  )
                  (= (hammingWeight main_end tr) (hammingWeight l32_lEnd tr))
               )
               (=>
                  (not
                     (not
                        (= (y tr) 0)
                     )
                  )
                  (= (i main_end tr) (i l32_rEnd tr))
               )
               (=>
                  (not
                     (not
                        (= (y tr) 0)
                     )
                  )
                  (= (hammingWeight main_end tr) (hammingWeight l32_rEnd tr))
               )
            )
            ;Update variable hammingWeight at location l33
            (and
               (= (hammingWeight l32_lEnd tr) (+ (hammingWeight l33 tr) 1))
               (= (i l32_lEnd tr) (i l33 tr))
            )
            ;Ignore any skip statement
            (= l36 l32_rEnd)
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var hammingWeight and location l14
      (=>
         (forall ((Itl14 Nat))
            (=>
               (Sub Itl14 (nl14 tr))
               (= (hammingWeight (l14 Itl14) tr) (hammingWeight (l14 (s Itl14)) tr))
            )
         )
         (= (hammingWeight (l14 zero) tr) (hammingWeight (l14 (nl14 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var i and location l14
      (=>
         (forall ((Itl14 Nat))
            (=>
               (Sub Itl14 (nl14 tr))
               (= (i (l14 Itl14) tr) (i (l14 (s Itl14)) tr))
            )
         )
         (= (i (l14 zero) tr) (i (l14 (nl14 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: if the condition of the loop at l14 holds initially, there is at least one loop iteration
      (=>
         (< (i (l14 zero) tr) (alength tr))
         (exists ((Itl14 Nat))
            (= (s Itl14) (nl14 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var hammingWeight at location l14
      (forall ((xInt Int)(Itl14 Nat))
         (=>
            (and
               (<= (hammingWeight (l14 zero) tr) xInt)
               (< xInt (hammingWeight (l14 (nl14 tr)) tr))
               (= (hammingWeight (l14 (s Itl14)) tr) (+ (hammingWeight (l14 Itl14) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (hammingWeight (l14 it) tr) xInt)
                  (Sub it (nl14 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var i at location l14
      (forall ((xInt Int)(Itl14 Nat))
         (=>
            (and
               (<= (i (l14 zero) tr) xInt)
               (< xInt (i (l14 (nl14 tr)) tr))
               (= (i (l14 (s Itl14)) tr) (+ (i (l14 Itl14) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (i (l14 it) tr) xInt)
                  (Sub it (nl14 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl14 Nat))
         (=>
            (and
               (Sub (s Itl14) (nl14 tr))
               (= (hammingWeight (l14 (s Itl14)) tr) (+ (hammingWeight (l14 Itl14) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (hammingWeight (l14 it1) tr) (hammingWeight (l14 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl14 Nat))
         (=>
            (and
               (Sub (s Itl14) (nl14 tr))
               (= (i (l14 (s Itl14)) tr) (+ (i (l14 Itl14) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (i (l14 it1) tr) (i (l14 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   ;Lemma: Var hammingWeight at loop l14 has same values on both traces
   (=>
      (and
         (= (hammingWeight (l14 zero) t1) (hammingWeight (l14 zero) t2))
         (forall ((Itl14 Nat))
            (=>
               (= (hammingWeight (l14 Itl14) t1) (hammingWeight (l14 Itl14) t2))
               (= (hammingWeight (l14 (s Itl14)) t1) (hammingWeight (l14 (s Itl14)) t2))
            )
         )
      )
      (forall ((Itl14 Nat))
         (= (hammingWeight (l14 Itl14) t1) (hammingWeight (l14 Itl14) t2))
      )
   )
)

(assert
   ;Lemma: Var i at loop l14 has same values on both traces
   (=>
      (and
         (= (i (l14 zero) t1) (i (l14 zero) t2))
         (forall ((Itl14 Nat))
            (=>
               (= (i (l14 Itl14) t1) (i (l14 Itl14) t2))
               (= (i (l14 (s Itl14)) t1) (i (l14 (s Itl14)) t2))
            )
         )
      )
      (forall ((Itl14 Nat))
         (= (i (l14 Itl14) t1) (i (l14 Itl14) t2))
      )
   )
)

(assert
   ;Lemma: If nl14(t2) has same properties as nl14(t1), then nl14(t2)=nl14(t1) (for loop at l14)
   (=>
      (and
         (forall ((Itl14 Nat))
            (=>
               (Sub Itl14 (nl14 t2))
               (< (i (l14 Itl14) t1) (alength t1))
            )
         )
         (not
            (< (i (l14 (nl14 t2)) t1) (alength t1))
         )
      )
      (= (nl14 t2) (nl14 t1))
   )
)

(assert
   ;Lemma: Equality preservation over traces for var hammingWeight at location l14
   (forall ((itR Nat))
      (=>
         (and
            (= (hammingWeight (l14 zero) t1) (hammingWeight (l14 zero) t2))
            (forall ((Itl14 Nat))
               (=>
                  (and
                     (Sub Itl14 itR)
                     (= (hammingWeight (l14 Itl14) t1) (hammingWeight (l14 Itl14) t2))
                  )
                  (= (hammingWeight (l14 (s Itl14)) t1) (hammingWeight (l14 (s Itl14)) t2))
               )
            )
         )
         (= (hammingWeight (l14 itR) t1) (hammingWeight (l14 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l14
   (forall ((itR Nat))
      (=>
         (and
            (= (i (l14 zero) t1) (i (l14 zero) t2))
            (forall ((Itl14 Nat))
               (=>
                  (and
                     (Sub Itl14 itR)
                     (= (i (l14 Itl14) t1) (i (l14 Itl14) t2))
                  )
                  (= (i (l14 (s Itl14)) t1) (i (l14 (s Itl14)) t2))
               )
            )
         )
         (= (i (l14 itR) t1) (i (l14 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var hammingWeight at location l14
   (forall ((itL Nat))
      (=>
         (and
            (= (hammingWeight (l14 itL) t1) (hammingWeight (l14 itL) t2))
            (forall ((Itl14 Nat))
               (=>
                  (and
                     (Sub itL (s Itl14))
                     (Sub Itl14 (nl14 t1))
                     (= (hammingWeight (l14 Itl14) t1) (hammingWeight (l14 Itl14) t2))
                  )
                  (= (hammingWeight (l14 (s Itl14)) t1) (hammingWeight (l14 (s Itl14)) t2))
               )
            )
            (= (l14 (nl14 t1)) (l14 (nl14 t2)))
         )
         (= (hammingWeight (l14 (nl14 t1)) t1) (hammingWeight (l14 (nl14 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l14
   (forall ((itL Nat))
      (=>
         (and
            (= (i (l14 itL) t1) (i (l14 itL) t2))
            (forall ((Itl14 Nat))
               (=>
                  (and
                     (Sub itL (s Itl14))
                     (Sub Itl14 (nl14 t1))
                     (= (i (l14 Itl14) t1) (i (l14 Itl14) t2))
                  )
                  (= (i (l14 (s Itl14)) t1) (i (l14 (s Itl14)) t2))
               )
            )
            (= (l14 (nl14 t1)) (l14 (nl14 t2)))
         )
         (= (i (l14 (nl14 t1)) t1) (i (l14 (nl14 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var hammingWeight at location l14
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (hammingWeight (l14 zero) t1) (hammingWeight (l14 zero) t2))
            (forall ((tr3 Trace)(Itl14 Nat))
               (= (hammingWeight (l14 (s Itl14)) tr3) (+ (hammingWeight (l14 Itl14) tr3) 1))
            )
         )
         (< (hammingWeight (l14 it1) tr) (hammingWeight (l14 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var i at location l14
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (i (l14 zero) t1) (i (l14 zero) t2))
            (forall ((tr3 Trace)(Itl14 Nat))
               (= (i (l14 (s Itl14)) tr3) (+ (i (l14 Itl14) tr3) 1))
            )
         )
         (< (i (l14 it1) tr) (i (l14 it2) tr))
      )
   )
)

(assert
   ;Theory axiom: forall x y z. (x + y) + z) = (x + z) + y
   (forall ((xInt Int)(yInt Int)(zInt Int))
      (= (+ (+ xInt yInt) zInt) (+ (+ xInt zInt) yInt))
   )
)

; negated conjecture
(assert
   (not
      (=>
         (and
            (forall ((j Int))
               (= (a j t1) (a j t2))
            )
            (= (x t1) (y t2))
            (= (y t1) (x t2))
            (= (alength t1) (alength t2))
         )
         (= (hammingWeight main_end t1) (hammingWeight main_end t2))
      )
   )
)

(check-sat)

(exit)
