(set-info :smt-lib-version 2.6)
(set-logic UFDTLIA)
(set-info :source |
Generated by: Bernhard Gleiss
Generated on: 2019-3-11
Generator: Rapid
Application: Software Verification
Target solver: Vampire
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "crafted")
(set-info :status unknown)

(declare-datatypes ((Nat 0)) (( (zero) (s (p Nat)) )) )
(declare-sort Time 0)
(declare-sort Trace 0)
(declare-fun l49 (Nat) Time)
(declare-fun l46 (Nat) Time)
(declare-fun l45_lEnd (Nat) Time)
(declare-fun l45 (Nat) Time)
(declare-fun l42 (Nat) Time)
(declare-const l35 Time)
(declare-const l34_rEnd Time)
(declare-fun l44 (Nat) Time)
(declare-const l34_lEnd Time)
(declare-const l34 Time)
(declare-const l31 Time)
(declare-const l28 Time)
(declare-const l27_rEnd Time)
(declare-fun l18 (Nat) Time)
(declare-const l27_lEnd Time)
(declare-fun l23 (Nat) Time)
(declare-fun l20 (Nat) Time)
(declare-fun l19_rEnd (Nat) Time)
(declare-fun hammingWeight (Time Trace) Int)
(declare-const l14 Time)
(declare-fun i (Time Trace) Int)
(declare-const l38 Time)
(declare-fun nl16 (Trace) Nat)
(declare-const main_end Time)
(declare-fun x (Trace) Int)
(declare-fun b (Int Trace) Int)
(declare-const l27 Time)
(declare-fun alength (Trace) Int)
(declare-const t1 Trace)
(declare-const l41 Time)
(declare-fun l19 (Nat) Time)
(declare-fun l45_rEnd (Nat) Time)
(declare-const t2 Trace)
(declare-fun blength (Trace) Int)
(declare-fun l16 (Nat) Time)
(declare-fun nl42 (Trace) Nat)
(declare-fun a (Int Trace) Int)
(declare-fun l19_lEnd (Nat) Time)
(declare-fun y (Trace) Int)
(declare-fun Sub (Nat Nat) Bool)
(assert (forall ((it Nat)) (Sub it (s it))) )
(assert (forall ((it1 Nat)(it2 Nat)) (=> (Sub it1 it2) (Sub it1 (s it2))) ))
(declare-const l13 Time)

(assert
   ;Semantics of function main
   (and
      (forall ((tr Trace))
         ;Update variable i at location l13
         (= (i l14 tr) 0)
      )
      (forall ((tr Trace))
         ;Update variable hammingWeight at location l14
         (and
            (= (hammingWeight (l16 zero) tr) 0)
            (= (i (l16 zero) tr) (i l14 tr))
         )
      )
      (forall ((tr Trace))
         ;Loop at location l16
         (and
            ;Jumping into the body doesn't change the variable values
            (forall ((Itl16 Nat))
               (and
                  (= (hammingWeight (l18 Itl16) tr) (hammingWeight (l16 Itl16) tr))
                  (= (i (l18 Itl16) tr) (i (l16 Itl16) tr))
               )
            )
            ;Semantics of the body
            (forall ((Itl16 Nat))
               (and
                  ;Update variable i at location l18
                  (and
                     (= (i (l19 Itl16) tr) (+ (i (l18 Itl16) tr) 1))
                     (= (hammingWeight (l19 Itl16) tr) (hammingWeight (l18 Itl16) tr))
                  )
                  ;Semantics of IfElse at location l19
                  (and
                     ;Jumping into any branch doesn't change the variable values
                     (and
                        (= (hammingWeight (l20 Itl16) tr) (hammingWeight (l19 Itl16) tr))
                        (= (i (l20 Itl16) tr) (i (l19 Itl16) tr))
                        (= (hammingWeight (l23 Itl16) tr) (hammingWeight (l19 Itl16) tr))
                        (= (i (l23 Itl16) tr) (i (l19 Itl16) tr))
                     )
                     ;The branching-condition determines which values to use after the if-statement
                     (and
                        (=>
                           (not
                              (= (a (i (l19 Itl16) tr) tr) 0)
                           )
                           (= (i (l16 (s Itl16)) tr) (i (l19_lEnd Itl16) tr))
                        )
                        (=>
                           (not
                              (= (a (i (l19 Itl16) tr) tr) 0)
                           )
                           (= (hammingWeight (l16 (s Itl16)) tr) (hammingWeight (l19_lEnd Itl16) tr))
                        )
                        (=>
                           (not
                              (not
                                 (= (a (i (l19 Itl16) tr) tr) 0)
                              )
                           )
                           (= (i (l16 (s Itl16)) tr) (i (l19_rEnd Itl16) tr))
                        )
                        (=>
                           (not
                              (not
                                 (= (a (i (l19 Itl16) tr) tr) 0)
                              )
                           )
                           (= (hammingWeight (l16 (s Itl16)) tr) (hammingWeight (l19_rEnd Itl16) tr))
                        )
                     )
                     ;Update variable hammingWeight at location l20
                     (and
                        (= (hammingWeight (l19_lEnd Itl16) tr) (+ (hammingWeight (l20 Itl16) tr) 1))
                        (= (i (l19_lEnd Itl16) tr) (i (l20 Itl16) tr))
                     )
                     ;Ignore any skip statement
                     (= (l23 Itl16) (l19_rEnd Itl16))
                  )
               )
            )
            ;The loop-condition holds always before the last iteration
            (forall ((Itl16 Nat))
               (=>
                  (Sub Itl16 (nl16 tr))
                  (< (i (l16 Itl16) tr) (alength tr))
               )
            )
            ;The loop-condition doesn't hold in the last iteration
            (not
               (< (i (l16 (nl16 tr)) tr) (alength tr))
            )
            ;The values after the while-loop are the values from the last iteration
            (and
               (= (hammingWeight l27 tr) (hammingWeight (l16 (nl16 tr)) tr))
               (= (i l27 tr) (i (l16 (nl16 tr)) tr))
            )
         )
      )
      (forall ((tr Trace))
         ;Semantics of IfElse at location l27
         (and
            ;Jumping into any branch doesn't change the variable values
            (and
               (= (hammingWeight l28 tr) (hammingWeight l27 tr))
               (= (i l28 tr) (i l27 tr))
               (= (hammingWeight l31 tr) (hammingWeight l27 tr))
               (= (i l31 tr) (i l27 tr))
            )
            ;The branching-condition determines which values to use after the if-statement
            (and
               (=>
                  (not
                     (= (x tr) 0)
                  )
                  (= (i l34 tr) (i l27_lEnd tr))
               )
               (=>
                  (not
                     (= (x tr) 0)
                  )
                  (= (hammingWeight l34 tr) (hammingWeight l27_lEnd tr))
               )
               (=>
                  (not
                     (not
                        (= (x tr) 0)
                     )
                  )
                  (= (i l34 tr) (i l27_rEnd tr))
               )
               (=>
                  (not
                     (not
                        (= (x tr) 0)
                     )
                  )
                  (= (hammingWeight l34 tr) (hammingWeight l27_rEnd tr))
               )
            )
            ;Update variable hammingWeight at location l28
            (and
               (= (hammingWeight l27_lEnd tr) (+ (hammingWeight l28 tr) 1))
               (= (i l27_lEnd tr) (i l28 tr))
            )
            ;Ignore any skip statement
            (= l31 l27_rEnd)
         )
      )
      (forall ((tr Trace))
         ;Semantics of IfElse at location l34
         (and
            ;Jumping into any branch doesn't change the variable values
            (and
               (= (hammingWeight l35 tr) (hammingWeight l34 tr))
               (= (i l35 tr) (i l34 tr))
               (= (hammingWeight l38 tr) (hammingWeight l34 tr))
               (= (i l38 tr) (i l34 tr))
            )
            ;The branching-condition determines which values to use after the if-statement
            (and
               (=>
                  (not
                     (= (y tr) 0)
                  )
                  (= (i l41 tr) (i l34_lEnd tr))
               )
               (=>
                  (not
                     (= (y tr) 0)
                  )
                  (= (hammingWeight l41 tr) (hammingWeight l34_lEnd tr))
               )
               (=>
                  (not
                     (not
                        (= (y tr) 0)
                     )
                  )
                  (= (i l41 tr) (i l34_rEnd tr))
               )
               (=>
                  (not
                     (not
                        (= (y tr) 0)
                     )
                  )
                  (= (hammingWeight l41 tr) (hammingWeight l34_rEnd tr))
               )
            )
            ;Update variable hammingWeight at location l35
            (and
               (= (hammingWeight l34_lEnd tr) (+ (hammingWeight l35 tr) 1))
               (= (i l34_lEnd tr) (i l35 tr))
            )
            ;Ignore any skip statement
            (= l38 l34_rEnd)
         )
      )
      (forall ((tr Trace))
         ;Update variable i at location l41
         (and
            (= (i (l42 zero) tr) 0)
            (= (hammingWeight (l42 zero) tr) (hammingWeight l41 tr))
         )
      )
      (forall ((tr Trace))
         ;Loop at location l42
         (and
            ;Jumping into the body doesn't change the variable values
            (forall ((Itl42 Nat))
               (and
                  (= (hammingWeight (l44 Itl42) tr) (hammingWeight (l42 Itl42) tr))
                  (= (i (l44 Itl42) tr) (i (l42 Itl42) tr))
               )
            )
            ;Semantics of the body
            (forall ((Itl42 Nat))
               (and
                  ;Update variable i at location l44
                  (and
                     (= (i (l45 Itl42) tr) (+ (i (l44 Itl42) tr) 1))
                     (= (hammingWeight (l45 Itl42) tr) (hammingWeight (l44 Itl42) tr))
                  )
                  ;Semantics of IfElse at location l45
                  (and
                     ;Jumping into any branch doesn't change the variable values
                     (and
                        (= (hammingWeight (l46 Itl42) tr) (hammingWeight (l45 Itl42) tr))
                        (= (i (l46 Itl42) tr) (i (l45 Itl42) tr))
                        (= (hammingWeight (l49 Itl42) tr) (hammingWeight (l45 Itl42) tr))
                        (= (i (l49 Itl42) tr) (i (l45 Itl42) tr))
                     )
                     ;The branching-condition determines which values to use after the if-statement
                     (and
                        (=>
                           (not
                              (= (b (i (l45 Itl42) tr) tr) 0)
                           )
                           (= (i (l42 (s Itl42)) tr) (i (l45_lEnd Itl42) tr))
                        )
                        (=>
                           (not
                              (= (b (i (l45 Itl42) tr) tr) 0)
                           )
                           (= (hammingWeight (l42 (s Itl42)) tr) (hammingWeight (l45_lEnd Itl42) tr))
                        )
                        (=>
                           (not
                              (not
                                 (= (b (i (l45 Itl42) tr) tr) 0)
                              )
                           )
                           (= (i (l42 (s Itl42)) tr) (i (l45_rEnd Itl42) tr))
                        )
                        (=>
                           (not
                              (not
                                 (= (b (i (l45 Itl42) tr) tr) 0)
                              )
                           )
                           (= (hammingWeight (l42 (s Itl42)) tr) (hammingWeight (l45_rEnd Itl42) tr))
                        )
                     )
                     ;Update variable hammingWeight at location l46
                     (and
                        (= (hammingWeight (l45_lEnd Itl42) tr) (+ (hammingWeight (l46 Itl42) tr) 1))
                        (= (i (l45_lEnd Itl42) tr) (i (l46 Itl42) tr))
                     )
                     ;Ignore any skip statement
                     (= (l49 Itl42) (l45_rEnd Itl42))
                  )
               )
            )
            ;The loop-condition holds always before the last iteration
            (forall ((Itl42 Nat))
               (=>
                  (Sub Itl42 (nl42 tr))
                  (< (i (l42 Itl42) tr) (blength tr))
               )
            )
            ;The loop-condition doesn't hold in the last iteration
            (not
               (< (i (l42 (nl42 tr)) tr) (blength tr))
            )
            ;The values after the while-loop are the values from the last iteration
            (and
               (= (hammingWeight main_end tr) (hammingWeight (l42 (nl42 tr)) tr))
               (= (i main_end tr) (i (l42 (nl42 tr)) tr))
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var hammingWeight and location l16
      (=>
         (forall ((Itl16 Nat))
            (=>
               (Sub Itl16 (nl16 tr))
               (= (hammingWeight (l16 Itl16) tr) (hammingWeight (l16 (s Itl16)) tr))
            )
         )
         (= (hammingWeight (l16 zero) tr) (hammingWeight (l16 (nl16 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var i and location l16
      (=>
         (forall ((Itl16 Nat))
            (=>
               (Sub Itl16 (nl16 tr))
               (= (i (l16 Itl16) tr) (i (l16 (s Itl16)) tr))
            )
         )
         (= (i (l16 zero) tr) (i (l16 (nl16 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var hammingWeight and location l42
      (=>
         (forall ((Itl42 Nat))
            (=>
               (Sub Itl42 (nl42 tr))
               (= (hammingWeight (l42 Itl42) tr) (hammingWeight (l42 (s Itl42)) tr))
            )
         )
         (= (hammingWeight (l42 zero) tr) (hammingWeight (l42 (nl42 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var i and location l42
      (=>
         (forall ((Itl42 Nat))
            (=>
               (Sub Itl42 (nl42 tr))
               (= (i (l42 Itl42) tr) (i (l42 (s Itl42)) tr))
            )
         )
         (= (i (l42 zero) tr) (i (l42 (nl42 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: if the condition of the loop at l16 holds initially, there is at least one loop iteration
      (=>
         (< (i (l16 zero) tr) (alength tr))
         (exists ((Itl16 Nat))
            (= (s Itl16) (nl16 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: if the condition of the loop at l42 holds initially, there is at least one loop iteration
      (=>
         (< (i (l42 zero) tr) (blength tr))
         (exists ((Itl42 Nat))
            (= (s Itl42) (nl42 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var hammingWeight at location l16
      (forall ((xInt Int)(Itl16 Nat))
         (=>
            (and
               (<= (hammingWeight (l16 zero) tr) xInt)
               (< xInt (hammingWeight (l16 (nl16 tr)) tr))
               (= (hammingWeight (l16 (s Itl16)) tr) (+ (hammingWeight (l16 Itl16) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (hammingWeight (l16 it) tr) xInt)
                  (Sub it (nl16 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var i at location l16
      (forall ((xInt Int)(Itl16 Nat))
         (=>
            (and
               (<= (i (l16 zero) tr) xInt)
               (< xInt (i (l16 (nl16 tr)) tr))
               (= (i (l16 (s Itl16)) tr) (+ (i (l16 Itl16) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (i (l16 it) tr) xInt)
                  (Sub it (nl16 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var hammingWeight at location l42
      (forall ((xInt Int)(Itl42 Nat))
         (=>
            (and
               (<= (hammingWeight (l42 zero) tr) xInt)
               (< xInt (hammingWeight (l42 (nl42 tr)) tr))
               (= (hammingWeight (l42 (s Itl42)) tr) (+ (hammingWeight (l42 Itl42) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (hammingWeight (l42 it) tr) xInt)
                  (Sub it (nl42 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var i at location l42
      (forall ((xInt Int)(Itl42 Nat))
         (=>
            (and
               (<= (i (l42 zero) tr) xInt)
               (< xInt (i (l42 (nl42 tr)) tr))
               (= (i (l42 (s Itl42)) tr) (+ (i (l42 Itl42) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (i (l42 it) tr) xInt)
                  (Sub it (nl42 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl16 Nat))
         (=>
            (and
               (Sub (s Itl16) (nl16 tr))
               (= (hammingWeight (l16 (s Itl16)) tr) (+ (hammingWeight (l16 Itl16) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (hammingWeight (l16 it1) tr) (hammingWeight (l16 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl16 Nat))
         (=>
            (and
               (Sub (s Itl16) (nl16 tr))
               (= (i (l16 (s Itl16)) tr) (+ (i (l16 Itl16) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (i (l16 it1) tr) (i (l16 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl42 Nat))
         (=>
            (and
               (Sub (s Itl42) (nl42 tr))
               (= (hammingWeight (l42 (s Itl42)) tr) (+ (hammingWeight (l42 Itl42) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (hammingWeight (l42 it1) tr) (hammingWeight (l42 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl42 Nat))
         (=>
            (and
               (Sub (s Itl42) (nl42 tr))
               (= (i (l42 (s Itl42)) tr) (+ (i (l42 Itl42) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (i (l42 it1) tr) (i (l42 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   ;Lemma: Var hammingWeight at loop l16 has same values on both traces
   (=>
      (and
         (= (hammingWeight (l16 zero) t1) (hammingWeight (l16 zero) t2))
         (forall ((Itl16 Nat))
            (=>
               (= (hammingWeight (l16 Itl16) t1) (hammingWeight (l16 Itl16) t2))
               (= (hammingWeight (l16 (s Itl16)) t1) (hammingWeight (l16 (s Itl16)) t2))
            )
         )
      )
      (forall ((Itl16 Nat))
         (= (hammingWeight (l16 Itl16) t1) (hammingWeight (l16 Itl16) t2))
      )
   )
)

(assert
   ;Lemma: Var i at loop l16 has same values on both traces
   (=>
      (and
         (= (i (l16 zero) t1) (i (l16 zero) t2))
         (forall ((Itl16 Nat))
            (=>
               (= (i (l16 Itl16) t1) (i (l16 Itl16) t2))
               (= (i (l16 (s Itl16)) t1) (i (l16 (s Itl16)) t2))
            )
         )
      )
      (forall ((Itl16 Nat))
         (= (i (l16 Itl16) t1) (i (l16 Itl16) t2))
      )
   )
)

(assert
   ;Lemma: Var hammingWeight at loop l42 has same values on both traces
   (=>
      (and
         (= (hammingWeight (l42 zero) t1) (hammingWeight (l42 zero) t2))
         (forall ((Itl42 Nat))
            (=>
               (= (hammingWeight (l42 Itl42) t1) (hammingWeight (l42 Itl42) t2))
               (= (hammingWeight (l42 (s Itl42)) t1) (hammingWeight (l42 (s Itl42)) t2))
            )
         )
      )
      (forall ((Itl42 Nat))
         (= (hammingWeight (l42 Itl42) t1) (hammingWeight (l42 Itl42) t2))
      )
   )
)

(assert
   ;Lemma: Var i at loop l42 has same values on both traces
   (=>
      (and
         (= (i (l42 zero) t1) (i (l42 zero) t2))
         (forall ((Itl42 Nat))
            (=>
               (= (i (l42 Itl42) t1) (i (l42 Itl42) t2))
               (= (i (l42 (s Itl42)) t1) (i (l42 (s Itl42)) t2))
            )
         )
      )
      (forall ((Itl42 Nat))
         (= (i (l42 Itl42) t1) (i (l42 Itl42) t2))
      )
   )
)

(assert
   ;Lemma: If nl16(t2) has same properties as nl16(t1), then nl16(t2)=nl16(t1) (for loop at l16)
   (=>
      (and
         (forall ((Itl16 Nat))
            (=>
               (Sub Itl16 (nl16 t2))
               (< (i (l16 Itl16) t1) (alength t1))
            )
         )
         (not
            (< (i (l16 (nl16 t2)) t1) (alength t1))
         )
      )
      (= (nl16 t2) (nl16 t1))
   )
)

(assert
   ;Lemma: If nl42(t2) has same properties as nl42(t1), then nl42(t2)=nl42(t1) (for loop at l42)
   (=>
      (and
         (forall ((Itl42 Nat))
            (=>
               (Sub Itl42 (nl42 t2))
               (< (i (l42 Itl42) t1) (blength t1))
            )
         )
         (not
            (< (i (l42 (nl42 t2)) t1) (blength t1))
         )
      )
      (= (nl42 t2) (nl42 t1))
   )
)

(assert
   ;Lemma: Equality preservation over traces for var hammingWeight at location l16
   (forall ((itR Nat))
      (=>
         (and
            (= (hammingWeight (l16 zero) t1) (hammingWeight (l16 zero) t2))
            (forall ((Itl16 Nat))
               (=>
                  (and
                     (Sub Itl16 itR)
                     (= (hammingWeight (l16 Itl16) t1) (hammingWeight (l16 Itl16) t2))
                  )
                  (= (hammingWeight (l16 (s Itl16)) t1) (hammingWeight (l16 (s Itl16)) t2))
               )
            )
         )
         (= (hammingWeight (l16 itR) t1) (hammingWeight (l16 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l16
   (forall ((itR Nat))
      (=>
         (and
            (= (i (l16 zero) t1) (i (l16 zero) t2))
            (forall ((Itl16 Nat))
               (=>
                  (and
                     (Sub Itl16 itR)
                     (= (i (l16 Itl16) t1) (i (l16 Itl16) t2))
                  )
                  (= (i (l16 (s Itl16)) t1) (i (l16 (s Itl16)) t2))
               )
            )
         )
         (= (i (l16 itR) t1) (i (l16 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var hammingWeight at location l16
   (forall ((itL Nat))
      (=>
         (and
            (= (hammingWeight (l16 itL) t1) (hammingWeight (l16 itL) t2))
            (forall ((Itl16 Nat))
               (=>
                  (and
                     (Sub itL (s Itl16))
                     (Sub Itl16 (nl16 t1))
                     (= (hammingWeight (l16 Itl16) t1) (hammingWeight (l16 Itl16) t2))
                  )
                  (= (hammingWeight (l16 (s Itl16)) t1) (hammingWeight (l16 (s Itl16)) t2))
               )
            )
            (= (l16 (nl16 t1)) (l16 (nl16 t2)))
         )
         (= (hammingWeight (l16 (nl16 t1)) t1) (hammingWeight (l16 (nl16 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l16
   (forall ((itL Nat))
      (=>
         (and
            (= (i (l16 itL) t1) (i (l16 itL) t2))
            (forall ((Itl16 Nat))
               (=>
                  (and
                     (Sub itL (s Itl16))
                     (Sub Itl16 (nl16 t1))
                     (= (i (l16 Itl16) t1) (i (l16 Itl16) t2))
                  )
                  (= (i (l16 (s Itl16)) t1) (i (l16 (s Itl16)) t2))
               )
            )
            (= (l16 (nl16 t1)) (l16 (nl16 t2)))
         )
         (= (i (l16 (nl16 t1)) t1) (i (l16 (nl16 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var hammingWeight at location l42
   (forall ((itR Nat))
      (=>
         (and
            (= (hammingWeight (l42 zero) t1) (hammingWeight (l42 zero) t2))
            (forall ((Itl42 Nat))
               (=>
                  (and
                     (Sub Itl42 itR)
                     (= (hammingWeight (l42 Itl42) t1) (hammingWeight (l42 Itl42) t2))
                  )
                  (= (hammingWeight (l42 (s Itl42)) t1) (hammingWeight (l42 (s Itl42)) t2))
               )
            )
         )
         (= (hammingWeight (l42 itR) t1) (hammingWeight (l42 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l42
   (forall ((itR Nat))
      (=>
         (and
            (= (i (l42 zero) t1) (i (l42 zero) t2))
            (forall ((Itl42 Nat))
               (=>
                  (and
                     (Sub Itl42 itR)
                     (= (i (l42 Itl42) t1) (i (l42 Itl42) t2))
                  )
                  (= (i (l42 (s Itl42)) t1) (i (l42 (s Itl42)) t2))
               )
            )
         )
         (= (i (l42 itR) t1) (i (l42 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var hammingWeight at location l42
   (forall ((itL Nat))
      (=>
         (and
            (= (hammingWeight (l42 itL) t1) (hammingWeight (l42 itL) t2))
            (forall ((Itl42 Nat))
               (=>
                  (and
                     (Sub itL (s Itl42))
                     (Sub Itl42 (nl42 t1))
                     (= (hammingWeight (l42 Itl42) t1) (hammingWeight (l42 Itl42) t2))
                  )
                  (= (hammingWeight (l42 (s Itl42)) t1) (hammingWeight (l42 (s Itl42)) t2))
               )
            )
            (= (l42 (nl42 t1)) (l42 (nl42 t2)))
         )
         (= (hammingWeight (l42 (nl42 t1)) t1) (hammingWeight (l42 (nl42 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l42
   (forall ((itL Nat))
      (=>
         (and
            (= (i (l42 itL) t1) (i (l42 itL) t2))
            (forall ((Itl42 Nat))
               (=>
                  (and
                     (Sub itL (s Itl42))
                     (Sub Itl42 (nl42 t1))
                     (= (i (l42 Itl42) t1) (i (l42 Itl42) t2))
                  )
                  (= (i (l42 (s Itl42)) t1) (i (l42 (s Itl42)) t2))
               )
            )
            (= (l42 (nl42 t1)) (l42 (nl42 t2)))
         )
         (= (i (l42 (nl42 t1)) t1) (i (l42 (nl42 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var hammingWeight at location l16
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (hammingWeight (l16 zero) t1) (hammingWeight (l16 zero) t2))
            (forall ((tr3 Trace)(Itl16 Nat))
               (= (hammingWeight (l16 (s Itl16)) tr3) (+ (hammingWeight (l16 Itl16) tr3) 1))
            )
         )
         (< (hammingWeight (l16 it1) tr) (hammingWeight (l16 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var i at location l16
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (i (l16 zero) t1) (i (l16 zero) t2))
            (forall ((tr3 Trace)(Itl16 Nat))
               (= (i (l16 (s Itl16)) tr3) (+ (i (l16 Itl16) tr3) 1))
            )
         )
         (< (i (l16 it1) tr) (i (l16 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var hammingWeight at location l42
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (hammingWeight (l42 zero) t1) (hammingWeight (l42 zero) t2))
            (forall ((tr3 Trace)(Itl42 Nat))
               (= (hammingWeight (l42 (s Itl42)) tr3) (+ (hammingWeight (l42 Itl42) tr3) 1))
            )
         )
         (< (hammingWeight (l42 it1) tr) (hammingWeight (l42 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var i at location l42
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (i (l42 zero) t1) (i (l42 zero) t2))
            (forall ((tr3 Trace)(Itl42 Nat))
               (= (i (l42 (s Itl42)) tr3) (+ (i (l42 Itl42) tr3) 1))
            )
         )
         (< (i (l42 it1) tr) (i (l42 it2) tr))
      )
   )
)

(assert
   ;Theory axiom: forall x y z. (x + y) + z) = (x + z) + y
   (forall ((xInt Int)(yInt Int)(zInt Int))
      (= (+ (+ xInt yInt) zInt) (+ (+ xInt zInt) yInt))
   )
)

; negated conjecture
(assert
   (not
      (=>
         (and
            (forall ((j Int))
               (and
                  (= (a j t1) (a j t2))
                  (= (b j t1) (b j t2))
               )
            )
            (= (x t1) (y t2))
            (= (y t1) (x t2))
            (= (alength t1) (alength t2))
            (= (blength t1) (blength t2))
         )
         (= (hammingWeight main_end t1) (hammingWeight main_end t2))
      )
   )
)

(check-sat)

(exit)
