(set-info :smt-lib-version 2.6)
(set-logic UFDTLIA)
(set-info :source |
Generated by: Bernhard Gleiss
Generated on: 2019-3-11
Generator: Rapid
Application: Software Verification
Target solver: Vampire
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "crafted")
(set-info :status unknown)

(declare-datatypes ((Nat 0)) (( (zero) (s (p Nat)) )) )
(declare-sort Time 0)
(declare-sort Trace 0)
(declare-const main_end Time)
(declare-fun l15 (Nat) Time)
(declare-fun nl12 (Trace) Nat)
(declare-const l9 Time)
(declare-fun alength (Trace) Int)
(declare-const t1 Trace)
(declare-const t2 Trace)
(declare-const l10 Time)
(declare-fun a (Int Trace) Int)
(declare-fun l12 (Nat) Time)
(declare-fun l14 (Nat) Time)
(declare-fun i (Time Trace) Int)
(declare-fun Sub (Nat Nat) Bool)
(assert (forall ((it Nat)) (Sub it (s it))) )
(assert (forall ((it1 Nat)(it2 Nat)) (=> (Sub it1 it2) (Sub it1 (s it2))) ))
(declare-fun hammingWeight (Time Trace) Int)

(assert
   ;Semantics of function main
   (and
      (forall ((tr Trace))
         ;Update variable i at location l9
         (= (i l10 tr) 0)
      )
      (forall ((tr Trace))
         ;Update variable hammingWeight at location l10
         (and
            (= (hammingWeight (l12 zero) tr) 0)
            (= (i (l12 zero) tr) (i l10 tr))
         )
      )
      (forall ((tr Trace))
         ;Loop at location l12
         (and
            ;Jumping into the body doesn't change the variable values
            (forall ((Itl12 Nat))
               (and
                  (= (hammingWeight (l14 Itl12) tr) (hammingWeight (l12 Itl12) tr))
                  (= (i (l14 Itl12) tr) (i (l12 Itl12) tr))
               )
            )
            ;Semantics of the body
            (forall ((Itl12 Nat))
               (and
                  ;Update variable hammingWeight at location l14
                  (and
                     (= (hammingWeight (l15 Itl12) tr) (+ (hammingWeight (l14 Itl12) tr) (a (i (l14 Itl12) tr) tr)))
                     (= (i (l15 Itl12) tr) (i (l14 Itl12) tr))
                  )
                  ;Update variable i at location l15
                  (and
                     (= (i (l12 (s Itl12)) tr) (+ (i (l15 Itl12) tr) 1))
                     (= (hammingWeight (l12 (s Itl12)) tr) (hammingWeight (l15 Itl12) tr))
                  )
               )
            )
            ;The loop-condition holds always before the last iteration
            (forall ((Itl12 Nat))
               (=>
                  (Sub Itl12 (nl12 tr))
                  (< (i (l12 Itl12) tr) (alength tr))
               )
            )
            ;The loop-condition doesn't hold in the last iteration
            (not
               (< (i (l12 (nl12 tr)) tr) (alength tr))
            )
            ;The values after the while-loop are the values from the last iteration
            (and
               (= (hammingWeight main_end tr) (hammingWeight (l12 (nl12 tr)) tr))
               (= (i main_end tr) (i (l12 (nl12 tr)) tr))
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var hammingWeight and location l12
      (=>
         (forall ((Itl12 Nat))
            (=>
               (Sub Itl12 (nl12 tr))
               (= (hammingWeight (l12 Itl12) tr) (hammingWeight (l12 (s Itl12)) tr))
            )
         )
         (= (hammingWeight (l12 zero) tr) (hammingWeight (l12 (nl12 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var i and location l12
      (=>
         (forall ((Itl12 Nat))
            (=>
               (Sub Itl12 (nl12 tr))
               (= (i (l12 Itl12) tr) (i (l12 (s Itl12)) tr))
            )
         )
         (= (i (l12 zero) tr) (i (l12 (nl12 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: if the condition of the loop at l12 holds initially, there is at least one loop iteration
      (=>
         (< (i (l12 zero) tr) (alength tr))
         (exists ((Itl12 Nat))
            (= (s Itl12) (nl12 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var hammingWeight at location l12
      (forall ((xInt Int)(Itl12 Nat))
         (=>
            (and
               (<= (hammingWeight (l12 zero) tr) xInt)
               (< xInt (hammingWeight (l12 (nl12 tr)) tr))
               (= (hammingWeight (l12 (s Itl12)) tr) (+ (hammingWeight (l12 Itl12) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (hammingWeight (l12 it) tr) xInt)
                  (Sub it (nl12 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var i at location l12
      (forall ((xInt Int)(Itl12 Nat))
         (=>
            (and
               (<= (i (l12 zero) tr) xInt)
               (< xInt (i (l12 (nl12 tr)) tr))
               (= (i (l12 (s Itl12)) tr) (+ (i (l12 Itl12) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (i (l12 it) tr) xInt)
                  (Sub it (nl12 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl12 Nat))
         (=>
            (and
               (Sub (s Itl12) (nl12 tr))
               (= (hammingWeight (l12 (s Itl12)) tr) (+ (hammingWeight (l12 Itl12) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (hammingWeight (l12 it1) tr) (hammingWeight (l12 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl12 Nat))
         (=>
            (and
               (Sub (s Itl12) (nl12 tr))
               (= (i (l12 (s Itl12)) tr) (+ (i (l12 Itl12) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (i (l12 it1) tr) (i (l12 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   ;Lemma: Var hammingWeight at loop l12 has same values on both traces
   (=>
      (and
         (= (hammingWeight (l12 zero) t1) (hammingWeight (l12 zero) t2))
         (forall ((Itl12 Nat))
            (=>
               (= (hammingWeight (l12 Itl12) t1) (hammingWeight (l12 Itl12) t2))
               (= (hammingWeight (l12 (s Itl12)) t1) (hammingWeight (l12 (s Itl12)) t2))
            )
         )
      )
      (forall ((Itl12 Nat))
         (= (hammingWeight (l12 Itl12) t1) (hammingWeight (l12 Itl12) t2))
      )
   )
)

(assert
   ;Lemma: Var i at loop l12 has same values on both traces
   (=>
      (and
         (= (i (l12 zero) t1) (i (l12 zero) t2))
         (forall ((Itl12 Nat))
            (=>
               (= (i (l12 Itl12) t1) (i (l12 Itl12) t2))
               (= (i (l12 (s Itl12)) t1) (i (l12 (s Itl12)) t2))
            )
         )
      )
      (forall ((Itl12 Nat))
         (= (i (l12 Itl12) t1) (i (l12 Itl12) t2))
      )
   )
)

(assert
   ;Lemma: If nl12(t2) has same properties as nl12(t1), then nl12(t2)=nl12(t1) (for loop at l12)
   (=>
      (and
         (forall ((Itl12 Nat))
            (=>
               (Sub Itl12 (nl12 t2))
               (< (i (l12 Itl12) t1) (alength t1))
            )
         )
         (not
            (< (i (l12 (nl12 t2)) t1) (alength t1))
         )
      )
      (= (nl12 t2) (nl12 t1))
   )
)

(assert
   ;Lemma: Equality preservation over traces for var hammingWeight at location l12
   (forall ((itR Nat))
      (=>
         (and
            (= (hammingWeight (l12 zero) t1) (hammingWeight (l12 zero) t2))
            (forall ((Itl12 Nat))
               (=>
                  (and
                     (Sub Itl12 itR)
                     (= (hammingWeight (l12 Itl12) t1) (hammingWeight (l12 Itl12) t2))
                  )
                  (= (hammingWeight (l12 (s Itl12)) t1) (hammingWeight (l12 (s Itl12)) t2))
               )
            )
         )
         (= (hammingWeight (l12 itR) t1) (hammingWeight (l12 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l12
   (forall ((itR Nat))
      (=>
         (and
            (= (i (l12 zero) t1) (i (l12 zero) t2))
            (forall ((Itl12 Nat))
               (=>
                  (and
                     (Sub Itl12 itR)
                     (= (i (l12 Itl12) t1) (i (l12 Itl12) t2))
                  )
                  (= (i (l12 (s Itl12)) t1) (i (l12 (s Itl12)) t2))
               )
            )
         )
         (= (i (l12 itR) t1) (i (l12 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var hammingWeight at location l12
   (forall ((itL Nat))
      (=>
         (and
            (= (hammingWeight (l12 itL) t1) (hammingWeight (l12 itL) t2))
            (forall ((Itl12 Nat))
               (=>
                  (and
                     (Sub itL (s Itl12))
                     (Sub Itl12 (nl12 t1))
                     (= (hammingWeight (l12 Itl12) t1) (hammingWeight (l12 Itl12) t2))
                  )
                  (= (hammingWeight (l12 (s Itl12)) t1) (hammingWeight (l12 (s Itl12)) t2))
               )
            )
            (= (l12 (nl12 t1)) (l12 (nl12 t2)))
         )
         (= (hammingWeight (l12 (nl12 t1)) t1) (hammingWeight (l12 (nl12 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l12
   (forall ((itL Nat))
      (=>
         (and
            (= (i (l12 itL) t1) (i (l12 itL) t2))
            (forall ((Itl12 Nat))
               (=>
                  (and
                     (Sub itL (s Itl12))
                     (Sub Itl12 (nl12 t1))
                     (= (i (l12 Itl12) t1) (i (l12 Itl12) t2))
                  )
                  (= (i (l12 (s Itl12)) t1) (i (l12 (s Itl12)) t2))
               )
            )
            (= (l12 (nl12 t1)) (l12 (nl12 t2)))
         )
         (= (i (l12 (nl12 t1)) t1) (i (l12 (nl12 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var hammingWeight at location l12
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (hammingWeight (l12 zero) t1) (hammingWeight (l12 zero) t2))
            (forall ((tr3 Trace)(Itl12 Nat))
               (= (hammingWeight (l12 (s Itl12)) tr3) (+ (hammingWeight (l12 Itl12) tr3) 1))
            )
         )
         (< (hammingWeight (l12 it1) tr) (hammingWeight (l12 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var i at location l12
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (i (l12 zero) t1) (i (l12 zero) t2))
            (forall ((tr3 Trace)(Itl12 Nat))
               (= (i (l12 (s Itl12)) tr3) (+ (i (l12 Itl12) tr3) 1))
            )
         )
         (< (i (l12 it1) tr) (i (l12 it2) tr))
      )
   )
)

(assert
   ;Theory axiom: forall x y z. (x + y) + z) = (x + z) + y
   (forall ((xInt Int)(yInt Int)(zInt Int))
      (= (+ (+ xInt yInt) zInt) (+ (+ xInt zInt) yInt))
   )
)

; negated conjecture
(assert
   (not
      (forall ((k Int)(itK Nat)(itKPlus2 Nat))
         (=>
            (and
               (= (alength t1) (alength t2))
               (<= 0 k)
               (< (+ k 1) (alength t1))
               (= (i (l12 itK) t1) k)
               (= (i (l12 itKPlus2) t1) (+ k 2))
               (= itKPlus2 (s (s itK)))
               (forall ((v Int))
                  (=>
                     (and
                        (not
                           (= v k)
                        )
                        (not
                           (= v (+ k 1))
                        )
                     )
                     (= (a v t1) (a v t2))
                  )
               )
               (= (a k t1) (a (+ k 1) t2))
               (= (a k t2) (a (+ k 1) t1))
               (forall ((x Int)(y Int)(z Int))
                  (= (+ (+ x y) z) (+ (+ x z) y))
               )
            )
            (and
               (= (hammingWeight (l12 itKPlus2) t1) (hammingWeight (l12 itKPlus2) t2))
               (= (hammingWeight main_end t1) (hammingWeight main_end t2))
            )
         )
      )
   )
)

(check-sat)

(exit)
