(set-info :smt-lib-version 2.6)
(set-logic UFDTLIA)
(set-info :source |
Generated by: Bernhard Gleiss
Generated on: 2019-3-11
Generator: Rapid
Application: Software Verification
Target solver: Vampire
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "crafted")
(set-info :status unknown)

(declare-datatypes ((Nat 0)) (( (zero) (s (p Nat)) )) )
(declare-sort Time 0)
(declare-sort Trace 0)
(declare-const t1 Trace)
(declare-fun h (Time Trace) Int)
(declare-const t2 Trace)
(declare-fun l (Time Trace) Int)
(declare-const l7 Time)
(declare-const l8 Time)
(declare-fun Sub (Nat Nat) Bool)
(assert (forall ((it Nat)) (Sub it (s it))) )
(assert (forall ((it1 Nat)(it2 Nat)) (=> (Sub it1 it2) (Sub it1 (s it2))) ))
(declare-const main_end Time)

(assert
   ;Semantics of function main
   (and
      (forall ((tr Trace))
         ;Update variable h at location l7
         (and
            (= (h l8 tr) (+ (l l7 tr) 4))
            (= (l l8 tr) (l l7 tr))
         )
      )
      (forall ((tr Trace))
         ;Update variable l at location l8
         (and
            (= (l main_end tr) (- (l l8 tr) 5))
            (= (h main_end tr) (h l8 tr))
         )
      )
   )
)

(assert
   ;Theory axiom: forall x y z. (x + y) + z) = (x + z) + y
   (forall ((xInt Int)(yInt Int)(zInt Int))
      (= (+ (+ xInt yInt) zInt) (+ (+ xInt zInt) yInt))
   )
)

; negated conjecture
(assert
   (not
      (=>
         (= (l l7 t1) (l l7 t2))
         (= (l main_end t1) (l main_end t2))
      )
   )
)

(check-sat)

(exit)
