(set-info :smt-lib-version 2.6)
(set-logic UFDTLIA)
(set-info :source |
Generated by: Bernhard Gleiss
Generated on: 2019-3-11
Generator: Rapid
Application: Software Verification
Target solver: Vampire
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "crafted")
(set-info :status unknown)

(declare-datatypes ((Nat 0)) (( (zero) (s (p Nat)) )) )
(declare-sort Time 0)
(declare-sort Trace 0)
(declare-const main_end Time)
(declare-const l21 Time)
(declare-const l20 Time)
(declare-const l16_rEnd Time)
(declare-const l16_lEnd Time)
(declare-const l10_rEnd Time)
(declare-const l10_lEnd Time)
(declare-const l9 Time)
(declare-fun counter (Time Trace) Int)
(declare-const l13 Time)
(declare-fun output (Time Int Trace) Int)
(declare-const l18 Time)
(declare-fun h2 (Trace) Int)
(declare-const l24 Time)
(declare-const t1 Trace)
(declare-const l17 Time)
(declare-fun h (Trace) Int)
(declare-const t2 Trace)
(declare-const l16 Time)
(declare-const l10 Time)
(declare-const l12 Time)
(declare-fun Sub (Nat Nat) Bool)
(assert (forall ((it Nat)) (Sub it (s it))) )
(assert (forall ((it1 Nat)(it2 Nat)) (=> (Sub it1 it2) (Sub it1 (s it2))) ))
(declare-const l25 Time)

(assert
   ;Semantics of function main
   (and
      (forall ((tr Trace))
         ;Update variable counter at location l9
         (and
            (= (counter l10 tr) 0)
            (forall ((pos Int))
               (= (output l10 pos tr) (output l9 pos tr))
            )
         )
      )
      (forall ((tr Trace))
         ;Semantics of IfElse at location l10
         (and
            ;Jumping into any branch doesn't change the variable values
            (and
               (forall ((pos Int))
                  (= (output l12 pos tr) (output l10 pos tr))
               )
               (= (counter l12 tr) (counter l10 tr))
               (forall ((pos Int))
                  (= (output l16 pos tr) (output l10 pos tr))
               )
               (= (counter l16 tr) (counter l10 tr))
            )
            ;The branching-condition determines which values to use after the if-statement
            (and
               (=>
                  (> (h tr) 0)
                  (= (counter l24 tr) (counter l10_lEnd tr))
               )
               (=>
                  (> (h tr) 0)
                  (forall ((pos Int))
                     (= (output l24 pos tr) (output l10_lEnd pos tr))
                  )
               )
               (=>
                  (not
                     (> (h tr) 0)
                  )
                  (= (counter l24 tr) (counter l10_rEnd tr))
               )
               (=>
                  (not
                     (> (h tr) 0)
                  )
                  (forall ((pos Int))
                     (= (output l24 pos tr) (output l10_rEnd pos tr))
                  )
               )
            )
            ;Update array variable output at location l12
            (and
               (= (output l13 (counter l12 tr) tr) 5)
               (forall ((pos Int))
                  (=>
                     (not
                        (= pos (counter l12 tr))
                     )
                     (= (output l13 pos tr) (output l12 pos tr))
                  )
               )
               (= (counter l13 tr) (counter l12 tr))
            )
            ;Update variable counter at location l13
            (and
               (= (counter l10_lEnd tr) (+ (counter l13 tr) 1))
               (forall ((pos Int))
                  (= (output l10_lEnd pos tr) (output l13 pos tr))
               )
            )
            ;Semantics of IfElse at location l16
            (and
               ;Jumping into any branch doesn't change the variable values
               (and
                  (forall ((pos Int))
                     (= (output l17 pos tr) (output l16 pos tr))
                  )
                  (= (counter l17 tr) (counter l16 tr))
                  (forall ((pos Int))
                     (= (output l20 pos tr) (output l16 pos tr))
                  )
                  (= (counter l20 tr) (counter l16 tr))
               )
               ;The branching-condition determines which values to use after the if-statement
               (and
                  (=>
                     (> (h2 tr) 0)
                     (= (counter l10_rEnd tr) (counter l16_lEnd tr))
                  )
                  (=>
                     (> (h2 tr) 0)
                     (forall ((pos Int))
                        (= (output l10_rEnd pos tr) (output l16_lEnd pos tr))
                     )
                  )
                  (=>
                     (not
                        (> (h2 tr) 0)
                     )
                     (= (counter l10_rEnd tr) (counter l16_rEnd tr))
                  )
                  (=>
                     (not
                        (> (h2 tr) 0)
                     )
                     (forall ((pos Int))
                        (= (output l10_rEnd pos tr) (output l16_rEnd pos tr))
                     )
                  )
               )
               ;Update array variable output at location l17
               (and
                  (= (output l18 (counter l17 tr) tr) 5)
                  (forall ((pos Int))
                     (=>
                        (not
                           (= pos (counter l17 tr))
                        )
                        (= (output l18 pos tr) (output l17 pos tr))
                     )
                  )
                  (= (counter l18 tr) (counter l17 tr))
               )
               ;Update variable counter at location l18
               (and
                  (= (counter l16_lEnd tr) (+ (counter l18 tr) 1))
                  (forall ((pos Int))
                     (= (output l16_lEnd pos tr) (output l18 pos tr))
                  )
               )
               ;Update array variable output at location l20
               (and
                  (= (output l21 (counter l20 tr) tr) 5)
                  (forall ((pos Int))
                     (=>
                        (not
                           (= pos (counter l20 tr))
                        )
                        (= (output l21 pos tr) (output l20 pos tr))
                     )
                  )
                  (= (counter l21 tr) (counter l20 tr))
               )
               ;Update variable counter at location l21
               (and
                  (= (counter l16_rEnd tr) (+ (counter l21 tr) 1))
                  (forall ((pos Int))
                     (= (output l16_rEnd pos tr) (output l21 pos tr))
                  )
               )
            )
         )
      )
      (forall ((tr Trace))
         ;Update array variable output at location l24
         (and
            (= (output l25 (counter l24 tr) tr) 7)
            (forall ((pos Int))
               (=>
                  (not
                     (= pos (counter l24 tr))
                  )
                  (= (output l25 pos tr) (output l24 pos tr))
               )
            )
            (= (counter l25 tr) (counter l24 tr))
         )
      )
      (forall ((tr Trace))
         ;Update variable counter at location l25
         (and
            (= (counter main_end tr) (+ (counter l25 tr) 1))
            (forall ((pos Int))
               (= (output main_end pos tr) (output l25 pos tr))
            )
         )
      )
   )
)

(assert
   ;Theory axiom: forall x y z. (x + y) + z) = (x + z) + y
   (forall ((xInt Int)(yInt Int)(zInt Int))
      (= (+ (+ xInt yInt) zInt) (+ (+ xInt zInt) yInt))
   )
)

; negated conjecture
(assert
   (not
      (= (counter main_end t1) (counter main_end t2))
   )
)

(check-sat)

(exit)
