(set-info :smt-lib-version 2.6)
(set-logic UFDTLIA)
(set-info :source |
Generated by: Bernhard Gleiss
Generated on: 2019-3-11
Generator: Rapid
Application: Software Verification
Target solver: Vampire
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "crafted")
(set-info :status unknown)

(declare-datatypes ((Nat 0)) (( (zero) (s (p Nat)) )) )
(declare-sort Time 0)
(declare-sort Trace 0)
(declare-const main_end Time)
(declare-const t1 Trace)
(declare-const l8_rEnd Time)
(declare-const t2 Trace)
(declare-const l10 Time)
(declare-const l8_lEnd Time)
(declare-fun lo (Time Trace) Int)
(declare-const l8 Time)
(declare-fun Sub (Nat Nat) Bool)
(assert (forall ((it Nat)) (Sub it (s it))) )
(assert (forall ((it1 Nat)(it2 Nat)) (=> (Sub it1 it2) (Sub it1 (s it2))) ))
(declare-const l14 Time)
(declare-fun hi (Trace) Int)

(assert
   ;Semantics of function main
   (forall ((tr Trace))
      ;Semantics of IfElse at location l8
      (and
         ;Jumping into any branch doesn't change the variable values
         (and
            (= (lo l10 tr) (lo l8 tr))
            (= (lo l14 tr) (lo l8 tr))
         )
         ;The branching-condition determines which values to use after the if-statement
         (and
            (=>
               (> (hi tr) 0)
               (= (lo main_end tr) (lo l8_lEnd tr))
            )
            (=>
               (not
                  (> (hi tr) 0)
               )
               (= (lo main_end tr) (lo l8_rEnd tr))
            )
         )
         ;Update variable lo at location l10
         (= (lo l8_lEnd tr) (+ (lo l10 tr) 1))
         ;Update variable lo at location l14
         (= (lo l8_rEnd tr) (+ (lo l14 tr) 1))
      )
   )
)

(assert
   ;Theory axiom: forall x y z. (x + y) + z) = (x + z) + y
   (forall ((xInt Int)(yInt Int)(zInt Int))
      (= (+ (+ xInt yInt) zInt) (+ (+ xInt zInt) yInt))
   )
)

; negated conjecture
(assert
   (not
      (=>
         (= (lo l8 t1) (lo l8 t2))
         (= (lo main_end t1) (lo main_end t2))
      )
   )
)

(check-sat)

(exit)
