(set-info :smt-lib-version 2.6)
(set-logic UFDTLIA)
(set-info :source |
Generated by: Bernhard Gleiss
Generated on: 2019-3-11
Generator: Rapid
Application: Software Verification
Target solver: Vampire
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "crafted")
(set-info :status unknown)

(declare-datatypes ((Nat 0)) (( (zero) (s (p Nat)) )) )
(declare-sort Time 0)
(declare-sort Trace 0)
(declare-const main_end Time)
(declare-const l21 Time)
(declare-const l20 Time)
(declare-const l12_rEnd Time)
(declare-const l9 Time)
(declare-fun counter (Time Trace) Int)
(declare-const l13 Time)
(declare-fun output (Time Int Trace) Int)
(declare-const t1 Trace)
(declare-const l19 Time)
(declare-fun h (Trace) Int)
(declare-const t2 Trace)
(declare-const l12_lEnd Time)
(declare-fun l (Time Trace) Int)
(declare-const l16 Time)
(declare-const l12 Time)
(declare-const l7 Time)
(declare-fun Sub (Nat Nat) Bool)
(assert (forall ((it Nat)) (Sub it (s it))) )
(assert (forall ((it1 Nat)(it2 Nat)) (=> (Sub it1 it2) (Sub it1 (s it2))) ))

(assert
   ;Semantics of function main
   (and
      (forall ((tr Trace))
         ;Update variable l at location l7
         (and
            (= (l l9 tr) 5)
            (forall ((pos Int))
               (= (output l9 pos tr) (output l7 pos tr))
            )
         )
      )
      (forall ((tr Trace))
         ;Update variable counter at location l9
         (and
            (= (counter l12 tr) 0)
            (forall ((pos Int))
               (= (output l12 pos tr) (output l9 pos tr))
            )
            (= (l l12 tr) (l l9 tr))
         )
      )
      (forall ((tr Trace))
         ;Semantics of IfElse at location l12
         (and
            ;Jumping into any branch doesn't change the variable values
            (and
               (= (counter l13 tr) (counter l12 tr))
               (= (l l13 tr) (l l12 tr))
               (forall ((pos Int))
                  (= (output l13 pos tr) (output l12 pos tr))
               )
               (= (counter l16 tr) (counter l12 tr))
               (= (l l16 tr) (l l12 tr))
               (forall ((pos Int))
                  (= (output l16 pos tr) (output l12 pos tr))
               )
            )
            ;The branching-condition determines which values to use after the if-statement
            (and
               (=>
                  (= (h tr) 1)
                  (forall ((pos Int))
                     (= (output l19 pos tr) (output l12_lEnd pos tr))
                  )
               )
               (=>
                  (= (h tr) 1)
                  (= (counter l19 tr) (counter l12_lEnd tr))
               )
               (=>
                  (= (h tr) 1)
                  (= (l l19 tr) (l l12_lEnd tr))
               )
               (=>
                  (not
                     (= (h tr) 1)
                  )
                  (forall ((pos Int))
                     (= (output l19 pos tr) (output l12_rEnd pos tr))
                  )
               )
               (=>
                  (not
                     (= (h tr) 1)
                  )
                  (= (counter l19 tr) (counter l12_rEnd tr))
               )
               (=>
                  (not
                     (= (h tr) 1)
                  )
                  (= (l l19 tr) (l l12_rEnd tr))
               )
            )
            ;Update variable l at location l13
            (and
               (= (l l12_lEnd tr) (- (l l13 tr) 1))
               (forall ((pos Int))
                  (= (output l12_lEnd pos tr) (output l13 pos tr))
               )
               (= (counter l12_lEnd tr) (counter l13 tr))
            )
            ;Ignore any skip statement
            (= l16 l12_rEnd)
         )
      )
      (forall ((tr Trace))
         ;Update variable l at location l19
         (and
            (= (l l20 tr) 4)
            (forall ((pos Int))
               (= (output l20 pos tr) (output l19 pos tr))
            )
            (= (counter l20 tr) (counter l19 tr))
         )
      )
      (forall ((tr Trace))
         ;Update array variable output at location l20
         (and
            (= (output l21 (counter l20 tr) tr) (l l20 tr))
            (forall ((pos Int))
               (=>
                  (not
                     (= pos (counter l20 tr))
                  )
                  (= (output l21 pos tr) (output l20 pos tr))
               )
            )
            (= (counter l21 tr) (counter l20 tr))
            (= (l l21 tr) (l l20 tr))
         )
      )
      (forall ((tr Trace))
         ;Update variable counter at location l21
         (and
            (= (counter main_end tr) (+ (counter l21 tr) 1))
            (forall ((pos Int))
               (= (output main_end pos tr) (output l21 pos tr))
            )
            (= (l main_end tr) (l l21 tr))
         )
      )
   )
)

(assert
   ;Theory axiom: forall x y z. (x + y) + z) = (x + z) + y
   (forall ((xInt Int)(yInt Int)(zInt Int))
      (= (+ (+ xInt yInt) zInt) (+ (+ xInt zInt) yInt))
   )
)

; negated conjecture
(assert
   (not
      (and
         (= (counter main_end t1) (counter main_end t2))
         (forall ((i Int)(tr Trace))
            (=>
               (and
                  (< i (counter main_end tr))
                  (<= 0 i)
               )
               (= (output main_end i t1) (output main_end i t2))
            )
         )
      )
   )
)

(check-sat)

(exit)
