(set-info :smt-lib-version 2.6)
(set-logic UFDTLIA)
(set-info :source |
Generated by: Bernhard Gleiss
Generated on: 2019-3-11
Generator: Rapid
Application: Software Verification
Target solver: Vampire
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "crafted")
(set-info :status unknown)

(declare-datatypes ((Nat 0)) (( (zero) (s (p Nat)) )) )
(declare-sort Time 0)
(declare-sort Trace 0)
(declare-const main_end Time)
(declare-const l9_rEnd Time)
(declare-const l9_lEnd Time)
(declare-const l9 Time)
(declare-fun low2 (Trace) Int)
(declare-const t1 Trace)
(declare-const t2 Trace)
(declare-fun low1 (Time Trace) Int)
(declare-const l10 Time)
(declare-fun Sub (Nat Nat) Bool)
(assert (forall ((it Nat)) (Sub it (s it))) )
(assert (forall ((it1 Nat)(it2 Nat)) (=> (Sub it1 it2) (Sub it1 (s it2))) ))
(declare-fun high (Trace) Int)
(declare-const l13 Time)

(assert
   ;Semantics of function main
   (forall ((tr Trace))
      ;Semantics of IfElse at location l9
      (and
         ;Jumping into any branch doesn't change the variable values
         (and
            (= (low1 l10 tr) (low1 l9 tr))
            (= (low1 l13 tr) (low1 l9 tr))
         )
         ;The branching-condition determines which values to use after the if-statement
         (and
            (=>
               (> (high tr) 0)
               (= (low1 main_end tr) (low1 l9_lEnd tr))
            )
            (=>
               (not
                  (> (high tr) 0)
               )
               (= (low1 main_end tr) (low1 l9_rEnd tr))
            )
         )
         ;Update variable low1 at location l10
         (= (low1 l9_lEnd tr) (+ (low2 tr) (low2 tr)))
         ;Update variable low1 at location l13
         (= (low1 l9_rEnd tr) (* 2 (low2 tr)))
      )
   )
)

(assert
   ;Theory axiom: forall x y z. (x + y) + z) = (x + z) + y
   (forall ((xInt Int)(yInt Int)(zInt Int))
      (= (+ (+ xInt yInt) zInt) (+ (+ xInt zInt) yInt))
   )
)

; negated conjecture
(assert
   (not
      (=>
         (and
            (= (low1 l9 t1) (low1 l9 t2))
            (= (low2 t1) (low2 t2))
         )
         (= (low1 main_end t1) (low1 main_end t2))
      )
   )
)

(check-sat)

(exit)
