(set-info :smt-lib-version 2.6)
(set-logic UFDTLIA)
(set-info :source |
Generated by: Bernhard Gleiss
Generated on: 2019-3-11
Generator: Rapid
Application: Software Verification
Target solver: Vampire
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "crafted")
(set-info :status unknown)

(declare-datatypes ((Nat 0)) (( (zero) (s (p Nat)) )) )
(declare-sort Time 0)
(declare-sort Trace 0)
(declare-fun l14 (Nat) Time)
(declare-const main_end Time)
(declare-fun nl13 (Trace) Nat)
(declare-fun high2 (Time Trace) Int)
(declare-fun high1 (Time Trace) Int)
(declare-fun low2 (Trace) Int)
(declare-const t1 Trace)
(declare-const l17 Time)
(declare-const l10 Time)
(declare-const t2 Trace)
(declare-const l11 Time)
(declare-fun low1 (Time Trace) Int)
(declare-fun Sub (Nat Nat) Bool)
(assert (forall ((it Nat)) (Sub it (s it))) )
(assert (forall ((it1 Nat)(it2 Nat)) (=> (Sub it1 it2) (Sub it1 (s it2))) ))
(declare-fun l13 (Nat) Time)

(assert
   ;Semantics of function main
   (and
      (forall ((tr Trace))
         ;Update variable high2 at location l10
         (and
            (= (high2 l11 tr) (low1 l10 tr))
            (= (high1 l11 tr) (high1 l10 tr))
            (= (low1 l11 tr) (low1 l10 tr))
         )
      )
      (forall ((tr Trace))
         ;Update variable high1 at location l11
         (and
            (= (high1 (l13 zero) tr) (high2 l11 tr))
            (= (high2 (l13 zero) tr) (high2 l11 tr))
            (= (low1 (l13 zero) tr) (low1 l11 tr))
         )
      )
      (forall ((tr Trace))
         ;Loop at location l13
         (and
            ;Jumping into the body doesn't change the variable values
            (forall ((Itl13 Nat))
               (and
                  (= (high2 (l14 Itl13) tr) (high2 (l13 Itl13) tr))
                  (= (low1 (l14 Itl13) tr) (low1 (l13 Itl13) tr))
                  (= (high1 (l14 Itl13) tr) (high1 (l13 Itl13) tr))
               )
            )
            ;Semantics of the body
            (forall ((Itl13 Nat))
               ;Update variable high1 at location l14
               (and
                  (= (high1 (l13 (s Itl13)) tr) (+ (high1 (l14 Itl13) tr) 1))
                  (= (high2 (l13 (s Itl13)) tr) (high2 (l14 Itl13) tr))
                  (= (low1 (l13 (s Itl13)) tr) (low1 (l14 Itl13) tr))
               )
            )
            ;The loop-condition holds always before the last iteration
            (forall ((Itl13 Nat))
               (=>
                  (Sub Itl13 (nl13 tr))
                  (< (high2 (l13 Itl13) tr) (low2 tr))
               )
            )
            ;The loop-condition doesn't hold in the last iteration
            (not
               (< (high2 (l13 (nl13 tr)) tr) (low2 tr))
            )
            ;The values after the while-loop are the values from the last iteration
            (and
               (= (high2 l17 tr) (high2 (l13 (nl13 tr)) tr))
               (= (low1 l17 tr) (low1 (l13 (nl13 tr)) tr))
               (= (high1 l17 tr) (high1 (l13 (nl13 tr)) tr))
            )
         )
      )
      (forall ((tr Trace))
         ;Update variable low1 at location l17
         (and
            (= (low1 main_end tr) (high1 l17 tr))
            (= (high1 main_end tr) (high1 l17 tr))
            (= (high2 main_end tr) (high2 l17 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var high2 and location l13
      (=>
         (forall ((Itl13 Nat))
            (=>
               (Sub Itl13 (nl13 tr))
               (= (high2 (l13 Itl13) tr) (high2 (l13 (s Itl13)) tr))
            )
         )
         (= (high2 (l13 zero) tr) (high2 (l13 (nl13 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var low1 and location l13
      (=>
         (forall ((Itl13 Nat))
            (=>
               (Sub Itl13 (nl13 tr))
               (= (low1 (l13 Itl13) tr) (low1 (l13 (s Itl13)) tr))
            )
         )
         (= (low1 (l13 zero) tr) (low1 (l13 (nl13 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var high1 and location l13
      (=>
         (forall ((Itl13 Nat))
            (=>
               (Sub Itl13 (nl13 tr))
               (= (high1 (l13 Itl13) tr) (high1 (l13 (s Itl13)) tr))
            )
         )
         (= (high1 (l13 zero) tr) (high1 (l13 (nl13 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: if the condition of the loop at l13 holds initially, there is at least one loop iteration
      (=>
         (< (high2 (l13 zero) tr) (low2 tr))
         (exists ((Itl13 Nat))
            (= (s Itl13) (nl13 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var high2 at location l13
      (forall ((xInt Int)(Itl13 Nat))
         (=>
            (and
               (<= (high2 (l13 zero) tr) xInt)
               (< xInt (high2 (l13 (nl13 tr)) tr))
               (= (high2 (l13 (s Itl13)) tr) (+ (high2 (l13 Itl13) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (high2 (l13 it) tr) xInt)
                  (Sub it (nl13 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var low1 at location l13
      (forall ((xInt Int)(Itl13 Nat))
         (=>
            (and
               (<= (low1 (l13 zero) tr) xInt)
               (< xInt (low1 (l13 (nl13 tr)) tr))
               (= (low1 (l13 (s Itl13)) tr) (+ (low1 (l13 Itl13) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (low1 (l13 it) tr) xInt)
                  (Sub it (nl13 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var high1 at location l13
      (forall ((xInt Int)(Itl13 Nat))
         (=>
            (and
               (<= (high1 (l13 zero) tr) xInt)
               (< xInt (high1 (l13 (nl13 tr)) tr))
               (= (high1 (l13 (s Itl13)) tr) (+ (high1 (l13 Itl13) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (high1 (l13 it) tr) xInt)
                  (Sub it (nl13 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl13 Nat))
         (=>
            (and
               (Sub (s Itl13) (nl13 tr))
               (= (high2 (l13 (s Itl13)) tr) (+ (high2 (l13 Itl13) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (high2 (l13 it1) tr) (high2 (l13 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl13 Nat))
         (=>
            (and
               (Sub (s Itl13) (nl13 tr))
               (= (low1 (l13 (s Itl13)) tr) (+ (low1 (l13 Itl13) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (low1 (l13 it1) tr) (low1 (l13 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl13 Nat))
         (=>
            (and
               (Sub (s Itl13) (nl13 tr))
               (= (high1 (l13 (s Itl13)) tr) (+ (high1 (l13 Itl13) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (high1 (l13 it1) tr) (high1 (l13 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   ;Lemma: Var high2 at loop l13 has same values on both traces
   (=>
      (and
         (= (high2 (l13 zero) t1) (high2 (l13 zero) t2))
         (forall ((Itl13 Nat))
            (=>
               (= (high2 (l13 Itl13) t1) (high2 (l13 Itl13) t2))
               (= (high2 (l13 (s Itl13)) t1) (high2 (l13 (s Itl13)) t2))
            )
         )
      )
      (forall ((Itl13 Nat))
         (= (high2 (l13 Itl13) t1) (high2 (l13 Itl13) t2))
      )
   )
)

(assert
   ;Lemma: Var low1 at loop l13 has same values on both traces
   (=>
      (and
         (= (low1 (l13 zero) t1) (low1 (l13 zero) t2))
         (forall ((Itl13 Nat))
            (=>
               (= (low1 (l13 Itl13) t1) (low1 (l13 Itl13) t2))
               (= (low1 (l13 (s Itl13)) t1) (low1 (l13 (s Itl13)) t2))
            )
         )
      )
      (forall ((Itl13 Nat))
         (= (low1 (l13 Itl13) t1) (low1 (l13 Itl13) t2))
      )
   )
)

(assert
   ;Lemma: Var high1 at loop l13 has same values on both traces
   (=>
      (and
         (= (high1 (l13 zero) t1) (high1 (l13 zero) t2))
         (forall ((Itl13 Nat))
            (=>
               (= (high1 (l13 Itl13) t1) (high1 (l13 Itl13) t2))
               (= (high1 (l13 (s Itl13)) t1) (high1 (l13 (s Itl13)) t2))
            )
         )
      )
      (forall ((Itl13 Nat))
         (= (high1 (l13 Itl13) t1) (high1 (l13 Itl13) t2))
      )
   )
)

(assert
   ;Lemma: If nl13(t2) has same properties as nl13(t1), then nl13(t2)=nl13(t1) (for loop at l13)
   (=>
      (and
         (forall ((Itl13 Nat))
            (=>
               (Sub Itl13 (nl13 t2))
               (< (high2 (l13 Itl13) t1) (low2 t1))
            )
         )
         (not
            (< (high2 (l13 (nl13 t2)) t1) (low2 t1))
         )
      )
      (= (nl13 t2) (nl13 t1))
   )
)

(assert
   ;Lemma: Equality preservation over traces for var high2 at location l13
   (forall ((itR Nat))
      (=>
         (and
            (= (high2 (l13 zero) t1) (high2 (l13 zero) t2))
            (forall ((Itl13 Nat))
               (=>
                  (and
                     (Sub Itl13 itR)
                     (= (high2 (l13 Itl13) t1) (high2 (l13 Itl13) t2))
                  )
                  (= (high2 (l13 (s Itl13)) t1) (high2 (l13 (s Itl13)) t2))
               )
            )
         )
         (= (high2 (l13 itR) t1) (high2 (l13 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var low1 at location l13
   (forall ((itR Nat))
      (=>
         (and
            (= (low1 (l13 zero) t1) (low1 (l13 zero) t2))
            (forall ((Itl13 Nat))
               (=>
                  (and
                     (Sub Itl13 itR)
                     (= (low1 (l13 Itl13) t1) (low1 (l13 Itl13) t2))
                  )
                  (= (low1 (l13 (s Itl13)) t1) (low1 (l13 (s Itl13)) t2))
               )
            )
         )
         (= (low1 (l13 itR) t1) (low1 (l13 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var high1 at location l13
   (forall ((itR Nat))
      (=>
         (and
            (= (high1 (l13 zero) t1) (high1 (l13 zero) t2))
            (forall ((Itl13 Nat))
               (=>
                  (and
                     (Sub Itl13 itR)
                     (= (high1 (l13 Itl13) t1) (high1 (l13 Itl13) t2))
                  )
                  (= (high1 (l13 (s Itl13)) t1) (high1 (l13 (s Itl13)) t2))
               )
            )
         )
         (= (high1 (l13 itR) t1) (high1 (l13 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var high2 at location l13
   (forall ((itL Nat))
      (=>
         (and
            (= (high2 (l13 itL) t1) (high2 (l13 itL) t2))
            (forall ((Itl13 Nat))
               (=>
                  (and
                     (Sub itL (s Itl13))
                     (Sub Itl13 (nl13 t1))
                     (= (high2 (l13 Itl13) t1) (high2 (l13 Itl13) t2))
                  )
                  (= (high2 (l13 (s Itl13)) t1) (high2 (l13 (s Itl13)) t2))
               )
            )
            (= (l13 (nl13 t1)) (l13 (nl13 t2)))
         )
         (= (high2 (l13 (nl13 t1)) t1) (high2 (l13 (nl13 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var low1 at location l13
   (forall ((itL Nat))
      (=>
         (and
            (= (low1 (l13 itL) t1) (low1 (l13 itL) t2))
            (forall ((Itl13 Nat))
               (=>
                  (and
                     (Sub itL (s Itl13))
                     (Sub Itl13 (nl13 t1))
                     (= (low1 (l13 Itl13) t1) (low1 (l13 Itl13) t2))
                  )
                  (= (low1 (l13 (s Itl13)) t1) (low1 (l13 (s Itl13)) t2))
               )
            )
            (= (l13 (nl13 t1)) (l13 (nl13 t2)))
         )
         (= (low1 (l13 (nl13 t1)) t1) (low1 (l13 (nl13 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var high1 at location l13
   (forall ((itL Nat))
      (=>
         (and
            (= (high1 (l13 itL) t1) (high1 (l13 itL) t2))
            (forall ((Itl13 Nat))
               (=>
                  (and
                     (Sub itL (s Itl13))
                     (Sub Itl13 (nl13 t1))
                     (= (high1 (l13 Itl13) t1) (high1 (l13 Itl13) t2))
                  )
                  (= (high1 (l13 (s Itl13)) t1) (high1 (l13 (s Itl13)) t2))
               )
            )
            (= (l13 (nl13 t1)) (l13 (nl13 t2)))
         )
         (= (high1 (l13 (nl13 t1)) t1) (high1 (l13 (nl13 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var high2 at location l13
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (high2 (l13 zero) t1) (high2 (l13 zero) t2))
            (forall ((tr3 Trace)(Itl13 Nat))
               (= (high2 (l13 (s Itl13)) tr3) (+ (high2 (l13 Itl13) tr3) 1))
            )
         )
         (< (high2 (l13 it1) tr) (high2 (l13 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var low1 at location l13
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (low1 (l13 zero) t1) (low1 (l13 zero) t2))
            (forall ((tr3 Trace)(Itl13 Nat))
               (= (low1 (l13 (s Itl13)) tr3) (+ (low1 (l13 Itl13) tr3) 1))
            )
         )
         (< (low1 (l13 it1) tr) (low1 (l13 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var high1 at location l13
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (high1 (l13 zero) t1) (high1 (l13 zero) t2))
            (forall ((tr3 Trace)(Itl13 Nat))
               (= (high1 (l13 (s Itl13)) tr3) (+ (high1 (l13 Itl13) tr3) 1))
            )
         )
         (< (high1 (l13 it1) tr) (high1 (l13 it2) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Static analysis lemma for var high2 at location l13
      (forall ((Itl13 Nat))
         (= (high2 (l13 Itl13) tr) (high2 (l13 zero) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Static analysis lemma for var low1 at location l13
      (forall ((Itl13 Nat))
         (= (low1 (l13 Itl13) tr) (low1 (l13 zero) tr))
      )
   )
)

(assert
   ;Theory axiom: forall x y z. (x + y) + z) = (x + z) + y
   (forall ((xInt Int)(yInt Int)(zInt Int))
      (= (+ (+ xInt yInt) zInt) (+ (+ xInt zInt) yInt))
   )
)

; negated conjecture
(assert
   (not
      (=>
         (and
            (= (low1 l10 t1) (low1 l10 t2))
            (= (low2 t1) (low2 t2))
         )
         (= (low1 main_end t1) (low1 main_end t2))
      )
   )
)

(check-sat)

(exit)
