(set-info :smt-lib-version 2.6)
(set-logic UFDTLIA)
(set-info :source |
Generated by: Bernhard Gleiss
Generated on: 2019-3-11
Generator: Rapid
Application: Software Verification
Target solver: Vampire
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "crafted")
(set-info :status unknown)

(declare-datatypes ((Nat 0)) (( (zero) (s (p Nat)) )) )
(declare-sort Time 0)
(declare-sort Trace 0)
(declare-const main_end Time)
(declare-fun dec (Time Trace) Int)
(declare-const t1 Trace)
(declare-fun l10 (Nat) Time)
(declare-const t2 Trace)
(declare-fun nl10 (Trace) Nat)
(declare-fun lo (Time Trace) Int)
(declare-fun l12 (Nat) Time)
(declare-fun Sub (Nat Nat) Bool)
(assert (forall ((it Nat)) (Sub it (s it))) )
(assert (forall ((it1 Nat)(it2 Nat)) (=> (Sub it1 it2) (Sub it1 (s it2))) ))
(declare-fun l14 (Nat) Time)
(declare-fun hi (Time Trace) Int)
(declare-fun l13 (Nat) Time)

(assert
   ;Semantics of function main
   (forall ((tr Trace))
      ;Loop at location l10
      (and
         ;Jumping into the body doesn't change the variable values
         (forall ((Itl10 Nat))
            (and
               (= (dec (l12 Itl10) tr) (dec (l10 Itl10) tr))
               (= (lo (l12 Itl10) tr) (lo (l10 Itl10) tr))
               (= (hi (l12 Itl10) tr) (hi (l10 Itl10) tr))
            )
         )
         ;Semantics of the body
         (forall ((Itl10 Nat))
            (and
               ;Update variable hi at location l12
               (and
                  (= (hi (l13 Itl10) tr) (+ (lo (l12 Itl10) tr) 1))
                  (= (lo (l13 Itl10) tr) (lo (l12 Itl10) tr))
                  (= (dec (l13 Itl10) tr) (dec (l12 Itl10) tr))
               )
               ;Update variable lo at location l13
               (and
                  (= (lo (l14 Itl10) tr) (+ (hi (l13 Itl10) tr) 1))
                  (= (hi (l14 Itl10) tr) (hi (l13 Itl10) tr))
                  (= (dec (l14 Itl10) tr) (dec (l13 Itl10) tr))
               )
               ;Update variable dec at location l14
               (and
                  (= (dec (l10 (s Itl10)) tr) (- (dec (l14 Itl10) tr) 1))
                  (= (hi (l10 (s Itl10)) tr) (hi (l14 Itl10) tr))
                  (= (lo (l10 (s Itl10)) tr) (lo (l14 Itl10) tr))
               )
            )
         )
         ;The loop-condition holds always before the last iteration
         (forall ((Itl10 Nat))
            (=>
               (Sub Itl10 (nl10 tr))
               (not
                  (= (dec (l10 Itl10) tr) 0)
               )
            )
         )
         ;The loop-condition doesn't hold in the last iteration
         (not
            (not
               (= (dec (l10 (nl10 tr)) tr) 0)
            )
         )
         ;The values after the while-loop are the values from the last iteration
         (and
            (= (dec main_end tr) (dec (l10 (nl10 tr)) tr))
            (= (lo main_end tr) (lo (l10 (nl10 tr)) tr))
            (= (hi main_end tr) (hi (l10 (nl10 tr)) tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var dec and location l10
      (=>
         (forall ((Itl10 Nat))
            (=>
               (Sub Itl10 (nl10 tr))
               (= (dec (l10 Itl10) tr) (dec (l10 (s Itl10)) tr))
            )
         )
         (= (dec (l10 zero) tr) (dec (l10 (nl10 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var lo and location l10
      (=>
         (forall ((Itl10 Nat))
            (=>
               (Sub Itl10 (nl10 tr))
               (= (lo (l10 Itl10) tr) (lo (l10 (s Itl10)) tr))
            )
         )
         (= (lo (l10 zero) tr) (lo (l10 (nl10 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var hi and location l10
      (=>
         (forall ((Itl10 Nat))
            (=>
               (Sub Itl10 (nl10 tr))
               (= (hi (l10 Itl10) tr) (hi (l10 (s Itl10)) tr))
            )
         )
         (= (hi (l10 zero) tr) (hi (l10 (nl10 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: if the condition of the loop at l10 holds initially, there is at least one loop iteration
      (=>
         (not
            (= (dec (l10 zero) tr) 0)
         )
         (exists ((Itl10 Nat))
            (= (s Itl10) (nl10 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var dec at location l10
      (forall ((xInt Int)(Itl10 Nat))
         (=>
            (and
               (<= (dec (l10 zero) tr) xInt)
               (< xInt (dec (l10 (nl10 tr)) tr))
               (= (dec (l10 (s Itl10)) tr) (+ (dec (l10 Itl10) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (dec (l10 it) tr) xInt)
                  (Sub it (nl10 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var lo at location l10
      (forall ((xInt Int)(Itl10 Nat))
         (=>
            (and
               (<= (lo (l10 zero) tr) xInt)
               (< xInt (lo (l10 (nl10 tr)) tr))
               (= (lo (l10 (s Itl10)) tr) (+ (lo (l10 Itl10) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (lo (l10 it) tr) xInt)
                  (Sub it (nl10 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var hi at location l10
      (forall ((xInt Int)(Itl10 Nat))
         (=>
            (and
               (<= (hi (l10 zero) tr) xInt)
               (< xInt (hi (l10 (nl10 tr)) tr))
               (= (hi (l10 (s Itl10)) tr) (+ (hi (l10 Itl10) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (hi (l10 it) tr) xInt)
                  (Sub it (nl10 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl10 Nat))
         (=>
            (and
               (Sub (s Itl10) (nl10 tr))
               (= (dec (l10 (s Itl10)) tr) (+ (dec (l10 Itl10) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (dec (l10 it1) tr) (dec (l10 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl10 Nat))
         (=>
            (and
               (Sub (s Itl10) (nl10 tr))
               (= (lo (l10 (s Itl10)) tr) (+ (lo (l10 Itl10) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (lo (l10 it1) tr) (lo (l10 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl10 Nat))
         (=>
            (and
               (Sub (s Itl10) (nl10 tr))
               (= (hi (l10 (s Itl10)) tr) (+ (hi (l10 Itl10) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (hi (l10 it1) tr) (hi (l10 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   ;Lemma: Var dec at loop l10 has same values on both traces
   (=>
      (and
         (= (dec (l10 zero) t1) (dec (l10 zero) t2))
         (forall ((Itl10 Nat))
            (=>
               (= (dec (l10 Itl10) t1) (dec (l10 Itl10) t2))
               (= (dec (l10 (s Itl10)) t1) (dec (l10 (s Itl10)) t2))
            )
         )
      )
      (forall ((Itl10 Nat))
         (= (dec (l10 Itl10) t1) (dec (l10 Itl10) t2))
      )
   )
)

(assert
   ;Lemma: Var lo at loop l10 has same values on both traces
   (=>
      (and
         (= (lo (l10 zero) t1) (lo (l10 zero) t2))
         (forall ((Itl10 Nat))
            (=>
               (= (lo (l10 Itl10) t1) (lo (l10 Itl10) t2))
               (= (lo (l10 (s Itl10)) t1) (lo (l10 (s Itl10)) t2))
            )
         )
      )
      (forall ((Itl10 Nat))
         (= (lo (l10 Itl10) t1) (lo (l10 Itl10) t2))
      )
   )
)

(assert
   ;Lemma: Var hi at loop l10 has same values on both traces
   (=>
      (and
         (= (hi (l10 zero) t1) (hi (l10 zero) t2))
         (forall ((Itl10 Nat))
            (=>
               (= (hi (l10 Itl10) t1) (hi (l10 Itl10) t2))
               (= (hi (l10 (s Itl10)) t1) (hi (l10 (s Itl10)) t2))
            )
         )
      )
      (forall ((Itl10 Nat))
         (= (hi (l10 Itl10) t1) (hi (l10 Itl10) t2))
      )
   )
)

(assert
   ;Lemma: If nl10(t2) has same properties as nl10(t1), then nl10(t2)=nl10(t1) (for loop at l10)
   (=>
      (and
         (forall ((Itl10 Nat))
            (=>
               (Sub Itl10 (nl10 t2))
               (not
                  (= (dec (l10 Itl10) t1) 0)
               )
            )
         )
         (not
            (not
               (= (dec (l10 (nl10 t2)) t1) 0)
            )
         )
      )
      (= (nl10 t2) (nl10 t1))
   )
)

(assert
   ;Lemma: Equality preservation over traces for var dec at location l10
   (forall ((itR Nat))
      (=>
         (and
            (= (dec (l10 zero) t1) (dec (l10 zero) t2))
            (forall ((Itl10 Nat))
               (=>
                  (and
                     (Sub Itl10 itR)
                     (= (dec (l10 Itl10) t1) (dec (l10 Itl10) t2))
                  )
                  (= (dec (l10 (s Itl10)) t1) (dec (l10 (s Itl10)) t2))
               )
            )
         )
         (= (dec (l10 itR) t1) (dec (l10 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var lo at location l10
   (forall ((itR Nat))
      (=>
         (and
            (= (lo (l10 zero) t1) (lo (l10 zero) t2))
            (forall ((Itl10 Nat))
               (=>
                  (and
                     (Sub Itl10 itR)
                     (= (lo (l10 Itl10) t1) (lo (l10 Itl10) t2))
                  )
                  (= (lo (l10 (s Itl10)) t1) (lo (l10 (s Itl10)) t2))
               )
            )
         )
         (= (lo (l10 itR) t1) (lo (l10 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var hi at location l10
   (forall ((itR Nat))
      (=>
         (and
            (= (hi (l10 zero) t1) (hi (l10 zero) t2))
            (forall ((Itl10 Nat))
               (=>
                  (and
                     (Sub Itl10 itR)
                     (= (hi (l10 Itl10) t1) (hi (l10 Itl10) t2))
                  )
                  (= (hi (l10 (s Itl10)) t1) (hi (l10 (s Itl10)) t2))
               )
            )
         )
         (= (hi (l10 itR) t1) (hi (l10 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var dec at location l10
   (forall ((itL Nat))
      (=>
         (and
            (= (dec (l10 itL) t1) (dec (l10 itL) t2))
            (forall ((Itl10 Nat))
               (=>
                  (and
                     (Sub itL (s Itl10))
                     (Sub Itl10 (nl10 t1))
                     (= (dec (l10 Itl10) t1) (dec (l10 Itl10) t2))
                  )
                  (= (dec (l10 (s Itl10)) t1) (dec (l10 (s Itl10)) t2))
               )
            )
            (= (l10 (nl10 t1)) (l10 (nl10 t2)))
         )
         (= (dec (l10 (nl10 t1)) t1) (dec (l10 (nl10 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var lo at location l10
   (forall ((itL Nat))
      (=>
         (and
            (= (lo (l10 itL) t1) (lo (l10 itL) t2))
            (forall ((Itl10 Nat))
               (=>
                  (and
                     (Sub itL (s Itl10))
                     (Sub Itl10 (nl10 t1))
                     (= (lo (l10 Itl10) t1) (lo (l10 Itl10) t2))
                  )
                  (= (lo (l10 (s Itl10)) t1) (lo (l10 (s Itl10)) t2))
               )
            )
            (= (l10 (nl10 t1)) (l10 (nl10 t2)))
         )
         (= (lo (l10 (nl10 t1)) t1) (lo (l10 (nl10 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var hi at location l10
   (forall ((itL Nat))
      (=>
         (and
            (= (hi (l10 itL) t1) (hi (l10 itL) t2))
            (forall ((Itl10 Nat))
               (=>
                  (and
                     (Sub itL (s Itl10))
                     (Sub Itl10 (nl10 t1))
                     (= (hi (l10 Itl10) t1) (hi (l10 Itl10) t2))
                  )
                  (= (hi (l10 (s Itl10)) t1) (hi (l10 (s Itl10)) t2))
               )
            )
            (= (l10 (nl10 t1)) (l10 (nl10 t2)))
         )
         (= (hi (l10 (nl10 t1)) t1) (hi (l10 (nl10 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var dec at location l10
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (dec (l10 zero) t1) (dec (l10 zero) t2))
            (forall ((tr3 Trace)(Itl10 Nat))
               (= (dec (l10 (s Itl10)) tr3) (+ (dec (l10 Itl10) tr3) 1))
            )
         )
         (< (dec (l10 it1) tr) (dec (l10 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var lo at location l10
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (lo (l10 zero) t1) (lo (l10 zero) t2))
            (forall ((tr3 Trace)(Itl10 Nat))
               (= (lo (l10 (s Itl10)) tr3) (+ (lo (l10 Itl10) tr3) 1))
            )
         )
         (< (lo (l10 it1) tr) (lo (l10 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var hi at location l10
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (hi (l10 zero) t1) (hi (l10 zero) t2))
            (forall ((tr3 Trace)(Itl10 Nat))
               (= (hi (l10 (s Itl10)) tr3) (+ (hi (l10 Itl10) tr3) 1))
            )
         )
         (< (hi (l10 it1) tr) (hi (l10 it2) tr))
      )
   )
)

(assert
   ;Theory axiom: forall x y z. (x + y) + z) = (x + z) + y
   (forall ((xInt Int)(yInt Int)(zInt Int))
      (= (+ (+ xInt yInt) zInt) (+ (+ xInt zInt) yInt))
   )
)

; negated conjecture
(assert
   (not
      (=>
         (and
            (forall ((tr Trace))
               (> (dec (l10 zero) tr) 0)
            )
            (= (dec (l10 zero) t1) (dec (l10 zero) t2))
            (= (lo (l10 zero) t1) (lo (l10 zero) t2))
         )
         (= (lo main_end t1) (lo main_end t2))
      )
   )
)

(check-sat)

(exit)
