(set-info :smt-lib-version 2.6)
(set-logic UFDTLIA)
(set-info :source |
Generated by: Bernhard Gleiss
Generated on: 2019-3-11
Generator: Rapid
Application: Software Verification
Target solver: Vampire
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "crafted")
(set-info :status unknown)

(declare-datatypes ((Nat 0)) (( (zero) (s (p Nat)) )) )
(declare-sort Time 0)
(declare-sort Trace 0)
(declare-const main_end Time)
(declare-fun l15 (Nat) Time)
(declare-fun l13 (Nat) Time)
(declare-const l8 Time)
(declare-fun output (Time Int Trace) Int)
(declare-const t1 Trace)
(declare-const t2 Trace)
(declare-fun k (Trace) Int)
(declare-fun l11 (Nat) Time)
(declare-fun nl11 (Trace) Nat)
(declare-fun lo (Trace) Int)
(declare-const l7 Time)
(declare-fun l14 (Nat) Time)
(declare-fun hi (Time Trace) Int)
(declare-fun i (Time Trace) Int)
(declare-fun Sub (Nat Nat) Bool)
(assert (forall ((it Nat)) (Sub it (s it))) )
(assert (forall ((it1 Nat)(it2 Nat)) (=> (Sub it1 it2) (Sub it1 (s it2))) ))

(assert
   ;Semantics of function main
   (and
      (forall ((tr Trace))
         ;Update variable hi at location l7
         (= (hi l8 tr) (lo tr))
      )
      (forall ((tr Trace))
         ;Update variable i at location l8
         (and
            (= (i (l11 zero) tr) 0)
            (= (hi (l11 zero) tr) (hi l8 tr))
         )
      )
      (forall ((tr Trace))
         ;Loop at location l11
         (and
            ;Jumping into the body doesn't change the variable values
            (forall ((Itl11 Nat))
               (and
                  (= (hi (l13 Itl11) tr) (hi (l11 Itl11) tr))
                  (= (i (l13 Itl11) tr) (i (l11 Itl11) tr))
                  (forall ((pos Int))
                     (= (output (l13 Itl11) pos tr) (output (l11 Itl11) pos tr))
                  )
               )
            )
            ;Semantics of the body
            (forall ((Itl11 Nat))
               (and
                  ;Update array variable output at location l13
                  (and
                     (= (output (l14 Itl11) (i (l13 Itl11) tr) tr) (hi (l13 Itl11) tr))
                     (forall ((pos Int))
                        (=>
                           (not
                              (= pos (i (l13 Itl11) tr))
                           )
                           (= (output (l14 Itl11) pos tr) (output (l13 Itl11) pos tr))
                        )
                     )
                     (= (i (l14 Itl11) tr) (i (l13 Itl11) tr))
                     (= (hi (l14 Itl11) tr) (hi (l13 Itl11) tr))
                  )
                  ;Update variable hi at location l14
                  (and
                     (= (hi (l15 Itl11) tr) (+ (hi (l14 Itl11) tr) 1))
                     (= (i (l15 Itl11) tr) (i (l14 Itl11) tr))
                     (forall ((pos Int))
                        (= (output (l15 Itl11) pos tr) (output (l14 Itl11) pos tr))
                     )
                  )
                  ;Update variable i at location l15
                  (and
                     (= (i (l11 (s Itl11)) tr) (+ (i (l15 Itl11) tr) 1))
                     (= (hi (l11 (s Itl11)) tr) (hi (l15 Itl11) tr))
                     (forall ((pos Int))
                        (= (output (l11 (s Itl11)) pos tr) (output (l15 Itl11) pos tr))
                     )
                  )
               )
            )
            ;The loop-condition holds always before the last iteration
            (forall ((Itl11 Nat))
               (=>
                  (Sub Itl11 (nl11 tr))
                  (< (hi (l11 Itl11) tr) (k tr))
               )
            )
            ;The loop-condition doesn't hold in the last iteration
            (not
               (< (hi (l11 (nl11 tr)) tr) (k tr))
            )
            ;The values after the while-loop are the values from the last iteration
            (and
               (= (hi main_end tr) (hi (l11 (nl11 tr)) tr))
               (= (i main_end tr) (i (l11 (nl11 tr)) tr))
               (forall ((pos Int))
                  (= (output main_end pos tr) (output (l11 (nl11 tr)) pos tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var hi and location l11
      (=>
         (forall ((Itl11 Nat))
            (=>
               (Sub Itl11 (nl11 tr))
               (= (hi (l11 Itl11) tr) (hi (l11 (s Itl11)) tr))
            )
         )
         (= (hi (l11 zero) tr) (hi (l11 (nl11 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var i and location l11
      (=>
         (forall ((Itl11 Nat))
            (=>
               (Sub Itl11 (nl11 tr))
               (= (i (l11 Itl11) tr) (i (l11 (s Itl11)) tr))
            )
         )
         (= (i (l11 zero) tr) (i (l11 (nl11 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for array var output and location l11
      (forall ((pos Int))
         (=>
            (forall ((Itl11 Nat))
               (=>
                  (Sub Itl11 (nl11 tr))
                  (= (output (l11 Itl11) pos tr) (output (l11 (s Itl11)) pos tr))
               )
            )
            (= (output (l11 zero) pos tr) (output (l11 (nl11 tr)) pos tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: if the condition of the loop at l11 holds initially, there is at least one loop iteration
      (=>
         (< (hi (l11 zero) tr) (k tr))
         (exists ((Itl11 Nat))
            (= (s Itl11) (nl11 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var hi at location l11
      (forall ((xInt Int)(Itl11 Nat))
         (=>
            (and
               (<= (hi (l11 zero) tr) xInt)
               (< xInt (hi (l11 (nl11 tr)) tr))
               (= (hi (l11 (s Itl11)) tr) (+ (hi (l11 Itl11) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (hi (l11 it) tr) xInt)
                  (Sub it (nl11 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var i at location l11
      (forall ((xInt Int)(Itl11 Nat))
         (=>
            (and
               (<= (i (l11 zero) tr) xInt)
               (< xInt (i (l11 (nl11 tr)) tr))
               (= (i (l11 (s Itl11)) tr) (+ (i (l11 Itl11) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (i (l11 it) tr) xInt)
                  (Sub it (nl11 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for array var output at location l11
      (forall ((xInt Int)(Itl11 Nat)(pos Int))
         (=>
            (and
               (<= (output (l11 zero) pos tr) xInt)
               (< xInt (output (l11 (nl11 tr)) pos tr))
               (= (output (l11 (s Itl11)) pos tr) (+ (output (l11 Itl11) pos tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (output (l11 it) pos tr) xInt)
                  (Sub it (nl11 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl11 Nat))
         (=>
            (and
               (Sub (s Itl11) (nl11 tr))
               (= (hi (l11 (s Itl11)) tr) (+ (hi (l11 Itl11) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (hi (l11 it1) tr) (hi (l11 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl11 Nat))
         (=>
            (and
               (Sub (s Itl11) (nl11 tr))
               (= (i (l11 (s Itl11)) tr) (+ (i (l11 Itl11) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (i (l11 it1) tr) (i (l11 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   ;Lemma: Var hi at loop l11 has same values on both traces
   (=>
      (and
         (= (hi (l11 zero) t1) (hi (l11 zero) t2))
         (forall ((Itl11 Nat))
            (=>
               (= (hi (l11 Itl11) t1) (hi (l11 Itl11) t2))
               (= (hi (l11 (s Itl11)) t1) (hi (l11 (s Itl11)) t2))
            )
         )
      )
      (forall ((Itl11 Nat))
         (= (hi (l11 Itl11) t1) (hi (l11 Itl11) t2))
      )
   )
)

(assert
   ;Lemma: Var i at loop l11 has same values on both traces
   (=>
      (and
         (= (i (l11 zero) t1) (i (l11 zero) t2))
         (forall ((Itl11 Nat))
            (=>
               (= (i (l11 Itl11) t1) (i (l11 Itl11) t2))
               (= (i (l11 (s Itl11)) t1) (i (l11 (s Itl11)) t2))
            )
         )
      )
      (forall ((Itl11 Nat))
         (= (i (l11 Itl11) t1) (i (l11 Itl11) t2))
      )
   )
)

(assert
   ;Lemma: Array var output at loop l11 has same values on both traces
   (forall ((pos Int))
      (=>
         (and
            (= (output (l11 zero) pos t1) (output (l11 zero) pos t2))
            (forall ((Itl11 Nat))
               (=>
                  (= (output (l11 Itl11) pos t1) (output (l11 Itl11) pos t2))
                  (= (output (l11 (s Itl11)) pos t1) (output (l11 (s Itl11)) pos t2))
               )
            )
         )
         (forall ((Itl11 Nat))
            (= (output (l11 Itl11) pos t1) (output (l11 Itl11) pos t2))
         )
      )
   )
)

(assert
   ;Lemma: If nl11(t2) has same properties as nl11(t1), then nl11(t2)=nl11(t1) (for loop at l11)
   (=>
      (and
         (forall ((Itl11 Nat))
            (=>
               (Sub Itl11 (nl11 t2))
               (< (hi (l11 Itl11) t1) (k t1))
            )
         )
         (not
            (< (hi (l11 (nl11 t2)) t1) (k t1))
         )
      )
      (= (nl11 t2) (nl11 t1))
   )
)

(assert
   ;Lemma: Equality preservation over traces for var hi at location l11
   (forall ((itR Nat))
      (=>
         (and
            (= (hi (l11 zero) t1) (hi (l11 zero) t2))
            (forall ((Itl11 Nat))
               (=>
                  (and
                     (Sub Itl11 itR)
                     (= (hi (l11 Itl11) t1) (hi (l11 Itl11) t2))
                  )
                  (= (hi (l11 (s Itl11)) t1) (hi (l11 (s Itl11)) t2))
               )
            )
         )
         (= (hi (l11 itR) t1) (hi (l11 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l11
   (forall ((itR Nat))
      (=>
         (and
            (= (i (l11 zero) t1) (i (l11 zero) t2))
            (forall ((Itl11 Nat))
               (=>
                  (and
                     (Sub Itl11 itR)
                     (= (i (l11 Itl11) t1) (i (l11 Itl11) t2))
                  )
                  (= (i (l11 (s Itl11)) t1) (i (l11 (s Itl11)) t2))
               )
            )
         )
         (= (i (l11 itR) t1) (i (l11 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for array var output at location l11
   (forall ((pos Int))
      ;Lemma: Equality preservation over traces for array var output at location l11
      (forall ((itR Nat))
         (=>
            (and
               (= (output (l11 zero) pos t1) (output (l11 zero) pos t2))
               (forall ((Itl11 Nat))
                  (=>
                     (and
                        (Sub Itl11 itR)
                        (= (output (l11 Itl11) pos t1) (output (l11 Itl11) pos t2))
                     )
                     (= (output (l11 (s Itl11)) pos t1) (output (l11 (s Itl11)) pos t2))
                  )
               )
            )
            (= (output (l11 itR) pos t1) (output (l11 itR) pos t2))
         )
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var hi at location l11
   (forall ((itL Nat))
      (=>
         (and
            (= (hi (l11 itL) t1) (hi (l11 itL) t2))
            (forall ((Itl11 Nat))
               (=>
                  (and
                     (Sub itL (s Itl11))
                     (Sub Itl11 (nl11 t1))
                     (= (hi (l11 Itl11) t1) (hi (l11 Itl11) t2))
                  )
                  (= (hi (l11 (s Itl11)) t1) (hi (l11 (s Itl11)) t2))
               )
            )
            (= (l11 (nl11 t1)) (l11 (nl11 t2)))
         )
         (= (hi (l11 (nl11 t1)) t1) (hi (l11 (nl11 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l11
   (forall ((itL Nat))
      (=>
         (and
            (= (i (l11 itL) t1) (i (l11 itL) t2))
            (forall ((Itl11 Nat))
               (=>
                  (and
                     (Sub itL (s Itl11))
                     (Sub Itl11 (nl11 t1))
                     (= (i (l11 Itl11) t1) (i (l11 Itl11) t2))
                  )
                  (= (i (l11 (s Itl11)) t1) (i (l11 (s Itl11)) t2))
               )
            )
            (= (l11 (nl11 t1)) (l11 (nl11 t2)))
         )
         (= (i (l11 (nl11 t1)) t1) (i (l11 (nl11 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for array var output at location l11
   (forall ((pos Int))
      ;Lemma: Equality preservation over traces for array var output at location l11
      (forall ((itL Nat))
         (=>
            (and
               (= (output (l11 itL) pos t1) (output (l11 itL) pos t2))
               (forall ((Itl11 Nat))
                  (=>
                     (and
                        (Sub itL (s Itl11))
                        (Sub Itl11 (nl11 t1))
                        (= (output (l11 Itl11) pos t1) (output (l11 Itl11) pos t2))
                     )
                     (= (output (l11 (s Itl11)) pos t1) (output (l11 (s Itl11)) pos t2))
                  )
               )
               (= (l11 (nl11 t1)) (l11 (nl11 t2)))
            )
            (= (output (l11 (nl11 t1)) pos t1) (output (l11 (nl11 t1)) pos t2))
         )
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var hi at location l11
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (hi (l11 zero) t1) (hi (l11 zero) t2))
            (forall ((tr3 Trace)(Itl11 Nat))
               (= (hi (l11 (s Itl11)) tr3) (+ (hi (l11 Itl11) tr3) 1))
            )
         )
         (< (hi (l11 it1) tr) (hi (l11 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var i at location l11
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (i (l11 zero) t1) (i (l11 zero) t2))
            (forall ((tr3 Trace)(Itl11 Nat))
               (= (i (l11 (s Itl11)) tr3) (+ (i (l11 Itl11) tr3) 1))
            )
         )
         (< (i (l11 it1) tr) (i (l11 it2) tr))
      )
   )
)

(assert
   ;Theory axiom: forall x y z. (x + y) + z) = (x + z) + y
   (forall ((xInt Int)(yInt Int)(zInt Int))
      (= (+ (+ xInt yInt) zInt) (+ (+ xInt zInt) yInt))
   )
)

; negated conjecture
(assert
   (not
      (=>
         (and
            (= (k t1) (k t2))
            (= (lo t1) (lo t2))
            (forall ((pos Int))
               (= (output (l11 zero) pos t1) (output (l11 zero) pos t2))
            )
         )
         (forall ((pos Int))
            (= (output main_end pos t1) (output main_end pos t2))
         )
      )
   )
)

(check-sat)

(exit)
