(set-info :smt-lib-version 2.6)
(set-logic UFDTLIA)
(set-info :source |
Generated by: Bernhard Gleiss
Generated on: 2019-3-11
Generator: Rapid
Application: Software Verification
Target solver: Vampire
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "crafted")
(set-info :status unknown)

(declare-datatypes ((Nat 0)) (( (zero) (s (p Nat)) )) )
(declare-sort Time 0)
(declare-sort Trace 0)
(declare-const main_end Time)
(declare-const l9 Time)
(declare-fun x (Time Trace) Int)
(declare-fun alength (Trace) Int)
(declare-const t1 Trace)
(declare-const t2 Trace)
(declare-fun l11 (Nat) Time)
(declare-fun nl11 (Trace) Nat)
(declare-fun a (Int Trace) Int)
(declare-fun l13 (Nat) Time)
(declare-const l8 Time)
(declare-fun l14 (Nat) Time)
(declare-fun i (Time Trace) Int)
(declare-fun Sub (Nat Nat) Bool)
(assert (forall ((it Nat)) (Sub it (s it))) )
(assert (forall ((it1 Nat)(it2 Nat)) (=> (Sub it1 it2) (Sub it1 (s it2))) ))

(assert
   ;Semantics of function main
   (and
      (forall ((tr Trace))
         ;Update variable x at location l8
         (= (x l9 tr) 0)
      )
      (forall ((tr Trace))
         ;Update variable i at location l9
         (and
            (= (i (l11 zero) tr) 0)
            (= (x (l11 zero) tr) (x l9 tr))
         )
      )
      (forall ((tr Trace))
         ;Loop at location l11
         (and
            ;Jumping into the body doesn't change the variable values
            (forall ((Itl11 Nat))
               (and
                  (= (i (l13 Itl11) tr) (i (l11 Itl11) tr))
                  (= (x (l13 Itl11) tr) (x (l11 Itl11) tr))
               )
            )
            ;Semantics of the body
            (forall ((Itl11 Nat))
               (and
                  ;Update variable x at location l13
                  (and
                     (= (x (l14 Itl11) tr) (+ (x (l13 Itl11) tr) (a (i (l13 Itl11) tr) tr)))
                     (= (i (l14 Itl11) tr) (i (l13 Itl11) tr))
                  )
                  ;Update variable i at location l14
                  (and
                     (= (i (l11 (s Itl11)) tr) (+ (i (l14 Itl11) tr) 1))
                     (= (x (l11 (s Itl11)) tr) (x (l14 Itl11) tr))
                  )
               )
            )
            ;The loop-condition holds always before the last iteration
            (forall ((Itl11 Nat))
               (=>
                  (Sub Itl11 (nl11 tr))
                  (< (i (l11 Itl11) tr) (alength tr))
               )
            )
            ;The loop-condition doesn't hold in the last iteration
            (not
               (< (i (l11 (nl11 tr)) tr) (alength tr))
            )
            ;The values after the while-loop are the values from the last iteration
            (and
               (= (i main_end tr) (i (l11 (nl11 tr)) tr))
               (= (x main_end tr) (x (l11 (nl11 tr)) tr))
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var i and location l11
      (=>
         (forall ((Itl11 Nat))
            (=>
               (Sub Itl11 (nl11 tr))
               (= (i (l11 Itl11) tr) (i (l11 (s Itl11)) tr))
            )
         )
         (= (i (l11 zero) tr) (i (l11 (nl11 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var x and location l11
      (=>
         (forall ((Itl11 Nat))
            (=>
               (Sub Itl11 (nl11 tr))
               (= (x (l11 Itl11) tr) (x (l11 (s Itl11)) tr))
            )
         )
         (= (x (l11 zero) tr) (x (l11 (nl11 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: if the condition of the loop at l11 holds initially, there is at least one loop iteration
      (=>
         (< (i (l11 zero) tr) (alength tr))
         (exists ((Itl11 Nat))
            (= (s Itl11) (nl11 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var i at location l11
      (forall ((xInt Int)(Itl11 Nat))
         (=>
            (and
               (<= (i (l11 zero) tr) xInt)
               (< xInt (i (l11 (nl11 tr)) tr))
               (= (i (l11 (s Itl11)) tr) (+ (i (l11 Itl11) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (i (l11 it) tr) xInt)
                  (Sub it (nl11 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var x at location l11
      (forall ((xInt Int)(Itl11 Nat))
         (=>
            (and
               (<= (x (l11 zero) tr) xInt)
               (< xInt (x (l11 (nl11 tr)) tr))
               (= (x (l11 (s Itl11)) tr) (+ (x (l11 Itl11) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (x (l11 it) tr) xInt)
                  (Sub it (nl11 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl11 Nat))
         (=>
            (and
               (Sub (s Itl11) (nl11 tr))
               (= (i (l11 (s Itl11)) tr) (+ (i (l11 Itl11) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (i (l11 it1) tr) (i (l11 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl11 Nat))
         (=>
            (and
               (Sub (s Itl11) (nl11 tr))
               (= (x (l11 (s Itl11)) tr) (+ (x (l11 Itl11) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (x (l11 it1) tr) (x (l11 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   ;Lemma: Var i at loop l11 has same values on both traces
   (=>
      (and
         (= (i (l11 zero) t1) (i (l11 zero) t2))
         (forall ((Itl11 Nat))
            (=>
               (= (i (l11 Itl11) t1) (i (l11 Itl11) t2))
               (= (i (l11 (s Itl11)) t1) (i (l11 (s Itl11)) t2))
            )
         )
      )
      (forall ((Itl11 Nat))
         (= (i (l11 Itl11) t1) (i (l11 Itl11) t2))
      )
   )
)

(assert
   ;Lemma: Var x at loop l11 has same values on both traces
   (=>
      (and
         (= (x (l11 zero) t1) (x (l11 zero) t2))
         (forall ((Itl11 Nat))
            (=>
               (= (x (l11 Itl11) t1) (x (l11 Itl11) t2))
               (= (x (l11 (s Itl11)) t1) (x (l11 (s Itl11)) t2))
            )
         )
      )
      (forall ((Itl11 Nat))
         (= (x (l11 Itl11) t1) (x (l11 Itl11) t2))
      )
   )
)

(assert
   ;Lemma: If nl11(t2) has same properties as nl11(t1), then nl11(t2)=nl11(t1) (for loop at l11)
   (=>
      (and
         (forall ((Itl11 Nat))
            (=>
               (Sub Itl11 (nl11 t2))
               (< (i (l11 Itl11) t1) (alength t1))
            )
         )
         (not
            (< (i (l11 (nl11 t2)) t1) (alength t1))
         )
      )
      (= (nl11 t2) (nl11 t1))
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l11
   (forall ((itR Nat))
      (=>
         (and
            (= (i (l11 zero) t1) (i (l11 zero) t2))
            (forall ((Itl11 Nat))
               (=>
                  (and
                     (Sub Itl11 itR)
                     (= (i (l11 Itl11) t1) (i (l11 Itl11) t2))
                  )
                  (= (i (l11 (s Itl11)) t1) (i (l11 (s Itl11)) t2))
               )
            )
         )
         (= (i (l11 itR) t1) (i (l11 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l11
   (forall ((itR Nat))
      (=>
         (and
            (= (x (l11 zero) t1) (x (l11 zero) t2))
            (forall ((Itl11 Nat))
               (=>
                  (and
                     (Sub Itl11 itR)
                     (= (x (l11 Itl11) t1) (x (l11 Itl11) t2))
                  )
                  (= (x (l11 (s Itl11)) t1) (x (l11 (s Itl11)) t2))
               )
            )
         )
         (= (x (l11 itR) t1) (x (l11 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l11
   (forall ((itL Nat))
      (=>
         (and
            (= (i (l11 itL) t1) (i (l11 itL) t2))
            (forall ((Itl11 Nat))
               (=>
                  (and
                     (Sub itL (s Itl11))
                     (Sub Itl11 (nl11 t1))
                     (= (i (l11 Itl11) t1) (i (l11 Itl11) t2))
                  )
                  (= (i (l11 (s Itl11)) t1) (i (l11 (s Itl11)) t2))
               )
            )
            (= (l11 (nl11 t1)) (l11 (nl11 t2)))
         )
         (= (i (l11 (nl11 t1)) t1) (i (l11 (nl11 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l11
   (forall ((itL Nat))
      (=>
         (and
            (= (x (l11 itL) t1) (x (l11 itL) t2))
            (forall ((Itl11 Nat))
               (=>
                  (and
                     (Sub itL (s Itl11))
                     (Sub Itl11 (nl11 t1))
                     (= (x (l11 Itl11) t1) (x (l11 Itl11) t2))
                  )
                  (= (x (l11 (s Itl11)) t1) (x (l11 (s Itl11)) t2))
               )
            )
            (= (l11 (nl11 t1)) (l11 (nl11 t2)))
         )
         (= (x (l11 (nl11 t1)) t1) (x (l11 (nl11 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var i at location l11
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (i (l11 zero) t1) (i (l11 zero) t2))
            (forall ((tr3 Trace)(Itl11 Nat))
               (= (i (l11 (s Itl11)) tr3) (+ (i (l11 Itl11) tr3) 1))
            )
         )
         (< (i (l11 it1) tr) (i (l11 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var x at location l11
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (x (l11 zero) t1) (x (l11 zero) t2))
            (forall ((tr3 Trace)(Itl11 Nat))
               (= (x (l11 (s Itl11)) tr3) (+ (x (l11 Itl11) tr3) 1))
            )
         )
         (< (x (l11 it1) tr) (x (l11 it2) tr))
      )
   )
)

(assert
   ;Theory axiom: forall x y z. (x + y) + z) = (x + z) + y
   (forall ((xInt Int)(yInt Int)(zInt Int))
      (= (+ (+ xInt yInt) zInt) (+ (+ xInt zInt) yInt))
   )
)

; negated conjecture
(assert
   (not
      (=>
         (and
            (forall ((j Int))
               (= (a j t1) (a j t2))
            )
            (= (alength t1) (alength t2))
         )
         (= (x main_end t1) (x main_end t2))
      )
   )
)

(check-sat)

(exit)
