(set-info :smt-lib-version 2.6)
(set-logic UFDTLIA)
(set-info :source |
Generated by: Bernhard Gleiss
Generated on: 2019-3-11
Generator: Rapid
Application: Software Verification
Target solver: Vampire
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "crafted")
(set-info :status unknown)

(declare-datatypes ((Nat 0)) (( (zero) (s (p Nat)) )) )
(declare-sort Time 0)
(declare-sort Trace 0)
(declare-const main_end Time)
(declare-fun nl24 (Trace) Nat)
(declare-const l21 Time)
(declare-fun l18 (Nat) Time)
(declare-const l23 Time)
(declare-fun l15 (Nat) Time)
(declare-fun i (Time Trace) Int)
(declare-fun x (Time Trace) Int)
(declare-fun l27 (Nat) Time)
(declare-fun l26 (Nat) Time)
(declare-fun alength (Trace) Int)
(declare-fun b (Int Trace) Int)
(declare-fun l24 (Nat) Time)
(declare-const t1 Trace)
(declare-fun l17 (Nat) Time)
(declare-const t2 Trace)
(declare-fun k (Trace) Int)
(declare-const l11 Time)
(declare-const l30 Time)
(declare-fun a (Int Trace) Int)
(declare-const l12 Time)
(declare-fun y (Time Trace) Int)
(declare-fun Sub (Nat Nat) Bool)
(assert (forall ((it Nat)) (Sub it (s it))) )
(assert (forall ((it1 Nat)(it2 Nat)) (=> (Sub it1 it2) (Sub it1 (s it2))) ))
(declare-fun nl15 (Trace) Nat)
(declare-const l13 Time)
(declare-fun blength (Trace) Int)

(assert
   ;Semantics of function main
   (and
      (forall ((tr Trace))
         ;Update variable x at location l11
         (= (x l12 tr) 0)
      )
      (forall ((tr Trace))
         ;Update variable y at location l12
         (and
            (= (y l13 tr) 0)
            (= (x l13 tr) (x l12 tr))
         )
      )
      (forall ((tr Trace))
         ;Update variable i at location l13
         (and
            (= (i (l15 zero) tr) 0)
            (= (x (l15 zero) tr) (x l13 tr))
            (= (y (l15 zero) tr) (y l13 tr))
         )
      )
      (forall ((tr Trace))
         ;Loop at location l15
         (and
            ;Jumping into the body doesn't change the variable values
            (forall ((Itl15 Nat))
               (and
                  (= (y (l17 Itl15) tr) (y (l15 Itl15) tr))
                  (= (x (l17 Itl15) tr) (x (l15 Itl15) tr))
                  (= (i (l17 Itl15) tr) (i (l15 Itl15) tr))
               )
            )
            ;Semantics of the body
            (forall ((Itl15 Nat))
               (and
                  ;Update variable x at location l17
                  (and
                     (= (x (l18 Itl15) tr) (+ (x (l17 Itl15) tr) (a (i (l17 Itl15) tr) tr)))
                     (= (y (l18 Itl15) tr) (y (l17 Itl15) tr))
                     (= (i (l18 Itl15) tr) (i (l17 Itl15) tr))
                  )
                  ;Update variable i at location l18
                  (and
                     (= (i (l15 (s Itl15)) tr) (+ (i (l18 Itl15) tr) 1))
                     (= (x (l15 (s Itl15)) tr) (x (l18 Itl15) tr))
                     (= (y (l15 (s Itl15)) tr) (y (l18 Itl15) tr))
                  )
               )
            )
            ;The loop-condition holds always before the last iteration
            (forall ((Itl15 Nat))
               (=>
                  (Sub Itl15 (nl15 tr))
                  (< (i (l15 Itl15) tr) (alength tr))
               )
            )
            ;The loop-condition doesn't hold in the last iteration
            (not
               (< (i (l15 (nl15 tr)) tr) (alength tr))
            )
            ;The values after the while-loop are the values from the last iteration
            (and
               (= (y l21 tr) (y (l15 (nl15 tr)) tr))
               (= (x l21 tr) (x (l15 (nl15 tr)) tr))
               (= (i l21 tr) (i (l15 (nl15 tr)) tr))
            )
         )
      )
      (forall ((tr Trace))
         ;Update variable x at location l21
         (and
            (= (x l23 tr) (+ (x l21 tr) (k tr)))
            (= (y l23 tr) (y l21 tr))
            (= (i l23 tr) (i l21 tr))
         )
      )
      (forall ((tr Trace))
         ;Update variable i at location l23
         (and
            (= (i (l24 zero) tr) 0)
            (= (x (l24 zero) tr) (x l23 tr))
            (= (y (l24 zero) tr) (y l23 tr))
         )
      )
      (forall ((tr Trace))
         ;Loop at location l24
         (and
            ;Jumping into the body doesn't change the variable values
            (forall ((Itl24 Nat))
               (and
                  (= (y (l26 Itl24) tr) (y (l24 Itl24) tr))
                  (= (x (l26 Itl24) tr) (x (l24 Itl24) tr))
                  (= (i (l26 Itl24) tr) (i (l24 Itl24) tr))
               )
            )
            ;Semantics of the body
            (forall ((Itl24 Nat))
               (and
                  ;Update variable y at location l26
                  (and
                     (= (y (l27 Itl24) tr) (+ (y (l26 Itl24) tr) (b (i (l26 Itl24) tr) tr)))
                     (= (x (l27 Itl24) tr) (x (l26 Itl24) tr))
                     (= (i (l27 Itl24) tr) (i (l26 Itl24) tr))
                  )
                  ;Update variable i at location l27
                  (and
                     (= (i (l24 (s Itl24)) tr) (+ (i (l27 Itl24) tr) 1))
                     (= (x (l24 (s Itl24)) tr) (x (l27 Itl24) tr))
                     (= (y (l24 (s Itl24)) tr) (y (l27 Itl24) tr))
                  )
               )
            )
            ;The loop-condition holds always before the last iteration
            (forall ((Itl24 Nat))
               (=>
                  (Sub Itl24 (nl24 tr))
                  (< (i (l24 Itl24) tr) (blength tr))
               )
            )
            ;The loop-condition doesn't hold in the last iteration
            (not
               (< (i (l24 (nl24 tr)) tr) (blength tr))
            )
            ;The values after the while-loop are the values from the last iteration
            (and
               (= (y l30 tr) (y (l24 (nl24 tr)) tr))
               (= (x l30 tr) (x (l24 (nl24 tr)) tr))
               (= (i l30 tr) (i (l24 (nl24 tr)) tr))
            )
         )
      )
      (forall ((tr Trace))
         ;Update variable x at location l30
         (and
            (= (x main_end tr) (+ (x l30 tr) (y l30 tr)))
            (= (y main_end tr) (y l30 tr))
            (= (i main_end tr) (i l30 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var y and location l15
      (=>
         (forall ((Itl15 Nat))
            (=>
               (Sub Itl15 (nl15 tr))
               (= (y (l15 Itl15) tr) (y (l15 (s Itl15)) tr))
            )
         )
         (= (y (l15 zero) tr) (y (l15 (nl15 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var x and location l15
      (=>
         (forall ((Itl15 Nat))
            (=>
               (Sub Itl15 (nl15 tr))
               (= (x (l15 Itl15) tr) (x (l15 (s Itl15)) tr))
            )
         )
         (= (x (l15 zero) tr) (x (l15 (nl15 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var i and location l15
      (=>
         (forall ((Itl15 Nat))
            (=>
               (Sub Itl15 (nl15 tr))
               (= (i (l15 Itl15) tr) (i (l15 (s Itl15)) tr))
            )
         )
         (= (i (l15 zero) tr) (i (l15 (nl15 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var y and location l24
      (=>
         (forall ((Itl24 Nat))
            (=>
               (Sub Itl24 (nl24 tr))
               (= (y (l24 Itl24) tr) (y (l24 (s Itl24)) tr))
            )
         )
         (= (y (l24 zero) tr) (y (l24 (nl24 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var x and location l24
      (=>
         (forall ((Itl24 Nat))
            (=>
               (Sub Itl24 (nl24 tr))
               (= (x (l24 Itl24) tr) (x (l24 (s Itl24)) tr))
            )
         )
         (= (x (l24 zero) tr) (x (l24 (nl24 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var i and location l24
      (=>
         (forall ((Itl24 Nat))
            (=>
               (Sub Itl24 (nl24 tr))
               (= (i (l24 Itl24) tr) (i (l24 (s Itl24)) tr))
            )
         )
         (= (i (l24 zero) tr) (i (l24 (nl24 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: if the condition of the loop at l15 holds initially, there is at least one loop iteration
      (=>
         (< (i (l15 zero) tr) (alength tr))
         (exists ((Itl15 Nat))
            (= (s Itl15) (nl15 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: if the condition of the loop at l24 holds initially, there is at least one loop iteration
      (=>
         (< (i (l24 zero) tr) (blength tr))
         (exists ((Itl24 Nat))
            (= (s Itl24) (nl24 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var y at location l15
      (forall ((xInt Int)(Itl15 Nat))
         (=>
            (and
               (<= (y (l15 zero) tr) xInt)
               (< xInt (y (l15 (nl15 tr)) tr))
               (= (y (l15 (s Itl15)) tr) (+ (y (l15 Itl15) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (y (l15 it) tr) xInt)
                  (Sub it (nl15 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var x at location l15
      (forall ((xInt Int)(Itl15 Nat))
         (=>
            (and
               (<= (x (l15 zero) tr) xInt)
               (< xInt (x (l15 (nl15 tr)) tr))
               (= (x (l15 (s Itl15)) tr) (+ (x (l15 Itl15) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (x (l15 it) tr) xInt)
                  (Sub it (nl15 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var i at location l15
      (forall ((xInt Int)(Itl15 Nat))
         (=>
            (and
               (<= (i (l15 zero) tr) xInt)
               (< xInt (i (l15 (nl15 tr)) tr))
               (= (i (l15 (s Itl15)) tr) (+ (i (l15 Itl15) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (i (l15 it) tr) xInt)
                  (Sub it (nl15 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var y at location l24
      (forall ((xInt Int)(Itl24 Nat))
         (=>
            (and
               (<= (y (l24 zero) tr) xInt)
               (< xInt (y (l24 (nl24 tr)) tr))
               (= (y (l24 (s Itl24)) tr) (+ (y (l24 Itl24) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (y (l24 it) tr) xInt)
                  (Sub it (nl24 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var x at location l24
      (forall ((xInt Int)(Itl24 Nat))
         (=>
            (and
               (<= (x (l24 zero) tr) xInt)
               (< xInt (x (l24 (nl24 tr)) tr))
               (= (x (l24 (s Itl24)) tr) (+ (x (l24 Itl24) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (x (l24 it) tr) xInt)
                  (Sub it (nl24 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var i at location l24
      (forall ((xInt Int)(Itl24 Nat))
         (=>
            (and
               (<= (i (l24 zero) tr) xInt)
               (< xInt (i (l24 (nl24 tr)) tr))
               (= (i (l24 (s Itl24)) tr) (+ (i (l24 Itl24) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (i (l24 it) tr) xInt)
                  (Sub it (nl24 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl15 Nat))
         (=>
            (and
               (Sub (s Itl15) (nl15 tr))
               (= (y (l15 (s Itl15)) tr) (+ (y (l15 Itl15) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (y (l15 it1) tr) (y (l15 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl15 Nat))
         (=>
            (and
               (Sub (s Itl15) (nl15 tr))
               (= (x (l15 (s Itl15)) tr) (+ (x (l15 Itl15) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (x (l15 it1) tr) (x (l15 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl15 Nat))
         (=>
            (and
               (Sub (s Itl15) (nl15 tr))
               (= (i (l15 (s Itl15)) tr) (+ (i (l15 Itl15) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (i (l15 it1) tr) (i (l15 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl24 Nat))
         (=>
            (and
               (Sub (s Itl24) (nl24 tr))
               (= (y (l24 (s Itl24)) tr) (+ (y (l24 Itl24) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (y (l24 it1) tr) (y (l24 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl24 Nat))
         (=>
            (and
               (Sub (s Itl24) (nl24 tr))
               (= (x (l24 (s Itl24)) tr) (+ (x (l24 Itl24) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (x (l24 it1) tr) (x (l24 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl24 Nat))
         (=>
            (and
               (Sub (s Itl24) (nl24 tr))
               (= (i (l24 (s Itl24)) tr) (+ (i (l24 Itl24) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (i (l24 it1) tr) (i (l24 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   ;Lemma: Var y at loop l15 has same values on both traces
   (=>
      (and
         (= (y (l15 zero) t1) (y (l15 zero) t2))
         (forall ((Itl15 Nat))
            (=>
               (= (y (l15 Itl15) t1) (y (l15 Itl15) t2))
               (= (y (l15 (s Itl15)) t1) (y (l15 (s Itl15)) t2))
            )
         )
      )
      (forall ((Itl15 Nat))
         (= (y (l15 Itl15) t1) (y (l15 Itl15) t2))
      )
   )
)

(assert
   ;Lemma: Var x at loop l15 has same values on both traces
   (=>
      (and
         (= (x (l15 zero) t1) (x (l15 zero) t2))
         (forall ((Itl15 Nat))
            (=>
               (= (x (l15 Itl15) t1) (x (l15 Itl15) t2))
               (= (x (l15 (s Itl15)) t1) (x (l15 (s Itl15)) t2))
            )
         )
      )
      (forall ((Itl15 Nat))
         (= (x (l15 Itl15) t1) (x (l15 Itl15) t2))
      )
   )
)

(assert
   ;Lemma: Var i at loop l15 has same values on both traces
   (=>
      (and
         (= (i (l15 zero) t1) (i (l15 zero) t2))
         (forall ((Itl15 Nat))
            (=>
               (= (i (l15 Itl15) t1) (i (l15 Itl15) t2))
               (= (i (l15 (s Itl15)) t1) (i (l15 (s Itl15)) t2))
            )
         )
      )
      (forall ((Itl15 Nat))
         (= (i (l15 Itl15) t1) (i (l15 Itl15) t2))
      )
   )
)

(assert
   ;Lemma: Var y at loop l24 has same values on both traces
   (=>
      (and
         (= (y (l24 zero) t1) (y (l24 zero) t2))
         (forall ((Itl24 Nat))
            (=>
               (= (y (l24 Itl24) t1) (y (l24 Itl24) t2))
               (= (y (l24 (s Itl24)) t1) (y (l24 (s Itl24)) t2))
            )
         )
      )
      (forall ((Itl24 Nat))
         (= (y (l24 Itl24) t1) (y (l24 Itl24) t2))
      )
   )
)

(assert
   ;Lemma: Var x at loop l24 has same values on both traces
   (=>
      (and
         (= (x (l24 zero) t1) (x (l24 zero) t2))
         (forall ((Itl24 Nat))
            (=>
               (= (x (l24 Itl24) t1) (x (l24 Itl24) t2))
               (= (x (l24 (s Itl24)) t1) (x (l24 (s Itl24)) t2))
            )
         )
      )
      (forall ((Itl24 Nat))
         (= (x (l24 Itl24) t1) (x (l24 Itl24) t2))
      )
   )
)

(assert
   ;Lemma: Var i at loop l24 has same values on both traces
   (=>
      (and
         (= (i (l24 zero) t1) (i (l24 zero) t2))
         (forall ((Itl24 Nat))
            (=>
               (= (i (l24 Itl24) t1) (i (l24 Itl24) t2))
               (= (i (l24 (s Itl24)) t1) (i (l24 (s Itl24)) t2))
            )
         )
      )
      (forall ((Itl24 Nat))
         (= (i (l24 Itl24) t1) (i (l24 Itl24) t2))
      )
   )
)

(assert
   ;Lemma: If nl15(t2) has same properties as nl15(t1), then nl15(t2)=nl15(t1) (for loop at l15)
   (=>
      (and
         (forall ((Itl15 Nat))
            (=>
               (Sub Itl15 (nl15 t2))
               (< (i (l15 Itl15) t1) (alength t1))
            )
         )
         (not
            (< (i (l15 (nl15 t2)) t1) (alength t1))
         )
      )
      (= (nl15 t2) (nl15 t1))
   )
)

(assert
   ;Lemma: If nl24(t2) has same properties as nl24(t1), then nl24(t2)=nl24(t1) (for loop at l24)
   (=>
      (and
         (forall ((Itl24 Nat))
            (=>
               (Sub Itl24 (nl24 t2))
               (< (i (l24 Itl24) t1) (blength t1))
            )
         )
         (not
            (< (i (l24 (nl24 t2)) t1) (blength t1))
         )
      )
      (= (nl24 t2) (nl24 t1))
   )
)

(assert
   ;Lemma: Equality preservation over traces for var y at location l15
   (forall ((itR Nat))
      (=>
         (and
            (= (y (l15 zero) t1) (y (l15 zero) t2))
            (forall ((Itl15 Nat))
               (=>
                  (and
                     (Sub Itl15 itR)
                     (= (y (l15 Itl15) t1) (y (l15 Itl15) t2))
                  )
                  (= (y (l15 (s Itl15)) t1) (y (l15 (s Itl15)) t2))
               )
            )
         )
         (= (y (l15 itR) t1) (y (l15 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l15
   (forall ((itR Nat))
      (=>
         (and
            (= (x (l15 zero) t1) (x (l15 zero) t2))
            (forall ((Itl15 Nat))
               (=>
                  (and
                     (Sub Itl15 itR)
                     (= (x (l15 Itl15) t1) (x (l15 Itl15) t2))
                  )
                  (= (x (l15 (s Itl15)) t1) (x (l15 (s Itl15)) t2))
               )
            )
         )
         (= (x (l15 itR) t1) (x (l15 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l15
   (forall ((itR Nat))
      (=>
         (and
            (= (i (l15 zero) t1) (i (l15 zero) t2))
            (forall ((Itl15 Nat))
               (=>
                  (and
                     (Sub Itl15 itR)
                     (= (i (l15 Itl15) t1) (i (l15 Itl15) t2))
                  )
                  (= (i (l15 (s Itl15)) t1) (i (l15 (s Itl15)) t2))
               )
            )
         )
         (= (i (l15 itR) t1) (i (l15 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var y at location l15
   (forall ((itL Nat))
      (=>
         (and
            (= (y (l15 itL) t1) (y (l15 itL) t2))
            (forall ((Itl15 Nat))
               (=>
                  (and
                     (Sub itL (s Itl15))
                     (Sub Itl15 (nl15 t1))
                     (= (y (l15 Itl15) t1) (y (l15 Itl15) t2))
                  )
                  (= (y (l15 (s Itl15)) t1) (y (l15 (s Itl15)) t2))
               )
            )
            (= (l15 (nl15 t1)) (l15 (nl15 t2)))
         )
         (= (y (l15 (nl15 t1)) t1) (y (l15 (nl15 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l15
   (forall ((itL Nat))
      (=>
         (and
            (= (x (l15 itL) t1) (x (l15 itL) t2))
            (forall ((Itl15 Nat))
               (=>
                  (and
                     (Sub itL (s Itl15))
                     (Sub Itl15 (nl15 t1))
                     (= (x (l15 Itl15) t1) (x (l15 Itl15) t2))
                  )
                  (= (x (l15 (s Itl15)) t1) (x (l15 (s Itl15)) t2))
               )
            )
            (= (l15 (nl15 t1)) (l15 (nl15 t2)))
         )
         (= (x (l15 (nl15 t1)) t1) (x (l15 (nl15 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l15
   (forall ((itL Nat))
      (=>
         (and
            (= (i (l15 itL) t1) (i (l15 itL) t2))
            (forall ((Itl15 Nat))
               (=>
                  (and
                     (Sub itL (s Itl15))
                     (Sub Itl15 (nl15 t1))
                     (= (i (l15 Itl15) t1) (i (l15 Itl15) t2))
                  )
                  (= (i (l15 (s Itl15)) t1) (i (l15 (s Itl15)) t2))
               )
            )
            (= (l15 (nl15 t1)) (l15 (nl15 t2)))
         )
         (= (i (l15 (nl15 t1)) t1) (i (l15 (nl15 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var y at location l24
   (forall ((itR Nat))
      (=>
         (and
            (= (y (l24 zero) t1) (y (l24 zero) t2))
            (forall ((Itl24 Nat))
               (=>
                  (and
                     (Sub Itl24 itR)
                     (= (y (l24 Itl24) t1) (y (l24 Itl24) t2))
                  )
                  (= (y (l24 (s Itl24)) t1) (y (l24 (s Itl24)) t2))
               )
            )
         )
         (= (y (l24 itR) t1) (y (l24 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l24
   (forall ((itR Nat))
      (=>
         (and
            (= (x (l24 zero) t1) (x (l24 zero) t2))
            (forall ((Itl24 Nat))
               (=>
                  (and
                     (Sub Itl24 itR)
                     (= (x (l24 Itl24) t1) (x (l24 Itl24) t2))
                  )
                  (= (x (l24 (s Itl24)) t1) (x (l24 (s Itl24)) t2))
               )
            )
         )
         (= (x (l24 itR) t1) (x (l24 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l24
   (forall ((itR Nat))
      (=>
         (and
            (= (i (l24 zero) t1) (i (l24 zero) t2))
            (forall ((Itl24 Nat))
               (=>
                  (and
                     (Sub Itl24 itR)
                     (= (i (l24 Itl24) t1) (i (l24 Itl24) t2))
                  )
                  (= (i (l24 (s Itl24)) t1) (i (l24 (s Itl24)) t2))
               )
            )
         )
         (= (i (l24 itR) t1) (i (l24 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var y at location l24
   (forall ((itL Nat))
      (=>
         (and
            (= (y (l24 itL) t1) (y (l24 itL) t2))
            (forall ((Itl24 Nat))
               (=>
                  (and
                     (Sub itL (s Itl24))
                     (Sub Itl24 (nl24 t1))
                     (= (y (l24 Itl24) t1) (y (l24 Itl24) t2))
                  )
                  (= (y (l24 (s Itl24)) t1) (y (l24 (s Itl24)) t2))
               )
            )
            (= (l24 (nl24 t1)) (l24 (nl24 t2)))
         )
         (= (y (l24 (nl24 t1)) t1) (y (l24 (nl24 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l24
   (forall ((itL Nat))
      (=>
         (and
            (= (x (l24 itL) t1) (x (l24 itL) t2))
            (forall ((Itl24 Nat))
               (=>
                  (and
                     (Sub itL (s Itl24))
                     (Sub Itl24 (nl24 t1))
                     (= (x (l24 Itl24) t1) (x (l24 Itl24) t2))
                  )
                  (= (x (l24 (s Itl24)) t1) (x (l24 (s Itl24)) t2))
               )
            )
            (= (l24 (nl24 t1)) (l24 (nl24 t2)))
         )
         (= (x (l24 (nl24 t1)) t1) (x (l24 (nl24 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l24
   (forall ((itL Nat))
      (=>
         (and
            (= (i (l24 itL) t1) (i (l24 itL) t2))
            (forall ((Itl24 Nat))
               (=>
                  (and
                     (Sub itL (s Itl24))
                     (Sub Itl24 (nl24 t1))
                     (= (i (l24 Itl24) t1) (i (l24 Itl24) t2))
                  )
                  (= (i (l24 (s Itl24)) t1) (i (l24 (s Itl24)) t2))
               )
            )
            (= (l24 (nl24 t1)) (l24 (nl24 t2)))
         )
         (= (i (l24 (nl24 t1)) t1) (i (l24 (nl24 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var y at location l15
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (y (l15 zero) t1) (y (l15 zero) t2))
            (forall ((tr3 Trace)(Itl15 Nat))
               (= (y (l15 (s Itl15)) tr3) (+ (y (l15 Itl15) tr3) 1))
            )
         )
         (< (y (l15 it1) tr) (y (l15 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var x at location l15
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (x (l15 zero) t1) (x (l15 zero) t2))
            (forall ((tr3 Trace)(Itl15 Nat))
               (= (x (l15 (s Itl15)) tr3) (+ (x (l15 Itl15) tr3) 1))
            )
         )
         (< (x (l15 it1) tr) (x (l15 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var i at location l15
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (i (l15 zero) t1) (i (l15 zero) t2))
            (forall ((tr3 Trace)(Itl15 Nat))
               (= (i (l15 (s Itl15)) tr3) (+ (i (l15 Itl15) tr3) 1))
            )
         )
         (< (i (l15 it1) tr) (i (l15 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var y at location l24
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (y (l24 zero) t1) (y (l24 zero) t2))
            (forall ((tr3 Trace)(Itl24 Nat))
               (= (y (l24 (s Itl24)) tr3) (+ (y (l24 Itl24) tr3) 1))
            )
         )
         (< (y (l24 it1) tr) (y (l24 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var x at location l24
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (x (l24 zero) t1) (x (l24 zero) t2))
            (forall ((tr3 Trace)(Itl24 Nat))
               (= (x (l24 (s Itl24)) tr3) (+ (x (l24 Itl24) tr3) 1))
            )
         )
         (< (x (l24 it1) tr) (x (l24 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var i at location l24
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (i (l24 zero) t1) (i (l24 zero) t2))
            (forall ((tr3 Trace)(Itl24 Nat))
               (= (i (l24 (s Itl24)) tr3) (+ (i (l24 Itl24) tr3) 1))
            )
         )
         (< (i (l24 it1) tr) (i (l24 it2) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Static analysis lemma for var y at location l15
      (forall ((Itl15 Nat))
         (= (y (l15 Itl15) tr) (y (l15 zero) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Static analysis lemma for var x at location l24
      (forall ((Itl24 Nat))
         (= (x (l24 Itl24) tr) (x (l24 zero) tr))
      )
   )
)

(assert
   ;Theory axiom: forall x y z. (x + y) + z) = (x + z) + y
   (forall ((xInt Int)(yInt Int)(zInt Int))
      (= (+ (+ xInt yInt) zInt) (+ (+ xInt zInt) yInt))
   )
)

; negated conjecture
(assert
   (not
      (=>
         (and
            (forall ((j Int))
               (and
                  (= (a j t1) (a j t2))
                  (= (b j t1) (b j t2))
               )
            )
            (= (alength t1) (alength t2))
            (= (blength t1) (blength t2))
            (= (k t1) 1)
            (= (k t2) 1)
         )
         (= (x main_end t1) (x main_end t2))
      )
   )
)

(check-sat)

(exit)
