(set-info :smt-lib-version 2.6)
(set-logic UFDTLIA)
(set-info :source |
Generated by: Bernhard Gleiss
Generated on: 2019-3-11
Generator: Rapid
Application: Software Verification
Target solver: Vampire
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "crafted")
(set-info :status unknown)

(declare-datatypes ((Nat 0)) (( (zero) (s (p Nat)) )) )
(declare-sort Time 0)
(declare-sort Trace 0)
(declare-const l20 Time)
(declare-fun nl14 (Trace) Nat)
(declare-fun x (Time Trace) Int)
(declare-fun alength (Trace) Int)
(declare-const t1 Trace)
(declare-fun l17 (Nat) Time)
(declare-const main_end Time)
(declare-fun z (Trace) Int)
(declare-const t2 Trace)
(declare-const l11 Time)
(declare-fun l16 (Nat) Time)
(declare-fun a (Int Trace) Int)
(declare-const l12 Time)
(declare-fun l14 (Nat) Time)
(declare-fun i (Time Trace) Int)
(declare-fun Sub (Nat Nat) Bool)
(assert (forall ((it Nat)) (Sub it (s it))) )
(assert (forall ((it1 Nat)(it2 Nat)) (=> (Sub it1 it2) (Sub it1 (s it2))) ))

(assert
   ;Semantics of function main
   (and
      (forall ((tr Trace))
         ;Update variable x at location l11
         (= (x l12 tr) 0)
      )
      (forall ((tr Trace))
         ;Update variable i at location l12
         (and
            (= (i (l14 zero) tr) 0)
            (= (x (l14 zero) tr) (x l12 tr))
         )
      )
      (forall ((tr Trace))
         ;Loop at location l14
         (and
            ;Jumping into the body doesn't change the variable values
            (forall ((Itl14 Nat))
               (and
                  (= (i (l16 Itl14) tr) (i (l14 Itl14) tr))
                  (= (x (l16 Itl14) tr) (x (l14 Itl14) tr))
               )
            )
            ;Semantics of the body
            (forall ((Itl14 Nat))
               (and
                  ;Update variable x at location l16
                  (and
                     (= (x (l17 Itl14) tr) (+ (x (l16 Itl14) tr) (a (i (l16 Itl14) tr) tr)))
                     (= (i (l17 Itl14) tr) (i (l16 Itl14) tr))
                  )
                  ;Update variable i at location l17
                  (and
                     (= (i (l14 (s Itl14)) tr) (+ (i (l17 Itl14) tr) 1))
                     (= (x (l14 (s Itl14)) tr) (x (l17 Itl14) tr))
                  )
               )
            )
            ;The loop-condition holds always before the last iteration
            (forall ((Itl14 Nat))
               (=>
                  (Sub Itl14 (nl14 tr))
                  (< (i (l14 Itl14) tr) (alength tr))
               )
            )
            ;The loop-condition doesn't hold in the last iteration
            (not
               (< (i (l14 (nl14 tr)) tr) (alength tr))
            )
            ;The values after the while-loop are the values from the last iteration
            (and
               (= (i l20 tr) (i (l14 (nl14 tr)) tr))
               (= (x l20 tr) (x (l14 (nl14 tr)) tr))
            )
         )
      )
      (forall ((tr Trace))
         ;Update variable x at location l20
         (and
            (= (x main_end tr) (+ (x l20 tr) (z tr)))
            (= (i main_end tr) (i l20 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var i and location l14
      (=>
         (forall ((Itl14 Nat))
            (=>
               (Sub Itl14 (nl14 tr))
               (= (i (l14 Itl14) tr) (i (l14 (s Itl14)) tr))
            )
         )
         (= (i (l14 zero) tr) (i (l14 (nl14 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var x and location l14
      (=>
         (forall ((Itl14 Nat))
            (=>
               (Sub Itl14 (nl14 tr))
               (= (x (l14 Itl14) tr) (x (l14 (s Itl14)) tr))
            )
         )
         (= (x (l14 zero) tr) (x (l14 (nl14 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: if the condition of the loop at l14 holds initially, there is at least one loop iteration
      (=>
         (< (i (l14 zero) tr) (alength tr))
         (exists ((Itl14 Nat))
            (= (s Itl14) (nl14 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var i at location l14
      (forall ((xInt Int)(Itl14 Nat))
         (=>
            (and
               (<= (i (l14 zero) tr) xInt)
               (< xInt (i (l14 (nl14 tr)) tr))
               (= (i (l14 (s Itl14)) tr) (+ (i (l14 Itl14) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (i (l14 it) tr) xInt)
                  (Sub it (nl14 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var x at location l14
      (forall ((xInt Int)(Itl14 Nat))
         (=>
            (and
               (<= (x (l14 zero) tr) xInt)
               (< xInt (x (l14 (nl14 tr)) tr))
               (= (x (l14 (s Itl14)) tr) (+ (x (l14 Itl14) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (x (l14 it) tr) xInt)
                  (Sub it (nl14 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl14 Nat))
         (=>
            (and
               (Sub (s Itl14) (nl14 tr))
               (= (i (l14 (s Itl14)) tr) (+ (i (l14 Itl14) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (i (l14 it1) tr) (i (l14 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl14 Nat))
         (=>
            (and
               (Sub (s Itl14) (nl14 tr))
               (= (x (l14 (s Itl14)) tr) (+ (x (l14 Itl14) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (x (l14 it1) tr) (x (l14 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   ;Lemma: Var i at loop l14 has same values on both traces
   (=>
      (and
         (= (i (l14 zero) t1) (i (l14 zero) t2))
         (forall ((Itl14 Nat))
            (=>
               (= (i (l14 Itl14) t1) (i (l14 Itl14) t2))
               (= (i (l14 (s Itl14)) t1) (i (l14 (s Itl14)) t2))
            )
         )
      )
      (forall ((Itl14 Nat))
         (= (i (l14 Itl14) t1) (i (l14 Itl14) t2))
      )
   )
)

(assert
   ;Lemma: Var x at loop l14 has same values on both traces
   (=>
      (and
         (= (x (l14 zero) t1) (x (l14 zero) t2))
         (forall ((Itl14 Nat))
            (=>
               (= (x (l14 Itl14) t1) (x (l14 Itl14) t2))
               (= (x (l14 (s Itl14)) t1) (x (l14 (s Itl14)) t2))
            )
         )
      )
      (forall ((Itl14 Nat))
         (= (x (l14 Itl14) t1) (x (l14 Itl14) t2))
      )
   )
)

(assert
   ;Lemma: If nl14(t2) has same properties as nl14(t1), then nl14(t2)=nl14(t1) (for loop at l14)
   (=>
      (and
         (forall ((Itl14 Nat))
            (=>
               (Sub Itl14 (nl14 t2))
               (< (i (l14 Itl14) t1) (alength t1))
            )
         )
         (not
            (< (i (l14 (nl14 t2)) t1) (alength t1))
         )
      )
      (= (nl14 t2) (nl14 t1))
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l14
   (forall ((itR Nat))
      (=>
         (and
            (= (i (l14 zero) t1) (i (l14 zero) t2))
            (forall ((Itl14 Nat))
               (=>
                  (and
                     (Sub Itl14 itR)
                     (= (i (l14 Itl14) t1) (i (l14 Itl14) t2))
                  )
                  (= (i (l14 (s Itl14)) t1) (i (l14 (s Itl14)) t2))
               )
            )
         )
         (= (i (l14 itR) t1) (i (l14 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l14
   (forall ((itR Nat))
      (=>
         (and
            (= (x (l14 zero) t1) (x (l14 zero) t2))
            (forall ((Itl14 Nat))
               (=>
                  (and
                     (Sub Itl14 itR)
                     (= (x (l14 Itl14) t1) (x (l14 Itl14) t2))
                  )
                  (= (x (l14 (s Itl14)) t1) (x (l14 (s Itl14)) t2))
               )
            )
         )
         (= (x (l14 itR) t1) (x (l14 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l14
   (forall ((itL Nat))
      (=>
         (and
            (= (i (l14 itL) t1) (i (l14 itL) t2))
            (forall ((Itl14 Nat))
               (=>
                  (and
                     (Sub itL (s Itl14))
                     (Sub Itl14 (nl14 t1))
                     (= (i (l14 Itl14) t1) (i (l14 Itl14) t2))
                  )
                  (= (i (l14 (s Itl14)) t1) (i (l14 (s Itl14)) t2))
               )
            )
            (= (l14 (nl14 t1)) (l14 (nl14 t2)))
         )
         (= (i (l14 (nl14 t1)) t1) (i (l14 (nl14 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l14
   (forall ((itL Nat))
      (=>
         (and
            (= (x (l14 itL) t1) (x (l14 itL) t2))
            (forall ((Itl14 Nat))
               (=>
                  (and
                     (Sub itL (s Itl14))
                     (Sub Itl14 (nl14 t1))
                     (= (x (l14 Itl14) t1) (x (l14 Itl14) t2))
                  )
                  (= (x (l14 (s Itl14)) t1) (x (l14 (s Itl14)) t2))
               )
            )
            (= (l14 (nl14 t1)) (l14 (nl14 t2)))
         )
         (= (x (l14 (nl14 t1)) t1) (x (l14 (nl14 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var i at location l14
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (i (l14 zero) t1) (i (l14 zero) t2))
            (forall ((tr3 Trace)(Itl14 Nat))
               (= (i (l14 (s Itl14)) tr3) (+ (i (l14 Itl14) tr3) 1))
            )
         )
         (< (i (l14 it1) tr) (i (l14 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var x at location l14
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (x (l14 zero) t1) (x (l14 zero) t2))
            (forall ((tr3 Trace)(Itl14 Nat))
               (= (x (l14 (s Itl14)) tr3) (+ (x (l14 Itl14) tr3) 1))
            )
         )
         (< (x (l14 it1) tr) (x (l14 it2) tr))
      )
   )
)

(assert
   ;Theory axiom: forall x y z. (x + y) + z) = (x + z) + y
   (forall ((xInt Int)(yInt Int)(zInt Int))
      (= (+ (+ xInt yInt) zInt) (+ (+ xInt zInt) yInt))
   )
)

; negated conjecture
(assert
   (not
      (forall ((k Int))
         (=>
            (and
               (forall ((j Int))
                  (= (a j t1) (a j t2))
               )
               (= (alength t1) (alength t2))
               (= (z t1) (+ (z t2) k))
            )
            (= (x main_end t1) (+ (x main_end t2) k))
         )
      )
   )
)

(check-sat)

(exit)
