(set-info :smt-lib-version 2.6)
(set-logic UFDTLIA)
(set-info :source |
Generated by: Bernhard Gleiss
Generated on: 2019-3-11
Generator: Rapid
Application: Software Verification
Target solver: Vampire
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "crafted")
(set-info :status unknown)

(declare-datatypes ((Nat 0)) (( (zero) (s (p Nat)) )) )
(declare-sort Time 0)
(declare-sort Trace 0)
(declare-const main_end Time)
(declare-fun l21 (Nat) Time)
(declare-fun l23 (Nat) Time)
(declare-fun l15 (Nat) Time)
(declare-const l18 Time)
(declare-fun nl12 (Trace) Nat)
(declare-const l9 Time)
(declare-fun l14 (Nat) Time)
(declare-fun i (Time Trace) Int)
(declare-fun x (Time Trace) Int)
(declare-fun alength (Trace) Int)
(declare-fun b (Int Trace) Int)
(declare-fun l24 (Nat) Time)
(declare-fun nl21 (Trace) Nat)
(declare-const t1 Trace)
(declare-const t2 Trace)
(declare-const l20 Time)
(declare-fun k (Trace) Int)
(declare-const l10 Time)
(declare-fun a (Int Trace) Int)
(declare-fun l12 (Nat) Time)
(declare-fun Sub (Nat Nat) Bool)
(assert (forall ((it Nat)) (Sub it (s it))) )
(assert (forall ((it1 Nat)(it2 Nat)) (=> (Sub it1 it2) (Sub it1 (s it2))) ))
(declare-fun blength (Trace) Int)

(assert
   ;Semantics of function main
   (and
      (forall ((tr Trace))
         ;Update variable x at location l9
         (= (x l10 tr) 0)
      )
      (forall ((tr Trace))
         ;Update variable i at location l10
         (and
            (= (i (l12 zero) tr) 0)
            (= (x (l12 zero) tr) (x l10 tr))
         )
      )
      (forall ((tr Trace))
         ;Loop at location l12
         (and
            ;Jumping into the body doesn't change the variable values
            (forall ((Itl12 Nat))
               (and
                  (= (x (l14 Itl12) tr) (x (l12 Itl12) tr))
                  (= (i (l14 Itl12) tr) (i (l12 Itl12) tr))
               )
            )
            ;Semantics of the body
            (forall ((Itl12 Nat))
               (and
                  ;Update variable x at location l14
                  (and
                     (= (x (l15 Itl12) tr) (+ (x (l14 Itl12) tr) (a (i (l14 Itl12) tr) tr)))
                     (= (i (l15 Itl12) tr) (i (l14 Itl12) tr))
                  )
                  ;Update variable i at location l15
                  (and
                     (= (i (l12 (s Itl12)) tr) (+ (i (l15 Itl12) tr) 1))
                     (= (x (l12 (s Itl12)) tr) (x (l15 Itl12) tr))
                  )
               )
            )
            ;The loop-condition holds always before the last iteration
            (forall ((Itl12 Nat))
               (=>
                  (Sub Itl12 (nl12 tr))
                  (< (i (l12 Itl12) tr) (alength tr))
               )
            )
            ;The loop-condition doesn't hold in the last iteration
            (not
               (< (i (l12 (nl12 tr)) tr) (alength tr))
            )
            ;The values after the while-loop are the values from the last iteration
            (and
               (= (x l18 tr) (x (l12 (nl12 tr)) tr))
               (= (i l18 tr) (i (l12 (nl12 tr)) tr))
            )
         )
      )
      (forall ((tr Trace))
         ;Update variable x at location l18
         (and
            (= (x l20 tr) (+ (x l18 tr) (k tr)))
            (= (i l20 tr) (i l18 tr))
         )
      )
      (forall ((tr Trace))
         ;Update variable i at location l20
         (and
            (= (i (l21 zero) tr) 0)
            (= (x (l21 zero) tr) (x l20 tr))
         )
      )
      (forall ((tr Trace))
         ;Loop at location l21
         (and
            ;Jumping into the body doesn't change the variable values
            (forall ((Itl21 Nat))
               (and
                  (= (x (l23 Itl21) tr) (x (l21 Itl21) tr))
                  (= (i (l23 Itl21) tr) (i (l21 Itl21) tr))
               )
            )
            ;Semantics of the body
            (forall ((Itl21 Nat))
               (and
                  ;Update variable x at location l23
                  (and
                     (= (x (l24 Itl21) tr) (+ (x (l23 Itl21) tr) (b (i (l23 Itl21) tr) tr)))
                     (= (i (l24 Itl21) tr) (i (l23 Itl21) tr))
                  )
                  ;Update variable i at location l24
                  (and
                     (= (i (l21 (s Itl21)) tr) (+ (i (l24 Itl21) tr) 1))
                     (= (x (l21 (s Itl21)) tr) (x (l24 Itl21) tr))
                  )
               )
            )
            ;The loop-condition holds always before the last iteration
            (forall ((Itl21 Nat))
               (=>
                  (Sub Itl21 (nl21 tr))
                  (< (i (l21 Itl21) tr) (blength tr))
               )
            )
            ;The loop-condition doesn't hold in the last iteration
            (not
               (< (i (l21 (nl21 tr)) tr) (blength tr))
            )
            ;The values after the while-loop are the values from the last iteration
            (and
               (= (x main_end tr) (x (l21 (nl21 tr)) tr))
               (= (i main_end tr) (i (l21 (nl21 tr)) tr))
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var x and location l12
      (=>
         (forall ((Itl12 Nat))
            (=>
               (Sub Itl12 (nl12 tr))
               (= (x (l12 Itl12) tr) (x (l12 (s Itl12)) tr))
            )
         )
         (= (x (l12 zero) tr) (x (l12 (nl12 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var i and location l12
      (=>
         (forall ((Itl12 Nat))
            (=>
               (Sub Itl12 (nl12 tr))
               (= (i (l12 Itl12) tr) (i (l12 (s Itl12)) tr))
            )
         )
         (= (i (l12 zero) tr) (i (l12 (nl12 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var x and location l21
      (=>
         (forall ((Itl21 Nat))
            (=>
               (Sub Itl21 (nl21 tr))
               (= (x (l21 Itl21) tr) (x (l21 (s Itl21)) tr))
            )
         )
         (= (x (l21 zero) tr) (x (l21 (nl21 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var i and location l21
      (=>
         (forall ((Itl21 Nat))
            (=>
               (Sub Itl21 (nl21 tr))
               (= (i (l21 Itl21) tr) (i (l21 (s Itl21)) tr))
            )
         )
         (= (i (l21 zero) tr) (i (l21 (nl21 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: if the condition of the loop at l12 holds initially, there is at least one loop iteration
      (=>
         (< (i (l12 zero) tr) (alength tr))
         (exists ((Itl12 Nat))
            (= (s Itl12) (nl12 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: if the condition of the loop at l21 holds initially, there is at least one loop iteration
      (=>
         (< (i (l21 zero) tr) (blength tr))
         (exists ((Itl21 Nat))
            (= (s Itl21) (nl21 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var x at location l12
      (forall ((xInt Int)(Itl12 Nat))
         (=>
            (and
               (<= (x (l12 zero) tr) xInt)
               (< xInt (x (l12 (nl12 tr)) tr))
               (= (x (l12 (s Itl12)) tr) (+ (x (l12 Itl12) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (x (l12 it) tr) xInt)
                  (Sub it (nl12 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var i at location l12
      (forall ((xInt Int)(Itl12 Nat))
         (=>
            (and
               (<= (i (l12 zero) tr) xInt)
               (< xInt (i (l12 (nl12 tr)) tr))
               (= (i (l12 (s Itl12)) tr) (+ (i (l12 Itl12) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (i (l12 it) tr) xInt)
                  (Sub it (nl12 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var x at location l21
      (forall ((xInt Int)(Itl21 Nat))
         (=>
            (and
               (<= (x (l21 zero) tr) xInt)
               (< xInt (x (l21 (nl21 tr)) tr))
               (= (x (l21 (s Itl21)) tr) (+ (x (l21 Itl21) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (x (l21 it) tr) xInt)
                  (Sub it (nl21 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var i at location l21
      (forall ((xInt Int)(Itl21 Nat))
         (=>
            (and
               (<= (i (l21 zero) tr) xInt)
               (< xInt (i (l21 (nl21 tr)) tr))
               (= (i (l21 (s Itl21)) tr) (+ (i (l21 Itl21) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (i (l21 it) tr) xInt)
                  (Sub it (nl21 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl12 Nat))
         (=>
            (and
               (Sub (s Itl12) (nl12 tr))
               (= (x (l12 (s Itl12)) tr) (+ (x (l12 Itl12) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (x (l12 it1) tr) (x (l12 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl12 Nat))
         (=>
            (and
               (Sub (s Itl12) (nl12 tr))
               (= (i (l12 (s Itl12)) tr) (+ (i (l12 Itl12) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (i (l12 it1) tr) (i (l12 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl21 Nat))
         (=>
            (and
               (Sub (s Itl21) (nl21 tr))
               (= (x (l21 (s Itl21)) tr) (+ (x (l21 Itl21) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (x (l21 it1) tr) (x (l21 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl21 Nat))
         (=>
            (and
               (Sub (s Itl21) (nl21 tr))
               (= (i (l21 (s Itl21)) tr) (+ (i (l21 Itl21) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (i (l21 it1) tr) (i (l21 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   ;Lemma: Var x at loop l12 has same values on both traces
   (=>
      (and
         (= (x (l12 zero) t1) (x (l12 zero) t2))
         (forall ((Itl12 Nat))
            (=>
               (= (x (l12 Itl12) t1) (x (l12 Itl12) t2))
               (= (x (l12 (s Itl12)) t1) (x (l12 (s Itl12)) t2))
            )
         )
      )
      (forall ((Itl12 Nat))
         (= (x (l12 Itl12) t1) (x (l12 Itl12) t2))
      )
   )
)

(assert
   ;Lemma: Var i at loop l12 has same values on both traces
   (=>
      (and
         (= (i (l12 zero) t1) (i (l12 zero) t2))
         (forall ((Itl12 Nat))
            (=>
               (= (i (l12 Itl12) t1) (i (l12 Itl12) t2))
               (= (i (l12 (s Itl12)) t1) (i (l12 (s Itl12)) t2))
            )
         )
      )
      (forall ((Itl12 Nat))
         (= (i (l12 Itl12) t1) (i (l12 Itl12) t2))
      )
   )
)

(assert
   ;Lemma: Var x at loop l21 has same values on both traces
   (=>
      (and
         (= (x (l21 zero) t1) (x (l21 zero) t2))
         (forall ((Itl21 Nat))
            (=>
               (= (x (l21 Itl21) t1) (x (l21 Itl21) t2))
               (= (x (l21 (s Itl21)) t1) (x (l21 (s Itl21)) t2))
            )
         )
      )
      (forall ((Itl21 Nat))
         (= (x (l21 Itl21) t1) (x (l21 Itl21) t2))
      )
   )
)

(assert
   ;Lemma: Var i at loop l21 has same values on both traces
   (=>
      (and
         (= (i (l21 zero) t1) (i (l21 zero) t2))
         (forall ((Itl21 Nat))
            (=>
               (= (i (l21 Itl21) t1) (i (l21 Itl21) t2))
               (= (i (l21 (s Itl21)) t1) (i (l21 (s Itl21)) t2))
            )
         )
      )
      (forall ((Itl21 Nat))
         (= (i (l21 Itl21) t1) (i (l21 Itl21) t2))
      )
   )
)

(assert
   ;Lemma: If nl12(t2) has same properties as nl12(t1), then nl12(t2)=nl12(t1) (for loop at l12)
   (=>
      (and
         (forall ((Itl12 Nat))
            (=>
               (Sub Itl12 (nl12 t2))
               (< (i (l12 Itl12) t1) (alength t1))
            )
         )
         (not
            (< (i (l12 (nl12 t2)) t1) (alength t1))
         )
      )
      (= (nl12 t2) (nl12 t1))
   )
)

(assert
   ;Lemma: If nl21(t2) has same properties as nl21(t1), then nl21(t2)=nl21(t1) (for loop at l21)
   (=>
      (and
         (forall ((Itl21 Nat))
            (=>
               (Sub Itl21 (nl21 t2))
               (< (i (l21 Itl21) t1) (blength t1))
            )
         )
         (not
            (< (i (l21 (nl21 t2)) t1) (blength t1))
         )
      )
      (= (nl21 t2) (nl21 t1))
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l12
   (forall ((itR Nat))
      (=>
         (and
            (= (x (l12 zero) t1) (x (l12 zero) t2))
            (forall ((Itl12 Nat))
               (=>
                  (and
                     (Sub Itl12 itR)
                     (= (x (l12 Itl12) t1) (x (l12 Itl12) t2))
                  )
                  (= (x (l12 (s Itl12)) t1) (x (l12 (s Itl12)) t2))
               )
            )
         )
         (= (x (l12 itR) t1) (x (l12 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l12
   (forall ((itR Nat))
      (=>
         (and
            (= (i (l12 zero) t1) (i (l12 zero) t2))
            (forall ((Itl12 Nat))
               (=>
                  (and
                     (Sub Itl12 itR)
                     (= (i (l12 Itl12) t1) (i (l12 Itl12) t2))
                  )
                  (= (i (l12 (s Itl12)) t1) (i (l12 (s Itl12)) t2))
               )
            )
         )
         (= (i (l12 itR) t1) (i (l12 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l12
   (forall ((itL Nat))
      (=>
         (and
            (= (x (l12 itL) t1) (x (l12 itL) t2))
            (forall ((Itl12 Nat))
               (=>
                  (and
                     (Sub itL (s Itl12))
                     (Sub Itl12 (nl12 t1))
                     (= (x (l12 Itl12) t1) (x (l12 Itl12) t2))
                  )
                  (= (x (l12 (s Itl12)) t1) (x (l12 (s Itl12)) t2))
               )
            )
            (= (l12 (nl12 t1)) (l12 (nl12 t2)))
         )
         (= (x (l12 (nl12 t1)) t1) (x (l12 (nl12 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l12
   (forall ((itL Nat))
      (=>
         (and
            (= (i (l12 itL) t1) (i (l12 itL) t2))
            (forall ((Itl12 Nat))
               (=>
                  (and
                     (Sub itL (s Itl12))
                     (Sub Itl12 (nl12 t1))
                     (= (i (l12 Itl12) t1) (i (l12 Itl12) t2))
                  )
                  (= (i (l12 (s Itl12)) t1) (i (l12 (s Itl12)) t2))
               )
            )
            (= (l12 (nl12 t1)) (l12 (nl12 t2)))
         )
         (= (i (l12 (nl12 t1)) t1) (i (l12 (nl12 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l21
   (forall ((itR Nat))
      (=>
         (and
            (= (x (l21 zero) t1) (x (l21 zero) t2))
            (forall ((Itl21 Nat))
               (=>
                  (and
                     (Sub Itl21 itR)
                     (= (x (l21 Itl21) t1) (x (l21 Itl21) t2))
                  )
                  (= (x (l21 (s Itl21)) t1) (x (l21 (s Itl21)) t2))
               )
            )
         )
         (= (x (l21 itR) t1) (x (l21 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l21
   (forall ((itR Nat))
      (=>
         (and
            (= (i (l21 zero) t1) (i (l21 zero) t2))
            (forall ((Itl21 Nat))
               (=>
                  (and
                     (Sub Itl21 itR)
                     (= (i (l21 Itl21) t1) (i (l21 Itl21) t2))
                  )
                  (= (i (l21 (s Itl21)) t1) (i (l21 (s Itl21)) t2))
               )
            )
         )
         (= (i (l21 itR) t1) (i (l21 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l21
   (forall ((itL Nat))
      (=>
         (and
            (= (x (l21 itL) t1) (x (l21 itL) t2))
            (forall ((Itl21 Nat))
               (=>
                  (and
                     (Sub itL (s Itl21))
                     (Sub Itl21 (nl21 t1))
                     (= (x (l21 Itl21) t1) (x (l21 Itl21) t2))
                  )
                  (= (x (l21 (s Itl21)) t1) (x (l21 (s Itl21)) t2))
               )
            )
            (= (l21 (nl21 t1)) (l21 (nl21 t2)))
         )
         (= (x (l21 (nl21 t1)) t1) (x (l21 (nl21 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l21
   (forall ((itL Nat))
      (=>
         (and
            (= (i (l21 itL) t1) (i (l21 itL) t2))
            (forall ((Itl21 Nat))
               (=>
                  (and
                     (Sub itL (s Itl21))
                     (Sub Itl21 (nl21 t1))
                     (= (i (l21 Itl21) t1) (i (l21 Itl21) t2))
                  )
                  (= (i (l21 (s Itl21)) t1) (i (l21 (s Itl21)) t2))
               )
            )
            (= (l21 (nl21 t1)) (l21 (nl21 t2)))
         )
         (= (i (l21 (nl21 t1)) t1) (i (l21 (nl21 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var x at location l12
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (x (l12 zero) t1) (x (l12 zero) t2))
            (forall ((tr3 Trace)(Itl12 Nat))
               (= (x (l12 (s Itl12)) tr3) (+ (x (l12 Itl12) tr3) 1))
            )
         )
         (< (x (l12 it1) tr) (x (l12 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var i at location l12
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (i (l12 zero) t1) (i (l12 zero) t2))
            (forall ((tr3 Trace)(Itl12 Nat))
               (= (i (l12 (s Itl12)) tr3) (+ (i (l12 Itl12) tr3) 1))
            )
         )
         (< (i (l12 it1) tr) (i (l12 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var x at location l21
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (x (l21 zero) t1) (x (l21 zero) t2))
            (forall ((tr3 Trace)(Itl21 Nat))
               (= (x (l21 (s Itl21)) tr3) (+ (x (l21 Itl21) tr3) 1))
            )
         )
         (< (x (l21 it1) tr) (x (l21 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var i at location l21
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (i (l21 zero) t1) (i (l21 zero) t2))
            (forall ((tr3 Trace)(Itl21 Nat))
               (= (i (l21 (s Itl21)) tr3) (+ (i (l21 Itl21) tr3) 1))
            )
         )
         (< (i (l21 it1) tr) (i (l21 it2) tr))
      )
   )
)

(assert
   ;Theory axiom: forall x y z. (x + y) + z) = (x + z) + y
   (forall ((xInt Int)(yInt Int)(zInt Int))
      (= (+ (+ xInt yInt) zInt) (+ (+ xInt zInt) yInt))
   )
)

; negated conjecture
(assert
   (not
      (=>
         (and
            (forall ((j Int))
               (and
                  (= (a j t1) (a j t2))
                  (= (b j t1) (b j t2))
               )
            )
            (= (alength t1) (alength t2))
            (= (blength t1) (blength t2))
            (= (k t1) (k t2))
         )
         (= (x main_end t1) (x main_end t2))
      )
   )
)

(check-sat)

(exit)
