(set-info :smt-lib-version 2.6)
(set-logic UFDTLIA)
(set-info :source |
Generated by: Bernhard Gleiss
Generated on: 2019-3-11
Generator: Rapid
Application: Software Verification
Target solver: Vampire
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "crafted")
(set-info :status unknown)

(declare-datatypes ((Nat 0)) (( (zero) (s (p Nat)) )) )
(declare-sort Time 0)
(declare-sort Trace 0)
(declare-const main_end Time)
(declare-fun nl22 (Trace) Nat)
(declare-const l21 Time)
(declare-fun l14 (Nat) Time)
(declare-fun i (Time Trace) Int)
(declare-fun x (Time Trace) Int)
(declare-fun nl14 (Trace) Nat)
(declare-fun k2 (Trace) Int)
(declare-fun k1 (Trace) Int)
(declare-const l27 Time)
(declare-fun alength (Trace) Int)
(declare-fun b (Int Trace) Int)
(declare-fun l24 (Nat) Time)
(declare-const t1 Trace)
(declare-const l19 Time)
(declare-fun l17 (Nat) Time)
(declare-const t2 Trace)
(declare-const l11 Time)
(declare-fun l16 (Nat) Time)
(declare-const l10 Time)
(declare-fun a (Int Trace) Int)
(declare-const l12 Time)
(declare-fun l22 (Nat) Time)
(declare-fun y (Time Trace) Int)
(declare-fun Sub (Nat Nat) Bool)
(assert (forall ((it Nat)) (Sub it (s it))) )
(assert (forall ((it1 Nat)(it2 Nat)) (=> (Sub it1 it2) (Sub it1 (s it2))) ))
(declare-fun l25 (Nat) Time)
(declare-fun blength (Trace) Int)
(declare-const l29 Time)

(assert
   ;Semantics of function main
   (and
      (forall ((tr Trace))
         ;Update variable x at location l10
         (= (x l11 tr) 0)
      )
      (forall ((tr Trace))
         ;Update variable y at location l11
         (and
            (= (y l12 tr) 0)
            (= (x l12 tr) (x l11 tr))
         )
      )
      (forall ((tr Trace))
         ;Update variable i at location l12
         (and
            (= (i (l14 zero) tr) 0)
            (= (x (l14 zero) tr) (x l12 tr))
            (= (y (l14 zero) tr) (y l12 tr))
         )
      )
      (forall ((tr Trace))
         ;Loop at location l14
         (and
            ;Jumping into the body doesn't change the variable values
            (forall ((Itl14 Nat))
               (and
                  (= (y (l16 Itl14) tr) (y (l14 Itl14) tr))
                  (= (i (l16 Itl14) tr) (i (l14 Itl14) tr))
                  (= (x (l16 Itl14) tr) (x (l14 Itl14) tr))
               )
            )
            ;Semantics of the body
            (forall ((Itl14 Nat))
               (and
                  ;Update variable x at location l16
                  (and
                     (= (x (l17 Itl14) tr) (+ (x (l16 Itl14) tr) (a (i (l16 Itl14) tr) tr)))
                     (= (y (l17 Itl14) tr) (y (l16 Itl14) tr))
                     (= (i (l17 Itl14) tr) (i (l16 Itl14) tr))
                  )
                  ;Update variable i at location l17
                  (and
                     (= (i (l14 (s Itl14)) tr) (+ (i (l17 Itl14) tr) 1))
                     (= (x (l14 (s Itl14)) tr) (x (l17 Itl14) tr))
                     (= (y (l14 (s Itl14)) tr) (y (l17 Itl14) tr))
                  )
               )
            )
            ;The loop-condition holds always before the last iteration
            (forall ((Itl14 Nat))
               (=>
                  (Sub Itl14 (nl14 tr))
                  (< (i (l14 Itl14) tr) (alength tr))
               )
            )
            ;The loop-condition doesn't hold in the last iteration
            (not
               (< (i (l14 (nl14 tr)) tr) (alength tr))
            )
            ;The values after the while-loop are the values from the last iteration
            (and
               (= (y l19 tr) (y (l14 (nl14 tr)) tr))
               (= (i l19 tr) (i (l14 (nl14 tr)) tr))
               (= (x l19 tr) (x (l14 (nl14 tr)) tr))
            )
         )
      )
      (forall ((tr Trace))
         ;Update variable x at location l19
         (and
            (= (x l21 tr) (+ (x l19 tr) (k1 tr)))
            (= (y l21 tr) (y l19 tr))
            (= (i l21 tr) (i l19 tr))
         )
      )
      (forall ((tr Trace))
         ;Update variable i at location l21
         (and
            (= (i (l22 zero) tr) 0)
            (= (x (l22 zero) tr) (x l21 tr))
            (= (y (l22 zero) tr) (y l21 tr))
         )
      )
      (forall ((tr Trace))
         ;Loop at location l22
         (and
            ;Jumping into the body doesn't change the variable values
            (forall ((Itl22 Nat))
               (and
                  (= (y (l24 Itl22) tr) (y (l22 Itl22) tr))
                  (= (i (l24 Itl22) tr) (i (l22 Itl22) tr))
                  (= (x (l24 Itl22) tr) (x (l22 Itl22) tr))
               )
            )
            ;Semantics of the body
            (forall ((Itl22 Nat))
               (and
                  ;Update variable y at location l24
                  (and
                     (= (y (l25 Itl22) tr) (+ (y (l24 Itl22) tr) (b (i (l24 Itl22) tr) tr)))
                     (= (x (l25 Itl22) tr) (x (l24 Itl22) tr))
                     (= (i (l25 Itl22) tr) (i (l24 Itl22) tr))
                  )
                  ;Update variable i at location l25
                  (and
                     (= (i (l22 (s Itl22)) tr) (+ (i (l25 Itl22) tr) 1))
                     (= (x (l22 (s Itl22)) tr) (x (l25 Itl22) tr))
                     (= (y (l22 (s Itl22)) tr) (y (l25 Itl22) tr))
                  )
               )
            )
            ;The loop-condition holds always before the last iteration
            (forall ((Itl22 Nat))
               (=>
                  (Sub Itl22 (nl22 tr))
                  (< (i (l22 Itl22) tr) (blength tr))
               )
            )
            ;The loop-condition doesn't hold in the last iteration
            (not
               (< (i (l22 (nl22 tr)) tr) (blength tr))
            )
            ;The values after the while-loop are the values from the last iteration
            (and
               (= (y l27 tr) (y (l22 (nl22 tr)) tr))
               (= (i l27 tr) (i (l22 (nl22 tr)) tr))
               (= (x l27 tr) (x (l22 (nl22 tr)) tr))
            )
         )
      )
      (forall ((tr Trace))
         ;Update variable y at location l27
         (and
            (= (y l29 tr) (+ (y l27 tr) (k2 tr)))
            (= (x l29 tr) (x l27 tr))
            (= (i l29 tr) (i l27 tr))
         )
      )
      (forall ((tr Trace))
         ;Update variable x at location l29
         (and
            (= (x main_end tr) (+ (x l29 tr) (y l29 tr)))
            (= (y main_end tr) (y l29 tr))
            (= (i main_end tr) (i l29 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var y and location l14
      (=>
         (forall ((Itl14 Nat))
            (=>
               (Sub Itl14 (nl14 tr))
               (= (y (l14 Itl14) tr) (y (l14 (s Itl14)) tr))
            )
         )
         (= (y (l14 zero) tr) (y (l14 (nl14 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var i and location l14
      (=>
         (forall ((Itl14 Nat))
            (=>
               (Sub Itl14 (nl14 tr))
               (= (i (l14 Itl14) tr) (i (l14 (s Itl14)) tr))
            )
         )
         (= (i (l14 zero) tr) (i (l14 (nl14 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var x and location l14
      (=>
         (forall ((Itl14 Nat))
            (=>
               (Sub Itl14 (nl14 tr))
               (= (x (l14 Itl14) tr) (x (l14 (s Itl14)) tr))
            )
         )
         (= (x (l14 zero) tr) (x (l14 (nl14 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var y and location l22
      (=>
         (forall ((Itl22 Nat))
            (=>
               (Sub Itl22 (nl22 tr))
               (= (y (l22 Itl22) tr) (y (l22 (s Itl22)) tr))
            )
         )
         (= (y (l22 zero) tr) (y (l22 (nl22 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var i and location l22
      (=>
         (forall ((Itl22 Nat))
            (=>
               (Sub Itl22 (nl22 tr))
               (= (i (l22 Itl22) tr) (i (l22 (s Itl22)) tr))
            )
         )
         (= (i (l22 zero) tr) (i (l22 (nl22 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var x and location l22
      (=>
         (forall ((Itl22 Nat))
            (=>
               (Sub Itl22 (nl22 tr))
               (= (x (l22 Itl22) tr) (x (l22 (s Itl22)) tr))
            )
         )
         (= (x (l22 zero) tr) (x (l22 (nl22 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: if the condition of the loop at l14 holds initially, there is at least one loop iteration
      (=>
         (< (i (l14 zero) tr) (alength tr))
         (exists ((Itl14 Nat))
            (= (s Itl14) (nl14 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: if the condition of the loop at l22 holds initially, there is at least one loop iteration
      (=>
         (< (i (l22 zero) tr) (blength tr))
         (exists ((Itl22 Nat))
            (= (s Itl22) (nl22 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var y at location l14
      (forall ((xInt Int)(Itl14 Nat))
         (=>
            (and
               (<= (y (l14 zero) tr) xInt)
               (< xInt (y (l14 (nl14 tr)) tr))
               (= (y (l14 (s Itl14)) tr) (+ (y (l14 Itl14) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (y (l14 it) tr) xInt)
                  (Sub it (nl14 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var i at location l14
      (forall ((xInt Int)(Itl14 Nat))
         (=>
            (and
               (<= (i (l14 zero) tr) xInt)
               (< xInt (i (l14 (nl14 tr)) tr))
               (= (i (l14 (s Itl14)) tr) (+ (i (l14 Itl14) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (i (l14 it) tr) xInt)
                  (Sub it (nl14 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var x at location l14
      (forall ((xInt Int)(Itl14 Nat))
         (=>
            (and
               (<= (x (l14 zero) tr) xInt)
               (< xInt (x (l14 (nl14 tr)) tr))
               (= (x (l14 (s Itl14)) tr) (+ (x (l14 Itl14) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (x (l14 it) tr) xInt)
                  (Sub it (nl14 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var y at location l22
      (forall ((xInt Int)(Itl22 Nat))
         (=>
            (and
               (<= (y (l22 zero) tr) xInt)
               (< xInt (y (l22 (nl22 tr)) tr))
               (= (y (l22 (s Itl22)) tr) (+ (y (l22 Itl22) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (y (l22 it) tr) xInt)
                  (Sub it (nl22 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var i at location l22
      (forall ((xInt Int)(Itl22 Nat))
         (=>
            (and
               (<= (i (l22 zero) tr) xInt)
               (< xInt (i (l22 (nl22 tr)) tr))
               (= (i (l22 (s Itl22)) tr) (+ (i (l22 Itl22) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (i (l22 it) tr) xInt)
                  (Sub it (nl22 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var x at location l22
      (forall ((xInt Int)(Itl22 Nat))
         (=>
            (and
               (<= (x (l22 zero) tr) xInt)
               (< xInt (x (l22 (nl22 tr)) tr))
               (= (x (l22 (s Itl22)) tr) (+ (x (l22 Itl22) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (x (l22 it) tr) xInt)
                  (Sub it (nl22 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl14 Nat))
         (=>
            (and
               (Sub (s Itl14) (nl14 tr))
               (= (y (l14 (s Itl14)) tr) (+ (y (l14 Itl14) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (y (l14 it1) tr) (y (l14 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl14 Nat))
         (=>
            (and
               (Sub (s Itl14) (nl14 tr))
               (= (i (l14 (s Itl14)) tr) (+ (i (l14 Itl14) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (i (l14 it1) tr) (i (l14 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl14 Nat))
         (=>
            (and
               (Sub (s Itl14) (nl14 tr))
               (= (x (l14 (s Itl14)) tr) (+ (x (l14 Itl14) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (x (l14 it1) tr) (x (l14 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl22 Nat))
         (=>
            (and
               (Sub (s Itl22) (nl22 tr))
               (= (y (l22 (s Itl22)) tr) (+ (y (l22 Itl22) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (y (l22 it1) tr) (y (l22 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl22 Nat))
         (=>
            (and
               (Sub (s Itl22) (nl22 tr))
               (= (i (l22 (s Itl22)) tr) (+ (i (l22 Itl22) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (i (l22 it1) tr) (i (l22 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl22 Nat))
         (=>
            (and
               (Sub (s Itl22) (nl22 tr))
               (= (x (l22 (s Itl22)) tr) (+ (x (l22 Itl22) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (x (l22 it1) tr) (x (l22 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   ;Lemma: Var y at loop l14 has same values on both traces
   (=>
      (and
         (= (y (l14 zero) t1) (y (l14 zero) t2))
         (forall ((Itl14 Nat))
            (=>
               (= (y (l14 Itl14) t1) (y (l14 Itl14) t2))
               (= (y (l14 (s Itl14)) t1) (y (l14 (s Itl14)) t2))
            )
         )
      )
      (forall ((Itl14 Nat))
         (= (y (l14 Itl14) t1) (y (l14 Itl14) t2))
      )
   )
)

(assert
   ;Lemma: Var i at loop l14 has same values on both traces
   (=>
      (and
         (= (i (l14 zero) t1) (i (l14 zero) t2))
         (forall ((Itl14 Nat))
            (=>
               (= (i (l14 Itl14) t1) (i (l14 Itl14) t2))
               (= (i (l14 (s Itl14)) t1) (i (l14 (s Itl14)) t2))
            )
         )
      )
      (forall ((Itl14 Nat))
         (= (i (l14 Itl14) t1) (i (l14 Itl14) t2))
      )
   )
)

(assert
   ;Lemma: Var x at loop l14 has same values on both traces
   (=>
      (and
         (= (x (l14 zero) t1) (x (l14 zero) t2))
         (forall ((Itl14 Nat))
            (=>
               (= (x (l14 Itl14) t1) (x (l14 Itl14) t2))
               (= (x (l14 (s Itl14)) t1) (x (l14 (s Itl14)) t2))
            )
         )
      )
      (forall ((Itl14 Nat))
         (= (x (l14 Itl14) t1) (x (l14 Itl14) t2))
      )
   )
)

(assert
   ;Lemma: Var y at loop l22 has same values on both traces
   (=>
      (and
         (= (y (l22 zero) t1) (y (l22 zero) t2))
         (forall ((Itl22 Nat))
            (=>
               (= (y (l22 Itl22) t1) (y (l22 Itl22) t2))
               (= (y (l22 (s Itl22)) t1) (y (l22 (s Itl22)) t2))
            )
         )
      )
      (forall ((Itl22 Nat))
         (= (y (l22 Itl22) t1) (y (l22 Itl22) t2))
      )
   )
)

(assert
   ;Lemma: Var i at loop l22 has same values on both traces
   (=>
      (and
         (= (i (l22 zero) t1) (i (l22 zero) t2))
         (forall ((Itl22 Nat))
            (=>
               (= (i (l22 Itl22) t1) (i (l22 Itl22) t2))
               (= (i (l22 (s Itl22)) t1) (i (l22 (s Itl22)) t2))
            )
         )
      )
      (forall ((Itl22 Nat))
         (= (i (l22 Itl22) t1) (i (l22 Itl22) t2))
      )
   )
)

(assert
   ;Lemma: Var x at loop l22 has same values on both traces
   (=>
      (and
         (= (x (l22 zero) t1) (x (l22 zero) t2))
         (forall ((Itl22 Nat))
            (=>
               (= (x (l22 Itl22) t1) (x (l22 Itl22) t2))
               (= (x (l22 (s Itl22)) t1) (x (l22 (s Itl22)) t2))
            )
         )
      )
      (forall ((Itl22 Nat))
         (= (x (l22 Itl22) t1) (x (l22 Itl22) t2))
      )
   )
)

(assert
   ;Lemma: If nl14(t2) has same properties as nl14(t1), then nl14(t2)=nl14(t1) (for loop at l14)
   (=>
      (and
         (forall ((Itl14 Nat))
            (=>
               (Sub Itl14 (nl14 t2))
               (< (i (l14 Itl14) t1) (alength t1))
            )
         )
         (not
            (< (i (l14 (nl14 t2)) t1) (alength t1))
         )
      )
      (= (nl14 t2) (nl14 t1))
   )
)

(assert
   ;Lemma: If nl22(t2) has same properties as nl22(t1), then nl22(t2)=nl22(t1) (for loop at l22)
   (=>
      (and
         (forall ((Itl22 Nat))
            (=>
               (Sub Itl22 (nl22 t2))
               (< (i (l22 Itl22) t1) (blength t1))
            )
         )
         (not
            (< (i (l22 (nl22 t2)) t1) (blength t1))
         )
      )
      (= (nl22 t2) (nl22 t1))
   )
)

(assert
   ;Lemma: Equality preservation over traces for var y at location l14
   (forall ((itR Nat))
      (=>
         (and
            (= (y (l14 zero) t1) (y (l14 zero) t2))
            (forall ((Itl14 Nat))
               (=>
                  (and
                     (Sub Itl14 itR)
                     (= (y (l14 Itl14) t1) (y (l14 Itl14) t2))
                  )
                  (= (y (l14 (s Itl14)) t1) (y (l14 (s Itl14)) t2))
               )
            )
         )
         (= (y (l14 itR) t1) (y (l14 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l14
   (forall ((itR Nat))
      (=>
         (and
            (= (i (l14 zero) t1) (i (l14 zero) t2))
            (forall ((Itl14 Nat))
               (=>
                  (and
                     (Sub Itl14 itR)
                     (= (i (l14 Itl14) t1) (i (l14 Itl14) t2))
                  )
                  (= (i (l14 (s Itl14)) t1) (i (l14 (s Itl14)) t2))
               )
            )
         )
         (= (i (l14 itR) t1) (i (l14 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l14
   (forall ((itR Nat))
      (=>
         (and
            (= (x (l14 zero) t1) (x (l14 zero) t2))
            (forall ((Itl14 Nat))
               (=>
                  (and
                     (Sub Itl14 itR)
                     (= (x (l14 Itl14) t1) (x (l14 Itl14) t2))
                  )
                  (= (x (l14 (s Itl14)) t1) (x (l14 (s Itl14)) t2))
               )
            )
         )
         (= (x (l14 itR) t1) (x (l14 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var y at location l14
   (forall ((itL Nat))
      (=>
         (and
            (= (y (l14 itL) t1) (y (l14 itL) t2))
            (forall ((Itl14 Nat))
               (=>
                  (and
                     (Sub itL (s Itl14))
                     (Sub Itl14 (nl14 t1))
                     (= (y (l14 Itl14) t1) (y (l14 Itl14) t2))
                  )
                  (= (y (l14 (s Itl14)) t1) (y (l14 (s Itl14)) t2))
               )
            )
            (= (l14 (nl14 t1)) (l14 (nl14 t2)))
         )
         (= (y (l14 (nl14 t1)) t1) (y (l14 (nl14 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l14
   (forall ((itL Nat))
      (=>
         (and
            (= (i (l14 itL) t1) (i (l14 itL) t2))
            (forall ((Itl14 Nat))
               (=>
                  (and
                     (Sub itL (s Itl14))
                     (Sub Itl14 (nl14 t1))
                     (= (i (l14 Itl14) t1) (i (l14 Itl14) t2))
                  )
                  (= (i (l14 (s Itl14)) t1) (i (l14 (s Itl14)) t2))
               )
            )
            (= (l14 (nl14 t1)) (l14 (nl14 t2)))
         )
         (= (i (l14 (nl14 t1)) t1) (i (l14 (nl14 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l14
   (forall ((itL Nat))
      (=>
         (and
            (= (x (l14 itL) t1) (x (l14 itL) t2))
            (forall ((Itl14 Nat))
               (=>
                  (and
                     (Sub itL (s Itl14))
                     (Sub Itl14 (nl14 t1))
                     (= (x (l14 Itl14) t1) (x (l14 Itl14) t2))
                  )
                  (= (x (l14 (s Itl14)) t1) (x (l14 (s Itl14)) t2))
               )
            )
            (= (l14 (nl14 t1)) (l14 (nl14 t2)))
         )
         (= (x (l14 (nl14 t1)) t1) (x (l14 (nl14 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var y at location l22
   (forall ((itR Nat))
      (=>
         (and
            (= (y (l22 zero) t1) (y (l22 zero) t2))
            (forall ((Itl22 Nat))
               (=>
                  (and
                     (Sub Itl22 itR)
                     (= (y (l22 Itl22) t1) (y (l22 Itl22) t2))
                  )
                  (= (y (l22 (s Itl22)) t1) (y (l22 (s Itl22)) t2))
               )
            )
         )
         (= (y (l22 itR) t1) (y (l22 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l22
   (forall ((itR Nat))
      (=>
         (and
            (= (i (l22 zero) t1) (i (l22 zero) t2))
            (forall ((Itl22 Nat))
               (=>
                  (and
                     (Sub Itl22 itR)
                     (= (i (l22 Itl22) t1) (i (l22 Itl22) t2))
                  )
                  (= (i (l22 (s Itl22)) t1) (i (l22 (s Itl22)) t2))
               )
            )
         )
         (= (i (l22 itR) t1) (i (l22 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l22
   (forall ((itR Nat))
      (=>
         (and
            (= (x (l22 zero) t1) (x (l22 zero) t2))
            (forall ((Itl22 Nat))
               (=>
                  (and
                     (Sub Itl22 itR)
                     (= (x (l22 Itl22) t1) (x (l22 Itl22) t2))
                  )
                  (= (x (l22 (s Itl22)) t1) (x (l22 (s Itl22)) t2))
               )
            )
         )
         (= (x (l22 itR) t1) (x (l22 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var y at location l22
   (forall ((itL Nat))
      (=>
         (and
            (= (y (l22 itL) t1) (y (l22 itL) t2))
            (forall ((Itl22 Nat))
               (=>
                  (and
                     (Sub itL (s Itl22))
                     (Sub Itl22 (nl22 t1))
                     (= (y (l22 Itl22) t1) (y (l22 Itl22) t2))
                  )
                  (= (y (l22 (s Itl22)) t1) (y (l22 (s Itl22)) t2))
               )
            )
            (= (l22 (nl22 t1)) (l22 (nl22 t2)))
         )
         (= (y (l22 (nl22 t1)) t1) (y (l22 (nl22 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l22
   (forall ((itL Nat))
      (=>
         (and
            (= (i (l22 itL) t1) (i (l22 itL) t2))
            (forall ((Itl22 Nat))
               (=>
                  (and
                     (Sub itL (s Itl22))
                     (Sub Itl22 (nl22 t1))
                     (= (i (l22 Itl22) t1) (i (l22 Itl22) t2))
                  )
                  (= (i (l22 (s Itl22)) t1) (i (l22 (s Itl22)) t2))
               )
            )
            (= (l22 (nl22 t1)) (l22 (nl22 t2)))
         )
         (= (i (l22 (nl22 t1)) t1) (i (l22 (nl22 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l22
   (forall ((itL Nat))
      (=>
         (and
            (= (x (l22 itL) t1) (x (l22 itL) t2))
            (forall ((Itl22 Nat))
               (=>
                  (and
                     (Sub itL (s Itl22))
                     (Sub Itl22 (nl22 t1))
                     (= (x (l22 Itl22) t1) (x (l22 Itl22) t2))
                  )
                  (= (x (l22 (s Itl22)) t1) (x (l22 (s Itl22)) t2))
               )
            )
            (= (l22 (nl22 t1)) (l22 (nl22 t2)))
         )
         (= (x (l22 (nl22 t1)) t1) (x (l22 (nl22 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var y at location l14
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (y (l14 zero) t1) (y (l14 zero) t2))
            (forall ((tr3 Trace)(Itl14 Nat))
               (= (y (l14 (s Itl14)) tr3) (+ (y (l14 Itl14) tr3) 1))
            )
         )
         (< (y (l14 it1) tr) (y (l14 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var i at location l14
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (i (l14 zero) t1) (i (l14 zero) t2))
            (forall ((tr3 Trace)(Itl14 Nat))
               (= (i (l14 (s Itl14)) tr3) (+ (i (l14 Itl14) tr3) 1))
            )
         )
         (< (i (l14 it1) tr) (i (l14 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var x at location l14
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (x (l14 zero) t1) (x (l14 zero) t2))
            (forall ((tr3 Trace)(Itl14 Nat))
               (= (x (l14 (s Itl14)) tr3) (+ (x (l14 Itl14) tr3) 1))
            )
         )
         (< (x (l14 it1) tr) (x (l14 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var y at location l22
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (y (l22 zero) t1) (y (l22 zero) t2))
            (forall ((tr3 Trace)(Itl22 Nat))
               (= (y (l22 (s Itl22)) tr3) (+ (y (l22 Itl22) tr3) 1))
            )
         )
         (< (y (l22 it1) tr) (y (l22 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var i at location l22
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (i (l22 zero) t1) (i (l22 zero) t2))
            (forall ((tr3 Trace)(Itl22 Nat))
               (= (i (l22 (s Itl22)) tr3) (+ (i (l22 Itl22) tr3) 1))
            )
         )
         (< (i (l22 it1) tr) (i (l22 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var x at location l22
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (x (l22 zero) t1) (x (l22 zero) t2))
            (forall ((tr3 Trace)(Itl22 Nat))
               (= (x (l22 (s Itl22)) tr3) (+ (x (l22 Itl22) tr3) 1))
            )
         )
         (< (x (l22 it1) tr) (x (l22 it2) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Static analysis lemma for var y at location l14
      (forall ((Itl14 Nat))
         (= (y (l14 Itl14) tr) (y (l14 zero) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Static analysis lemma for var x at location l22
      (forall ((Itl22 Nat))
         (= (x (l22 Itl22) tr) (x (l22 zero) tr))
      )
   )
)

(assert
   ;Theory axiom: forall x y z. (x + y) + z) = (x + z) + y
   (forall ((xInt Int)(yInt Int)(zInt Int))
      (= (+ (+ xInt yInt) zInt) (+ (+ xInt zInt) yInt))
   )
)

; negated conjecture
(assert
   (not
      (=>
         (and
            (forall ((j Int))
               (and
                  (= (a j t1) (a j t2))
                  (= (b j t1) (b j t2))
               )
            )
            (= (alength t1) (alength t2))
            (= (blength t1) (blength t2))
            (= (k1 t1) 1)
            (= (k1 t2) 0)
            (= (k2 t1) 0)
            (= (k2 t2) 1)
         )
         (and
            (= (x l21 t1) (+ (x l21 t2) 1))
            (= (+ (y main_end t1) 1) (y main_end t2))
            (= (x main_end t1) (x main_end t2))
         )
      )
   )
)

(check-sat)

(exit)
