(set-info :smt-lib-version 2.6)
(set-logic UFDTLIA)
(set-info :source |
Generated by: Bernhard Gleiss
Generated on: 2019-3-11
Generator: Rapid
Application: Software Verification
Target solver: Vampire
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "crafted")
(set-info :status unknown)

(declare-datatypes ((Nat 0)) (( (zero) (s (p Nat)) )) )
(declare-sort Time 0)
(declare-sort Trace 0)
(declare-const l28 Time)
(declare-fun nl23 (Trace) Nat)
(declare-const l20 Time)
(declare-fun l18 (Nat) Time)
(declare-fun l23 (Nat) Time)
(declare-fun l15 (Nat) Time)
(declare-fun i (Time Trace) Int)
(declare-const main_end Time)
(declare-fun z (Time Trace) Int)
(declare-fun x (Time Trace) Int)
(declare-fun k2 (Trace) Int)
(declare-fun k1 (Trace) Int)
(declare-fun l26 (Nat) Time)
(declare-fun alength (Trace) Int)
(declare-fun b (Int Trace) Int)
(declare-const t1 Trace)
(declare-fun l17 (Nat) Time)
(declare-const t2 Trace)
(declare-const l11 Time)
(declare-const l30 Time)
(declare-const l10 Time)
(declare-fun a (Int Trace) Int)
(declare-const l22 Time)
(declare-fun y (Time Trace) Int)
(declare-fun Sub (Nat Nat) Bool)
(assert (forall ((it Nat)) (Sub it (s it))) )
(assert (forall ((it1 Nat)(it2 Nat)) (=> (Sub it1 it2) (Sub it1 (s it2))) ))
(declare-fun l25 (Nat) Time)
(declare-fun nl15 (Trace) Nat)
(declare-const l13 Time)
(declare-fun blength (Trace) Int)

(assert
   ;Semantics of function main
   (and
      (forall ((tr Trace))
         ;Update variable x at location l10
         (= (x l11 tr) 0)
      )
      (forall ((tr Trace))
         ;Update variable y at location l11
         (and
            (= (y l13 tr) 0)
            (= (x l13 tr) (x l11 tr))
         )
      )
      (forall ((tr Trace))
         ;Update variable i at location l13
         (and
            (= (i (l15 zero) tr) 0)
            (= (x (l15 zero) tr) (x l13 tr))
            (= (y (l15 zero) tr) (y l13 tr))
            (= (z (l15 zero) tr) (z l13 tr))
         )
      )
      (forall ((tr Trace))
         ;Loop at location l15
         (and
            ;Jumping into the body doesn't change the variable values
            (forall ((Itl15 Nat))
               (and
                  (= (z (l17 Itl15) tr) (z (l15 Itl15) tr))
                  (= (y (l17 Itl15) tr) (y (l15 Itl15) tr))
                  (= (i (l17 Itl15) tr) (i (l15 Itl15) tr))
                  (= (x (l17 Itl15) tr) (x (l15 Itl15) tr))
               )
            )
            ;Semantics of the body
            (forall ((Itl15 Nat))
               (and
                  ;Update variable x at location l17
                  (and
                     (= (x (l18 Itl15) tr) (+ (x (l17 Itl15) tr) (a (i (l17 Itl15) tr) tr)))
                     (= (i (l18 Itl15) tr) (i (l17 Itl15) tr))
                     (= (y (l18 Itl15) tr) (y (l17 Itl15) tr))
                     (= (z (l18 Itl15) tr) (z (l17 Itl15) tr))
                  )
                  ;Update variable i at location l18
                  (and
                     (= (i (l15 (s Itl15)) tr) (+ (i (l18 Itl15) tr) 1))
                     (= (x (l15 (s Itl15)) tr) (x (l18 Itl15) tr))
                     (= (y (l15 (s Itl15)) tr) (y (l18 Itl15) tr))
                     (= (z (l15 (s Itl15)) tr) (z (l18 Itl15) tr))
                  )
               )
            )
            ;The loop-condition holds always before the last iteration
            (forall ((Itl15 Nat))
               (=>
                  (Sub Itl15 (nl15 tr))
                  (< (i (l15 Itl15) tr) (alength tr))
               )
            )
            ;The loop-condition doesn't hold in the last iteration
            (not
               (< (i (l15 (nl15 tr)) tr) (alength tr))
            )
            ;The values after the while-loop are the values from the last iteration
            (and
               (= (z l20 tr) (z (l15 (nl15 tr)) tr))
               (= (y l20 tr) (y (l15 (nl15 tr)) tr))
               (= (i l20 tr) (i (l15 (nl15 tr)) tr))
               (= (x l20 tr) (x (l15 (nl15 tr)) tr))
            )
         )
      )
      (forall ((tr Trace))
         ;Update variable x at location l20
         (and
            (= (x l22 tr) (+ (x l20 tr) (k1 tr)))
            (= (i l22 tr) (i l20 tr))
            (= (y l22 tr) (y l20 tr))
            (= (z l22 tr) (z l20 tr))
         )
      )
      (forall ((tr Trace))
         ;Update variable i at location l22
         (and
            (= (i (l23 zero) tr) 0)
            (= (x (l23 zero) tr) (x l22 tr))
            (= (y (l23 zero) tr) (y l22 tr))
            (= (z (l23 zero) tr) (z l22 tr))
         )
      )
      (forall ((tr Trace))
         ;Loop at location l23
         (and
            ;Jumping into the body doesn't change the variable values
            (forall ((Itl23 Nat))
               (and
                  (= (z (l25 Itl23) tr) (z (l23 Itl23) tr))
                  (= (y (l25 Itl23) tr) (y (l23 Itl23) tr))
                  (= (i (l25 Itl23) tr) (i (l23 Itl23) tr))
                  (= (x (l25 Itl23) tr) (x (l23 Itl23) tr))
               )
            )
            ;Semantics of the body
            (forall ((Itl23 Nat))
               (and
                  ;Update variable y at location l25
                  (and
                     (= (y (l26 Itl23) tr) (+ (y (l25 Itl23) tr) (b (i (l25 Itl23) tr) tr)))
                     (= (x (l26 Itl23) tr) (x (l25 Itl23) tr))
                     (= (i (l26 Itl23) tr) (i (l25 Itl23) tr))
                     (= (z (l26 Itl23) tr) (z (l25 Itl23) tr))
                  )
                  ;Update variable i at location l26
                  (and
                     (= (i (l23 (s Itl23)) tr) (+ (i (l26 Itl23) tr) 1))
                     (= (x (l23 (s Itl23)) tr) (x (l26 Itl23) tr))
                     (= (y (l23 (s Itl23)) tr) (y (l26 Itl23) tr))
                     (= (z (l23 (s Itl23)) tr) (z (l26 Itl23) tr))
                  )
               )
            )
            ;The loop-condition holds always before the last iteration
            (forall ((Itl23 Nat))
               (=>
                  (Sub Itl23 (nl23 tr))
                  (< (i (l23 Itl23) tr) (blength tr))
               )
            )
            ;The loop-condition doesn't hold in the last iteration
            (not
               (< (i (l23 (nl23 tr)) tr) (blength tr))
            )
            ;The values after the while-loop are the values from the last iteration
            (and
               (= (z l28 tr) (z (l23 (nl23 tr)) tr))
               (= (y l28 tr) (y (l23 (nl23 tr)) tr))
               (= (i l28 tr) (i (l23 (nl23 tr)) tr))
               (= (x l28 tr) (x (l23 (nl23 tr)) tr))
            )
         )
      )
      (forall ((tr Trace))
         ;Update variable y at location l28
         (and
            (= (y l30 tr) (+ (y l28 tr) (k2 tr)))
            (= (x l30 tr) (x l28 tr))
            (= (i l30 tr) (i l28 tr))
            (= (z l30 tr) (z l28 tr))
         )
      )
      (forall ((tr Trace))
         ;Update variable z at location l30
         (and
            (= (z main_end tr) (+ (x l30 tr) (y l30 tr)))
            (= (x main_end tr) (x l30 tr))
            (= (i main_end tr) (i l30 tr))
            (= (y main_end tr) (y l30 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var z and location l15
      (=>
         (forall ((Itl15 Nat))
            (=>
               (Sub Itl15 (nl15 tr))
               (= (z (l15 Itl15) tr) (z (l15 (s Itl15)) tr))
            )
         )
         (= (z (l15 zero) tr) (z (l15 (nl15 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var y and location l15
      (=>
         (forall ((Itl15 Nat))
            (=>
               (Sub Itl15 (nl15 tr))
               (= (y (l15 Itl15) tr) (y (l15 (s Itl15)) tr))
            )
         )
         (= (y (l15 zero) tr) (y (l15 (nl15 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var i and location l15
      (=>
         (forall ((Itl15 Nat))
            (=>
               (Sub Itl15 (nl15 tr))
               (= (i (l15 Itl15) tr) (i (l15 (s Itl15)) tr))
            )
         )
         (= (i (l15 zero) tr) (i (l15 (nl15 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var x and location l15
      (=>
         (forall ((Itl15 Nat))
            (=>
               (Sub Itl15 (nl15 tr))
               (= (x (l15 Itl15) tr) (x (l15 (s Itl15)) tr))
            )
         )
         (= (x (l15 zero) tr) (x (l15 (nl15 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var z and location l23
      (=>
         (forall ((Itl23 Nat))
            (=>
               (Sub Itl23 (nl23 tr))
               (= (z (l23 Itl23) tr) (z (l23 (s Itl23)) tr))
            )
         )
         (= (z (l23 zero) tr) (z (l23 (nl23 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var y and location l23
      (=>
         (forall ((Itl23 Nat))
            (=>
               (Sub Itl23 (nl23 tr))
               (= (y (l23 Itl23) tr) (y (l23 (s Itl23)) tr))
            )
         )
         (= (y (l23 zero) tr) (y (l23 (nl23 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var i and location l23
      (=>
         (forall ((Itl23 Nat))
            (=>
               (Sub Itl23 (nl23 tr))
               (= (i (l23 Itl23) tr) (i (l23 (s Itl23)) tr))
            )
         )
         (= (i (l23 zero) tr) (i (l23 (nl23 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Induction on = for var x and location l23
      (=>
         (forall ((Itl23 Nat))
            (=>
               (Sub Itl23 (nl23 tr))
               (= (x (l23 Itl23) tr) (x (l23 (s Itl23)) tr))
            )
         )
         (= (x (l23 zero) tr) (x (l23 (nl23 tr)) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: if the condition of the loop at l15 holds initially, there is at least one loop iteration
      (=>
         (< (i (l15 zero) tr) (alength tr))
         (exists ((Itl15 Nat))
            (= (s Itl15) (nl15 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: if the condition of the loop at l23 holds initially, there is at least one loop iteration
      (=>
         (< (i (l23 zero) tr) (blength tr))
         (exists ((Itl23 Nat))
            (= (s Itl23) (nl23 tr))
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var z at location l15
      (forall ((xInt Int)(Itl15 Nat))
         (=>
            (and
               (<= (z (l15 zero) tr) xInt)
               (< xInt (z (l15 (nl15 tr)) tr))
               (= (z (l15 (s Itl15)) tr) (+ (z (l15 Itl15) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (z (l15 it) tr) xInt)
                  (Sub it (nl15 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var y at location l15
      (forall ((xInt Int)(Itl15 Nat))
         (=>
            (and
               (<= (y (l15 zero) tr) xInt)
               (< xInt (y (l15 (nl15 tr)) tr))
               (= (y (l15 (s Itl15)) tr) (+ (y (l15 Itl15) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (y (l15 it) tr) xInt)
                  (Sub it (nl15 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var i at location l15
      (forall ((xInt Int)(Itl15 Nat))
         (=>
            (and
               (<= (i (l15 zero) tr) xInt)
               (< xInt (i (l15 (nl15 tr)) tr))
               (= (i (l15 (s Itl15)) tr) (+ (i (l15 Itl15) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (i (l15 it) tr) xInt)
                  (Sub it (nl15 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var x at location l15
      (forall ((xInt Int)(Itl15 Nat))
         (=>
            (and
               (<= (x (l15 zero) tr) xInt)
               (< xInt (x (l15 (nl15 tr)) tr))
               (= (x (l15 (s Itl15)) tr) (+ (x (l15 Itl15) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (x (l15 it) tr) xInt)
                  (Sub it (nl15 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var z at location l23
      (forall ((xInt Int)(Itl23 Nat))
         (=>
            (and
               (<= (z (l23 zero) tr) xInt)
               (< xInt (z (l23 (nl23 tr)) tr))
               (= (z (l23 (s Itl23)) tr) (+ (z (l23 Itl23) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (z (l23 it) tr) xInt)
                  (Sub it (nl23 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var y at location l23
      (forall ((xInt Int)(Itl23 Nat))
         (=>
            (and
               (<= (y (l23 zero) tr) xInt)
               (< xInt (y (l23 (nl23 tr)) tr))
               (= (y (l23 (s Itl23)) tr) (+ (y (l23 Itl23) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (y (l23 it) tr) xInt)
                  (Sub it (nl23 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var i at location l23
      (forall ((xInt Int)(Itl23 Nat))
         (=>
            (and
               (<= (i (l23 zero) tr) xInt)
               (< xInt (i (l23 (nl23 tr)) tr))
               (= (i (l23 (s Itl23)) tr) (+ (i (l23 Itl23) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (i (l23 it) tr) xInt)
                  (Sub it (nl23 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Lemma: Intermediate value for var x at location l23
      (forall ((xInt Int)(Itl23 Nat))
         (=>
            (and
               (<= (x (l23 zero) tr) xInt)
               (< xInt (x (l23 (nl23 tr)) tr))
               (= (x (l23 (s Itl23)) tr) (+ (x (l23 Itl23) tr) 1))
            )
            (exists ((it Nat))
               (and
                  (= (x (l23 it) tr) xInt)
                  (Sub it (nl23 tr))
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl15 Nat))
         (=>
            (and
               (Sub (s Itl15) (nl15 tr))
               (= (z (l15 (s Itl15)) tr) (+ (z (l15 Itl15) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (z (l15 it1) tr) (z (l15 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl15 Nat))
         (=>
            (and
               (Sub (s Itl15) (nl15 tr))
               (= (y (l15 (s Itl15)) tr) (+ (y (l15 Itl15) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (y (l15 it1) tr) (y (l15 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl15 Nat))
         (=>
            (and
               (Sub (s Itl15) (nl15 tr))
               (= (i (l15 (s Itl15)) tr) (+ (i (l15 Itl15) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (i (l15 it1) tr) (i (l15 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl15 Nat))
         (=>
            (and
               (Sub (s Itl15) (nl15 tr))
               (= (x (l15 (s Itl15)) tr) (+ (x (l15 Itl15) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (x (l15 it1) tr) (x (l15 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl23 Nat))
         (=>
            (and
               (Sub (s Itl23) (nl23 tr))
               (= (z (l23 (s Itl23)) tr) (+ (z (l23 Itl23) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (z (l23 it1) tr) (z (l23 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl23 Nat))
         (=>
            (and
               (Sub (s Itl23) (nl23 tr))
               (= (y (l23 (s Itl23)) tr) (+ (y (l23 Itl23) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (y (l23 it1) tr) (y (l23 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl23 Nat))
         (=>
            (and
               (Sub (s Itl23) (nl23 tr))
               (= (i (l23 (s Itl23)) tr) (+ (i (l23 Itl23) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (i (l23 it1) tr) (i (l23 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Injectivitiy of Iterators Lemma
      (forall ((Itl23 Nat))
         (=>
            (and
               (Sub (s Itl23) (nl23 tr))
               (= (x (l23 (s Itl23)) tr) (+ (x (l23 Itl23) tr) 1))
            )
            (forall ((it1 Nat)(it2 Nat))
               (=>
                  (= (x (l23 it1) tr) (x (l23 it2) tr))
                  (= it1 it2)
               )
            )
         )
      )
   )
)

(assert
   ;Lemma: Var z at loop l15 has same values on both traces
   (=>
      (and
         (= (z (l15 zero) t1) (z (l15 zero) t2))
         (forall ((Itl15 Nat))
            (=>
               (= (z (l15 Itl15) t1) (z (l15 Itl15) t2))
               (= (z (l15 (s Itl15)) t1) (z (l15 (s Itl15)) t2))
            )
         )
      )
      (forall ((Itl15 Nat))
         (= (z (l15 Itl15) t1) (z (l15 Itl15) t2))
      )
   )
)

(assert
   ;Lemma: Var y at loop l15 has same values on both traces
   (=>
      (and
         (= (y (l15 zero) t1) (y (l15 zero) t2))
         (forall ((Itl15 Nat))
            (=>
               (= (y (l15 Itl15) t1) (y (l15 Itl15) t2))
               (= (y (l15 (s Itl15)) t1) (y (l15 (s Itl15)) t2))
            )
         )
      )
      (forall ((Itl15 Nat))
         (= (y (l15 Itl15) t1) (y (l15 Itl15) t2))
      )
   )
)

(assert
   ;Lemma: Var i at loop l15 has same values on both traces
   (=>
      (and
         (= (i (l15 zero) t1) (i (l15 zero) t2))
         (forall ((Itl15 Nat))
            (=>
               (= (i (l15 Itl15) t1) (i (l15 Itl15) t2))
               (= (i (l15 (s Itl15)) t1) (i (l15 (s Itl15)) t2))
            )
         )
      )
      (forall ((Itl15 Nat))
         (= (i (l15 Itl15) t1) (i (l15 Itl15) t2))
      )
   )
)

(assert
   ;Lemma: Var x at loop l15 has same values on both traces
   (=>
      (and
         (= (x (l15 zero) t1) (x (l15 zero) t2))
         (forall ((Itl15 Nat))
            (=>
               (= (x (l15 Itl15) t1) (x (l15 Itl15) t2))
               (= (x (l15 (s Itl15)) t1) (x (l15 (s Itl15)) t2))
            )
         )
      )
      (forall ((Itl15 Nat))
         (= (x (l15 Itl15) t1) (x (l15 Itl15) t2))
      )
   )
)

(assert
   ;Lemma: Var z at loop l23 has same values on both traces
   (=>
      (and
         (= (z (l23 zero) t1) (z (l23 zero) t2))
         (forall ((Itl23 Nat))
            (=>
               (= (z (l23 Itl23) t1) (z (l23 Itl23) t2))
               (= (z (l23 (s Itl23)) t1) (z (l23 (s Itl23)) t2))
            )
         )
      )
      (forall ((Itl23 Nat))
         (= (z (l23 Itl23) t1) (z (l23 Itl23) t2))
      )
   )
)

(assert
   ;Lemma: Var y at loop l23 has same values on both traces
   (=>
      (and
         (= (y (l23 zero) t1) (y (l23 zero) t2))
         (forall ((Itl23 Nat))
            (=>
               (= (y (l23 Itl23) t1) (y (l23 Itl23) t2))
               (= (y (l23 (s Itl23)) t1) (y (l23 (s Itl23)) t2))
            )
         )
      )
      (forall ((Itl23 Nat))
         (= (y (l23 Itl23) t1) (y (l23 Itl23) t2))
      )
   )
)

(assert
   ;Lemma: Var i at loop l23 has same values on both traces
   (=>
      (and
         (= (i (l23 zero) t1) (i (l23 zero) t2))
         (forall ((Itl23 Nat))
            (=>
               (= (i (l23 Itl23) t1) (i (l23 Itl23) t2))
               (= (i (l23 (s Itl23)) t1) (i (l23 (s Itl23)) t2))
            )
         )
      )
      (forall ((Itl23 Nat))
         (= (i (l23 Itl23) t1) (i (l23 Itl23) t2))
      )
   )
)

(assert
   ;Lemma: Var x at loop l23 has same values on both traces
   (=>
      (and
         (= (x (l23 zero) t1) (x (l23 zero) t2))
         (forall ((Itl23 Nat))
            (=>
               (= (x (l23 Itl23) t1) (x (l23 Itl23) t2))
               (= (x (l23 (s Itl23)) t1) (x (l23 (s Itl23)) t2))
            )
         )
      )
      (forall ((Itl23 Nat))
         (= (x (l23 Itl23) t1) (x (l23 Itl23) t2))
      )
   )
)

(assert
   ;Lemma: If nl15(t2) has same properties as nl15(t1), then nl15(t2)=nl15(t1) (for loop at l15)
   (=>
      (and
         (forall ((Itl15 Nat))
            (=>
               (Sub Itl15 (nl15 t2))
               (< (i (l15 Itl15) t1) (alength t1))
            )
         )
         (not
            (< (i (l15 (nl15 t2)) t1) (alength t1))
         )
      )
      (= (nl15 t2) (nl15 t1))
   )
)

(assert
   ;Lemma: If nl23(t2) has same properties as nl23(t1), then nl23(t2)=nl23(t1) (for loop at l23)
   (=>
      (and
         (forall ((Itl23 Nat))
            (=>
               (Sub Itl23 (nl23 t2))
               (< (i (l23 Itl23) t1) (blength t1))
            )
         )
         (not
            (< (i (l23 (nl23 t2)) t1) (blength t1))
         )
      )
      (= (nl23 t2) (nl23 t1))
   )
)

(assert
   ;Lemma: Equality preservation over traces for var z at location l15
   (forall ((itR Nat))
      (=>
         (and
            (= (z (l15 zero) t1) (z (l15 zero) t2))
            (forall ((Itl15 Nat))
               (=>
                  (and
                     (Sub Itl15 itR)
                     (= (z (l15 Itl15) t1) (z (l15 Itl15) t2))
                  )
                  (= (z (l15 (s Itl15)) t1) (z (l15 (s Itl15)) t2))
               )
            )
         )
         (= (z (l15 itR) t1) (z (l15 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var y at location l15
   (forall ((itR Nat))
      (=>
         (and
            (= (y (l15 zero) t1) (y (l15 zero) t2))
            (forall ((Itl15 Nat))
               (=>
                  (and
                     (Sub Itl15 itR)
                     (= (y (l15 Itl15) t1) (y (l15 Itl15) t2))
                  )
                  (= (y (l15 (s Itl15)) t1) (y (l15 (s Itl15)) t2))
               )
            )
         )
         (= (y (l15 itR) t1) (y (l15 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l15
   (forall ((itR Nat))
      (=>
         (and
            (= (i (l15 zero) t1) (i (l15 zero) t2))
            (forall ((Itl15 Nat))
               (=>
                  (and
                     (Sub Itl15 itR)
                     (= (i (l15 Itl15) t1) (i (l15 Itl15) t2))
                  )
                  (= (i (l15 (s Itl15)) t1) (i (l15 (s Itl15)) t2))
               )
            )
         )
         (= (i (l15 itR) t1) (i (l15 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l15
   (forall ((itR Nat))
      (=>
         (and
            (= (x (l15 zero) t1) (x (l15 zero) t2))
            (forall ((Itl15 Nat))
               (=>
                  (and
                     (Sub Itl15 itR)
                     (= (x (l15 Itl15) t1) (x (l15 Itl15) t2))
                  )
                  (= (x (l15 (s Itl15)) t1) (x (l15 (s Itl15)) t2))
               )
            )
         )
         (= (x (l15 itR) t1) (x (l15 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var z at location l15
   (forall ((itL Nat))
      (=>
         (and
            (= (z (l15 itL) t1) (z (l15 itL) t2))
            (forall ((Itl15 Nat))
               (=>
                  (and
                     (Sub itL (s Itl15))
                     (Sub Itl15 (nl15 t1))
                     (= (z (l15 Itl15) t1) (z (l15 Itl15) t2))
                  )
                  (= (z (l15 (s Itl15)) t1) (z (l15 (s Itl15)) t2))
               )
            )
            (= (l15 (nl15 t1)) (l15 (nl15 t2)))
         )
         (= (z (l15 (nl15 t1)) t1) (z (l15 (nl15 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var y at location l15
   (forall ((itL Nat))
      (=>
         (and
            (= (y (l15 itL) t1) (y (l15 itL) t2))
            (forall ((Itl15 Nat))
               (=>
                  (and
                     (Sub itL (s Itl15))
                     (Sub Itl15 (nl15 t1))
                     (= (y (l15 Itl15) t1) (y (l15 Itl15) t2))
                  )
                  (= (y (l15 (s Itl15)) t1) (y (l15 (s Itl15)) t2))
               )
            )
            (= (l15 (nl15 t1)) (l15 (nl15 t2)))
         )
         (= (y (l15 (nl15 t1)) t1) (y (l15 (nl15 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l15
   (forall ((itL Nat))
      (=>
         (and
            (= (i (l15 itL) t1) (i (l15 itL) t2))
            (forall ((Itl15 Nat))
               (=>
                  (and
                     (Sub itL (s Itl15))
                     (Sub Itl15 (nl15 t1))
                     (= (i (l15 Itl15) t1) (i (l15 Itl15) t2))
                  )
                  (= (i (l15 (s Itl15)) t1) (i (l15 (s Itl15)) t2))
               )
            )
            (= (l15 (nl15 t1)) (l15 (nl15 t2)))
         )
         (= (i (l15 (nl15 t1)) t1) (i (l15 (nl15 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l15
   (forall ((itL Nat))
      (=>
         (and
            (= (x (l15 itL) t1) (x (l15 itL) t2))
            (forall ((Itl15 Nat))
               (=>
                  (and
                     (Sub itL (s Itl15))
                     (Sub Itl15 (nl15 t1))
                     (= (x (l15 Itl15) t1) (x (l15 Itl15) t2))
                  )
                  (= (x (l15 (s Itl15)) t1) (x (l15 (s Itl15)) t2))
               )
            )
            (= (l15 (nl15 t1)) (l15 (nl15 t2)))
         )
         (= (x (l15 (nl15 t1)) t1) (x (l15 (nl15 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var z at location l23
   (forall ((itR Nat))
      (=>
         (and
            (= (z (l23 zero) t1) (z (l23 zero) t2))
            (forall ((Itl23 Nat))
               (=>
                  (and
                     (Sub Itl23 itR)
                     (= (z (l23 Itl23) t1) (z (l23 Itl23) t2))
                  )
                  (= (z (l23 (s Itl23)) t1) (z (l23 (s Itl23)) t2))
               )
            )
         )
         (= (z (l23 itR) t1) (z (l23 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var y at location l23
   (forall ((itR Nat))
      (=>
         (and
            (= (y (l23 zero) t1) (y (l23 zero) t2))
            (forall ((Itl23 Nat))
               (=>
                  (and
                     (Sub Itl23 itR)
                     (= (y (l23 Itl23) t1) (y (l23 Itl23) t2))
                  )
                  (= (y (l23 (s Itl23)) t1) (y (l23 (s Itl23)) t2))
               )
            )
         )
         (= (y (l23 itR) t1) (y (l23 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l23
   (forall ((itR Nat))
      (=>
         (and
            (= (i (l23 zero) t1) (i (l23 zero) t2))
            (forall ((Itl23 Nat))
               (=>
                  (and
                     (Sub Itl23 itR)
                     (= (i (l23 Itl23) t1) (i (l23 Itl23) t2))
                  )
                  (= (i (l23 (s Itl23)) t1) (i (l23 (s Itl23)) t2))
               )
            )
         )
         (= (i (l23 itR) t1) (i (l23 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l23
   (forall ((itR Nat))
      (=>
         (and
            (= (x (l23 zero) t1) (x (l23 zero) t2))
            (forall ((Itl23 Nat))
               (=>
                  (and
                     (Sub Itl23 itR)
                     (= (x (l23 Itl23) t1) (x (l23 Itl23) t2))
                  )
                  (= (x (l23 (s Itl23)) t1) (x (l23 (s Itl23)) t2))
               )
            )
         )
         (= (x (l23 itR) t1) (x (l23 itR) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var z at location l23
   (forall ((itL Nat))
      (=>
         (and
            (= (z (l23 itL) t1) (z (l23 itL) t2))
            (forall ((Itl23 Nat))
               (=>
                  (and
                     (Sub itL (s Itl23))
                     (Sub Itl23 (nl23 t1))
                     (= (z (l23 Itl23) t1) (z (l23 Itl23) t2))
                  )
                  (= (z (l23 (s Itl23)) t1) (z (l23 (s Itl23)) t2))
               )
            )
            (= (l23 (nl23 t1)) (l23 (nl23 t2)))
         )
         (= (z (l23 (nl23 t1)) t1) (z (l23 (nl23 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var y at location l23
   (forall ((itL Nat))
      (=>
         (and
            (= (y (l23 itL) t1) (y (l23 itL) t2))
            (forall ((Itl23 Nat))
               (=>
                  (and
                     (Sub itL (s Itl23))
                     (Sub Itl23 (nl23 t1))
                     (= (y (l23 Itl23) t1) (y (l23 Itl23) t2))
                  )
                  (= (y (l23 (s Itl23)) t1) (y (l23 (s Itl23)) t2))
               )
            )
            (= (l23 (nl23 t1)) (l23 (nl23 t2)))
         )
         (= (y (l23 (nl23 t1)) t1) (y (l23 (nl23 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var i at location l23
   (forall ((itL Nat))
      (=>
         (and
            (= (i (l23 itL) t1) (i (l23 itL) t2))
            (forall ((Itl23 Nat))
               (=>
                  (and
                     (Sub itL (s Itl23))
                     (Sub Itl23 (nl23 t1))
                     (= (i (l23 Itl23) t1) (i (l23 Itl23) t2))
                  )
                  (= (i (l23 (s Itl23)) t1) (i (l23 (s Itl23)) t2))
               )
            )
            (= (l23 (nl23 t1)) (l23 (nl23 t2)))
         )
         (= (i (l23 (nl23 t1)) t1) (i (l23 (nl23 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Equality preservation over traces for var x at location l23
   (forall ((itL Nat))
      (=>
         (and
            (= (x (l23 itL) t1) (x (l23 itL) t2))
            (forall ((Itl23 Nat))
               (=>
                  (and
                     (Sub itL (s Itl23))
                     (Sub Itl23 (nl23 t1))
                     (= (x (l23 Itl23) t1) (x (l23 Itl23) t2))
                  )
                  (= (x (l23 (s Itl23)) t1) (x (l23 (s Itl23)) t2))
               )
            )
            (= (l23 (nl23 t1)) (l23 (nl23 t2)))
         )
         (= (x (l23 (nl23 t1)) t1) (x (l23 (nl23 t1)) t2))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var z at location l15
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (z (l15 zero) t1) (z (l15 zero) t2))
            (forall ((tr3 Trace)(Itl15 Nat))
               (= (z (l15 (s Itl15)) tr3) (+ (z (l15 Itl15) tr3) 1))
            )
         )
         (< (z (l15 it1) tr) (z (l15 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var y at location l15
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (y (l15 zero) t1) (y (l15 zero) t2))
            (forall ((tr3 Trace)(Itl15 Nat))
               (= (y (l15 (s Itl15)) tr3) (+ (y (l15 Itl15) tr3) 1))
            )
         )
         (< (y (l15 it1) tr) (y (l15 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var i at location l15
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (i (l15 zero) t1) (i (l15 zero) t2))
            (forall ((tr3 Trace)(Itl15 Nat))
               (= (i (l15 (s Itl15)) tr3) (+ (i (l15 Itl15) tr3) 1))
            )
         )
         (< (i (l15 it1) tr) (i (l15 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var x at location l15
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (x (l15 zero) t1) (x (l15 zero) t2))
            (forall ((tr3 Trace)(Itl15 Nat))
               (= (x (l15 (s Itl15)) tr3) (+ (x (l15 Itl15) tr3) 1))
            )
         )
         (< (x (l15 it1) tr) (x (l15 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var z at location l23
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (z (l23 zero) t1) (z (l23 zero) t2))
            (forall ((tr3 Trace)(Itl23 Nat))
               (= (z (l23 (s Itl23)) tr3) (+ (z (l23 Itl23) tr3) 1))
            )
         )
         (< (z (l23 it1) tr) (z (l23 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var y at location l23
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (y (l23 zero) t1) (y (l23 zero) t2))
            (forall ((tr3 Trace)(Itl23 Nat))
               (= (y (l23 (s Itl23)) tr3) (+ (y (l23 Itl23) tr3) 1))
            )
         )
         (< (y (l23 it1) tr) (y (l23 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var i at location l23
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (i (l23 zero) t1) (i (l23 zero) t2))
            (forall ((tr3 Trace)(Itl23 Nat))
               (= (i (l23 (s Itl23)) tr3) (+ (i (l23 Itl23) tr3) 1))
            )
         )
         (< (i (l23 it1) tr) (i (l23 it2) tr))
      )
   )
)

(assert
   ;Lemma: Synchronization of orderings for var x at location l23
   (forall ((tr Trace)(it1 Nat)(it2 Nat))
      (=>
         (and
            (Sub it1 it2)
            (= (x (l23 zero) t1) (x (l23 zero) t2))
            (forall ((tr3 Trace)(Itl23 Nat))
               (= (x (l23 (s Itl23)) tr3) (+ (x (l23 Itl23) tr3) 1))
            )
         )
         (< (x (l23 it1) tr) (x (l23 it2) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Static analysis lemma for var z at location l15
      (forall ((Itl15 Nat))
         (= (z (l15 Itl15) tr) (z (l15 zero) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Static analysis lemma for var y at location l15
      (forall ((Itl15 Nat))
         (= (y (l15 Itl15) tr) (y (l15 zero) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Static analysis lemma for var z at location l23
      (forall ((Itl23 Nat))
         (= (z (l23 Itl23) tr) (z (l23 zero) tr))
      )
   )
)

(assert
   (forall ((tr Trace))
      ;Static analysis lemma for var x at location l23
      (forall ((Itl23 Nat))
         (= (x (l23 Itl23) tr) (x (l23 zero) tr))
      )
   )
)

(assert
   ;Theory axiom: forall x y z. (x + y) + z) = (x + z) + y
   (forall ((xInt Int)(yInt Int)(zInt Int))
      (= (+ (+ xInt yInt) zInt) (+ (+ xInt zInt) yInt))
   )
)

; negated conjecture
(assert
   (not
      (=>
         (and
            (forall ((j Int))
               (and
                  (= (a j t1) (a j t2))
                  (= (b j t1) (b j t2))
               )
            )
            (= (alength t1) (alength t2))
            (= (blength t1) (blength t2))
            (= (k1 t1) 1)
            (= (k1 t2) 0)
            (= (k2 t1) 0)
            (= (k2 t2) 1)
         )
         (= (z main_end t1) (z main_end t2))
      )
   )
)

(check-sat)

(exit)
